GNU bug report logs - #38546
Update Julia to 1.3.1.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: nixo <anothersms@HIDDEN>; Keywords: patch; dated Mon, 9 Dec 2019 13:58:02 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.
Changed bug title to 'Update Julia to 1.3.1.' from '[PATCH 0/3] Julia: fix package build and add julia-xyz' Request was from zimoun <zimon.toutoune@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 11 Feb 2020 15:25:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 11 10:25:03 2020
Received: from localhost ([127.0.0.1]:57372 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1j1XPK-0002wa-M4
	for submit <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:25:02 -0500
Received: from mail-wr1-f65.google.com ([209.85.221.65]:45086)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1j1XPI-0002w0-9l
 for 38546 <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:25:01 -0500
Received: by mail-wr1-f65.google.com with SMTP id g3so11775831wrs.12
 for <38546 <at> debbugs.gnu.org>; Tue, 11 Feb 2020 07:25:00 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=bQkTIijs3Nj7WrGGYpuuBi+/IYPbIGqxN6+wymw8rtY=;
 b=OcBkhmkhBXiXegtao0cVBcoCqAHY5L40poNQTOdlLlLzcWO+Eq9Lp0z8nRSV8YU1SL
 MNdGaXf2Eu1YKOTiGLOQ6txwOscH/F+khtNQK+p41qgDMjSxCKsQAr0qHgr4eJW2ATZs
 AiBDZpEaoqs0e+cqmuFsEaI4typ1zAQrOLBZ+Z9PCHjIW2e7q9nJ+RFLKJzKVRiC7LIf
 NcMD3uSuopGY1K1ftJydeF0YEKeTiNQW9FPTC+dG067vfgUgTdgATsBxT4ZUetmK+/W8
 dvNPEVxSA8NVG2iZoo5Z+pY8g3Clh0nBRS1GMNXfohJTj+wFM83BFAt7vYQUStNSt2w3
 c5zw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=bQkTIijs3Nj7WrGGYpuuBi+/IYPbIGqxN6+wymw8rtY=;
 b=DyhaMEc0CnBKlSXzMfeSPCRZttYGr7mnp8r8WVWQWtTTyCFof6Ny3fpGlZx9sOARXI
 N4315Ae6TU4B4RrJF4XJx7mTTbuav6ldJNUgpQInuMeNIScjPUcoKqmMg2CdmWYNPK6P
 WwfbvWgnW89+pUmqEObXJOSdnzdWPeVCqEZgmIWRkVPZp+OOvIgPmsiSr4w9uUAMh5i3
 lPWF+AKvNb4U7BMOrwBmHswKti3+7HEzxpIYi26XC0to7tMqyZH8bZx9jbs8eE5Bncys
 jmgy827qs6J35gaP6BYP8+YEBD3paSSfMtc58Ql/qz59bz4mBIdo3iK87omB1TzfhxV7
 Jy+Q==
X-Gm-Message-State: APjAAAXdpQd8KsZ0ywsRnWlTQS7y2fXYtxDzJoZBy9YpvhL7AACMSYK0
 Ft7RlgvxKHACITTTOfkzKcYQZJcTtf8=
X-Google-Smtp-Source: APXvYqwUxrJjZRYPWAfKHV52E2T8TFOEE9U1WhrxPdIiB3jLE65sGmIk8yQBA5F8dnS9L3BO3uJz/w==
X-Received: by 2002:adf:e906:: with SMTP id f6mr8971219wrm.258.1581434694040; 
 Tue, 11 Feb 2020 07:24:54 -0800 (PST)
Received: from guixSD ([95.232.154.110])
 by smtp.gmail.com with ESMTPSA id c13sm5929935wrx.9.2020.02.11.07.24.53
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Feb 2020 07:24:53 -0800 (PST)
From: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
In-Reply-To: <CAJ3okZ3uhRfg8Z4upVhkeACbp8GBty+oiBjoGNEiOKtaGKuvpQ@HIDDEN>
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
 <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
 <CAJ3okZ38fzeaLjGjQkNq3EYv7JSxEpsn9zgnnyt3E9WaQQZxSQ@HIDDEN>
 <87lfp9dusm.fsf@HIDDEN>
 <CAJ3okZ3uhRfg8Z4upVhkeACbp8GBty+oiBjoGNEiOKtaGKuvpQ@HIDDEN>
Date: Tue, 11 Feb 2020 16:24:52 +0100
Message-ID: <87imkddu4b.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

zimoun <zimon.toutoune@HIDDEN> writes:

Hi

> On Tue, 11 Feb 2020 at 16:10, Nicol=C3=B2 Balzarotti <anothersms@HIDDEN=
m> wrote:
>
>> > 1.
>> >> Do you have a special motivation to rename 'llvm-patch' to 'julia-pat=
ch'?
>> >> (I agree, it is better :-))
>> >
>> Yes, because now it's not only used by llvm-julia but also by the new
>> libunwind-julia.  So calling llvm-patch a function that takes a patch
>> from the julia repo and that is applied to a "julia module" is measleadi=
ng.
>
> Ok.
>
>
>> > 2.
>> >> Well, only 2 inputs are missing. Do you think it is affordable to pack
>> >> them and so remove the commentary?
>> >>
>> >> --8<---------------cut here---------------start------------->8---
>> >> ;; FIXME: The following inputs are downloaded from upstream to allow =
us
>> >> ;; to use the lightweight Julia release tarball.  Ideally, these inpu=
ts
>> >> ;; would eventually be replaced with proper Guix packages.
>> >> ;; Find dependencies versions here:
>> >> ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Vers=
ions.make
>> >> --8<---------------cut here---------------end--------------->8---
>>
>> I indeed tried.  The main problem is that in the Makefile there's no
>> USE_SYSTEM_{OBJCONV/LIBWHICH}, and I didn't want to mess with the it.
>> But yes, I think I could at least try again.
>
> Let me check how it will be crawled by SWH to be sure that Guix will
> be able to still build Julia 1.3 even if GitHub does not exist
> anymore.
> And I am in favour to let these 2 inputs.
>
>
>> > 3.
>> >> Otherwise, there is some issues about indentation -- I think you use
>> >> Emacs, so check that '.dir-locals.el' is correctly setup -- double
>> >> space for sentences in description,
>> >> 'patch/julia-SOURCE_DATE_EPOCH-mtime.patch' should be added with the
>> >> same commit that "Update", etc.
>> >> I have half-corrected so I can send you these 2 v2-patches if you wan=
t to. :-)
>> >
>> If you already fixed them, yes please send a v2 patch and I'll continue
>> working from there.
>
> Stay tuned. :-)
> I try to send it today...
>
Don't worry, I'm still working on my PhD thesis so my spare time until
the end of the week is low :D
>
>> Fine for me, do we need also to debug a broken test right?
>
> I do not know if the test are broken. I am not able to run them on my
> desktop machine. Not enough memory.
>
Ok, so I'll run tests a few times on my server then
>
> Cheers,
> simon

Thanks, Nicol=C3=B2




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 11 Feb 2020 15:19:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 11 10:19:53 2020
Received: from localhost ([127.0.0.1]:57366 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1j1XKL-0002nt-0f
	for submit <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:19:53 -0500
Received: from mail-qk1-f176.google.com ([209.85.222.176]:33829)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1j1XKH-0002nf-6j
 for 38546 <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:19:51 -0500
Received: by mail-qk1-f176.google.com with SMTP id c20so4403832qkm.1
 for <38546 <at> debbugs.gnu.org>; Tue, 11 Feb 2020 07:19:49 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=m1bnNKjoW3sfzzPq/YOOw0m/c5wYybBYhyDwDkdVpL8=;
 b=loFa4ShS4GImIiic8EBHXEiqHKaDnJ7q+g+IlIBn+/o+kb0zEkwMweu83Qns+nWDi2
 L+b0qcUgNU0qUdP+CxLHn6QRgKZWvWO+sZ621qN03N9g83q3QK0/iB9y24jWQ+Z7rnG+
 /PJJ1wdoLIUx8UpZP6xT3QITZHEXZGlQW43DBqjI43AMdisWVidnGesxgcqNCiBRkai1
 6iF+ajD6MzACLGN94qKdDKwXgYvw1GSATHEKcylXmRRWNIuBZbZ8I05f+7ewVutyeSY4
 ayvu/8R7h6YLngiv+QdOoXM8e0IVX3uFTujoAQ4uTIw+ZHj+b2F2xPrvtepDVkxfAwUh
 1i6A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=m1bnNKjoW3sfzzPq/YOOw0m/c5wYybBYhyDwDkdVpL8=;
 b=omKlb7z9TfFt2Ojq060ehbJbK0o85JcOzbOAtwZRtVkI+JHowY5doYD7tC/FjiXe/8
 XQow2G0T/1LIxz8hgVdgwg64C3+9BpG6ud8ppa26lQ5fOQyu0H1dnvMFFSj5CYof8Y4d
 KZdMfjjOHT/U29jEJ8BVsLZiHxC9McgM6drq7a4w9wT8TTCfe45kFLQcexsicaBlXYsO
 WRQRyGpwEDk+PuKzi6GW2H/FR0j5FOl24HNYOQ1BmlrzBTcQ0Jys6P5E8sTYZ601X3MR
 MfleExD/6Ay43Zevg+I8OvvWoRZEPd7hiqAgkaF9893pehdZzPPk+J0iSC9Jws4vQ71Z
 cZhQ==
X-Gm-Message-State: APjAAAXso71x7q7OmQNvcJLntuwg6I26OcpWWROs9bomF6fyKoNopzxR
 VJGGQuV/+Q1WP9bbkZLBXPuNrMKBOZPDs8YbrWI=
X-Google-Smtp-Source: APXvYqwwUP9wZbzVPItK4ff61f7L016SVnnsufsWvNxvgnYrKUIYmmOHT/FeUTwYaaWB9SSdm1H80i/btn990NItNc8=
X-Received: by 2002:a37:ac17:: with SMTP id e23mr6619717qkm.80.1581434383769; 
 Tue, 11 Feb 2020 07:19:43 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
 <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
 <CAJ3okZ38fzeaLjGjQkNq3EYv7JSxEpsn9zgnnyt3E9WaQQZxSQ@HIDDEN>
 <87lfp9dusm.fsf@HIDDEN>
In-Reply-To: <87lfp9dusm.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Tue, 11 Feb 2020 16:19:32 +0100
Message-ID: <CAJ3okZ3uhRfg8Z4upVhkeACbp8GBty+oiBjoGNEiOKtaGKuvpQ@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Tue, 11 Feb 2020 at 16:10, Nicol=C3=B2 Balzarotti <anothersms@HIDDEN>=
 wrote:

> > 1.
> >> Do you have a special motivation to rename 'llvm-patch' to 'julia-patc=
h'?
> >> (I agree, it is better :-))
> >
> Yes, because now it's not only used by llvm-julia but also by the new
> libunwind-julia.  So calling llvm-patch a function that takes a patch
> from the julia repo and that is applied to a "julia module" is measleadin=
g.

Ok.


> > 2.
> >> Well, only 2 inputs are missing. Do you think it is affordable to pack
> >> them and so remove the commentary?
> >>
> >> --8<---------------cut here---------------start------------->8---
> >> ;; FIXME: The following inputs are downloaded from upstream to allow u=
s
> >> ;; to use the lightweight Julia release tarball.  Ideally, these input=
s
> >> ;; would eventually be replaced with proper Guix packages.
> >> ;; Find dependencies versions here:
> >> ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Versi=
ons.make
> >> --8<---------------cut here---------------end--------------->8---
>
> I indeed tried.  The main problem is that in the Makefile there's no
> USE_SYSTEM_{OBJCONV/LIBWHICH}, and I didn't want to mess with the it.
> But yes, I think I could at least try again.

Let me check how it will be crawled by SWH to be sure that Guix will
be able to still build Julia 1.3 even if GitHub does not exist
anymore.
And I am in favour to let these 2 inputs.


> > 3.
> >> Otherwise, there is some issues about indentation -- I think you use
> >> Emacs, so check that '.dir-locals.el' is correctly setup -- double
> >> space for sentences in description,
> >> 'patch/julia-SOURCE_DATE_EPOCH-mtime.patch' should be added with the
> >> same commit that "Update", etc.
> >> I have half-corrected so I can send you these 2 v2-patches if you want=
 to. :-)
> >
> If you already fixed them, yes please send a v2 patch and I'll continue
> working from there.

Stay tuned. :-)
I try to send it today...


> Fine for me, do we need also to debug a broken test right?

I do not know if the test are broken. I am not able to run them on my
desktop machine. Not enough memory.


Cheers,
simon




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 11 Feb 2020 15:10:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 11 10:10:28 2020
Received: from localhost ([127.0.0.1]:57357 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1j1XBD-0002ZR-M4
	for submit <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:10:27 -0500
Received: from mail-wm1-f48.google.com ([209.85.128.48]:37547)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1j1XBC-0002ZE-0w
 for 38546 <at> debbugs.gnu.org; Tue, 11 Feb 2020 10:10:26 -0500
Received: by mail-wm1-f48.google.com with SMTP id a6so4001332wme.2
 for <38546 <at> debbugs.gnu.org>; Tue, 11 Feb 2020 07:10:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=9ACTzDq4bGdSIw+NsLr8gCV40/wUW9hFmpGyh/yN2tg=;
 b=jJLnrDTEU4gVr3kTQCFidXmeFV0K/EcHVBzd12yahO8gUkw5l7AVK2pcdlLdqRH84E
 gVcFgqukX//TBdCZOgOCyNO3bsNM5LZfdJJ+FhfE8gpg97th1a8u2CSm+/XHUtxRw8F7
 GJ/awDTb7ybAbiA89AiuirBsCySZNlKUuw/XAqBDnDEt3DdWwqSIrRYecuzgd5hEceZY
 RH/fwl1qIvR0ZzRZ/B+UELYnIrXVCPif2bNM7ZbNgcuMpLliC2qus66/5qOzLU9SqQPH
 8sm2lt4OS3Tg8GIkqzSmW7UQ6AM3HJIk+LQrX0chItR4bMa4zUTyBDuGw4ptab9rl2NC
 E00Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=9ACTzDq4bGdSIw+NsLr8gCV40/wUW9hFmpGyh/yN2tg=;
 b=VAC91fYVlTvM+HLb6xMbMdAVMOvPF8gSEGEOzbpzjFMO0IOaVken3mDN56fFpu8zMB
 8KEw7jtP5h9xx9DHIVh/c6hosqiBkdxd1Fo9eCnf206GcUx8oyYx51ywy9ElHNpNrzH6
 pTXviAuwxoMFmiJN2wR+kXjohWmyEs3ElPKXiqHKhpkRdh+tUeJ2L7/XLumcpKt9Lnxh
 s9Vdh++gKUIAu+4gSTSslEmM+XuBHee4jhClS9brOLHSeKBEf9ElObcf+HAMeakKnAz/
 YsQ/YZNKjGVNbTQFk1bV+4nJj8HyQIJ/c+IIViXl2MxfvDZE68QgU9ypRTdETQ9LgXox
 MMTg==
X-Gm-Message-State: APjAAAXzuREAlvG7rjI5srXGdNJMG76EkQttd0plR1AYWdivSHQUzc3p
 00w7O1zQ9eS4+MECWLqafe8A9YXDrUE=
X-Google-Smtp-Source: APXvYqweQNLcgsItD6wLh4QwV/ketGRGEMoruorMj5QZb5CeU4v7lNFkbiuCd4CgqGcVIstOSpxh+A==
X-Received: by 2002:a05:600c:211:: with SMTP id
 17mr6039836wmi.60.1581433819850; 
 Tue, 11 Feb 2020 07:10:19 -0800 (PST)
Received: from guixSD ([95.232.154.110])
 by smtp.gmail.com with ESMTPSA id w19sm3956776wmc.22.2020.02.11.07.10.18
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 11 Feb 2020 07:10:18 -0800 (PST)
From: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
In-Reply-To: <CAJ3okZ38fzeaLjGjQkNq3EYv7JSxEpsn9zgnnyt3E9WaQQZxSQ@HIDDEN>
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
 <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
 <CAJ3okZ38fzeaLjGjQkNq3EYv7JSxEpsn9zgnnyt3E9WaQQZxSQ@HIDDEN>
Date: Tue, 11 Feb 2020 16:10:17 +0100
Message-ID: <87lfp9dusm.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

zimoun <zimon.toutoune@HIDDEN> writes:

Hi,
> Hi Nicol=C3=B3,
>
> I have seen your message on IRC.
> Cool for the release 1.4.
>
>
> Could we try to include first this 1.3 one?  Then push the 1.4 if it
> is already ready.
>
> Because then, this release will be usable "forever" (or almost ;-)
> even if it is not perfect and issues are fixed with the 1.4.
> I mean, once a package is inside Guix, then it becomes "easily" usable
> with 'guix time-machine' and saved on Software Heritage.
> Therefore, considering the big picture of Scientific Reproducibility,
> it matters -- for the future to be able to travel back -- to also have
> 1.3. ;-)
>

Ok, let's do both
> I think we are almost done. From my point of view, we just need to
> address (or comment) these 3 points:
>
> 1.
>> Do you have a special motivation to rename 'llvm-patch' to 'julia-patch'?
>> (I agree, it is better :-))
>
Yes, because now it's not only used by llvm-julia but also by the new
libunwind-julia.  So calling llvm-patch a function that takes a patch
from the julia repo and that is applied to a "julia module" is measleading.

>
> 2.
>> Well, only 2 inputs are missing. Do you think it is affordable to pack
>> them and so remove the commentary?
>>
>> --8<---------------cut here---------------start------------->8---
>> ;; FIXME: The following inputs are downloaded from upstream to allow us
>> ;; to use the lightweight Julia release tarball.  Ideally, these inputs
>> ;; would eventually be replaced with proper Guix packages.
>> ;; Find dependencies versions here:
>> ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Version=
s.make
>> --8<---------------cut here---------------end--------------->8---
>

I indeed tried.  The main problem is that in the Makefile there's no
USE_SYSTEM_{OBJCONV/LIBWHICH}, and I didn't want to mess with the it.
But yes, I think I could at least try again.

>
> 3.
>> Otherwise, there is some issues about indentation -- I think you use
>> Emacs, so check that '.dir-locals.el' is correctly setup -- double
>> space for sentences in description,
>> 'patch/julia-SOURCE_DATE_EPOCH-mtime.patch' should be added with the
>> same commit that "Update", etc.
>> I have half-corrected so I can send you these 2 v2-patches if you want t=
o. :-)
>
>
If you already fixed them, yes please send a v2 patch and I'll continue
working from there.

>
> What do you think?
>
Fine for me, do we need also to debug a broken test right?
>
> Cheers,
> simon


Nicol=C3=B2




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 11 Feb 2020 14:51:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 11 09:51:24 2020
Received: from localhost ([127.0.0.1]:56117 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1j1Wsl-0001pt-Qh
	for submit <at> debbugs.gnu.org; Tue, 11 Feb 2020 09:51:24 -0500
Received: from mail-qk1-f181.google.com ([209.85.222.181]:46735)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1j1Wsk-0001pg-8Q
 for 38546 <at> debbugs.gnu.org; Tue, 11 Feb 2020 09:51:22 -0500
Received: by mail-qk1-f181.google.com with SMTP id g195so10268699qke.13
 for <38546 <at> debbugs.gnu.org>; Tue, 11 Feb 2020 06:51:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=9m5yu1gS0XwDj5rMMlk7brL8t4GXK9u81YpaOwM9S8Y=;
 b=Ex64PUsISecd3EwV17q7yTU4ohgwO7UxLVyLSIV5PoAz62U6XsqTFLa386HJqxaFbA
 U/xVMAgDdsZeb2xiPEik22mma8PsPTw9S09W1WiRiDq/grQ3FT36xJeapmjE4qbh/G/R
 4jiLttv14T0FdhdO33JqGeToiurnYCPq6KwsLUskt33Rc5LasUmaY/WfJsu7w/lscBp0
 JY6nczESRYYYkkReA7fjS3fuacBe/GJbb/o4cQU26be8pSU6+GU7/0R9zLBLu6rBWc9c
 HkKaMHELqfnHkgauCcSWgqhRqusJKz8Mq7+qcy1K5Fe20otv2k3JqvUfgfEQXugaHHEj
 aO9Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=9m5yu1gS0XwDj5rMMlk7brL8t4GXK9u81YpaOwM9S8Y=;
 b=m05GPnMA5wu1MS0UInGT24xellG3BUUD/Hcd8BKlH/C6EcSmODnBP5xI7ZLNwAwoR/
 xIwwMxHvO6s7ZwZNxGCGFm/4iOodin+lMLcFQOeoGWHfwsXQ27gBoEk8q6zdQS5cCqjM
 IAqrtKvuZJQuxDuctIMJ57HZdm0i6FlucY14TKXvu1Xbv266wxKgs15S0z7p2KS2hhWV
 JOVY0AxYi/5GeHvqxh39obKGUoX81rXPG4quxw8Sbe12N2skB+3GzpRSfTpcktfvYVp2
 E2gJHx1gqPZLQ5vX2G7pPmjQtLpQNiMs1AVc3N4E3NKJ3CbyfZhbGTaWIKQlJ1XZQmEm
 fC7Q==
X-Gm-Message-State: APjAAAW7IEBZN8j9WgsAZQhXvU66h98PWmWJIh00YwPBfwqOy6Kn6vc2
 ZRuNPon0W6CPkKpKDdTvOljRYazrGQMvFLZmM5M=
X-Google-Smtp-Source: APXvYqzMr+67ZSJjPq8ODTatlikiyN9yiCHjoPAbLgATK5nJmEmLGLUUIT68GJjNV2kIn4vxkhV6jnCVbHDfzCjgg7U=
X-Received: by 2002:a05:620a:124f:: with SMTP id
 a15mr5939916qkl.201.1581432676710; 
 Tue, 11 Feb 2020 06:51:16 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
 <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
In-Reply-To: <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Tue, 11 Feb 2020 15:51:05 +0100
Message-ID: <CAJ3okZ38fzeaLjGjQkNq3EYv7JSxEpsn9zgnnyt3E9WaQQZxSQ@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B3,

I have seen your message on IRC.
Cool for the release 1.4.


Could we try to include first this 1.3 one?  Then push the 1.4 if it
is already ready.

Because then, this release will be usable "forever" (or almost ;-)
even if it is not perfect and issues are fixed with the 1.4.
I mean, once a package is inside Guix, then it becomes "easily" usable
with 'guix time-machine' and saved on Software Heritage.
Therefore, considering the big picture of Scientific Reproducibility,
it matters -- for the future to be able to travel back -- to also have
1.3. ;-)

I think we are almost done. From my point of view, we just need to
address (or comment) these 3 points:

1.
> Do you have a special motivation to rename 'llvm-patch' to 'julia-patch'?
> (I agree, it is better :-))


2.
> Well, only 2 inputs are missing. Do you think it is affordable to pack
> them and so remove the commentary?
>
> --8<---------------cut here---------------start------------->8---
> ;; FIXME: The following inputs are downloaded from upstream to allow us
> ;; to use the lightweight Julia release tarball.  Ideally, these inputs
> ;; would eventually be replaced with proper Guix packages.
> ;; Find dependencies versions here:
> ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Versions=
.make
> --8<---------------cut here---------------end--------------->8---


3.
> Otherwise, there is some issues about indentation -- I think you use
> Emacs, so check that '.dir-locals.el' is correctly setup -- double
> space for sentences in description,
> 'patch/julia-SOURCE_DATE_EPOCH-mtime.patch' should be added with the
> same commit that "Update", etc.
> I have half-corrected so I can send you these 2 v2-patches if you want to=
. :-)



What do you think?


Cheers,
simon




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 7 Feb 2020 12:06:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Feb 07 07:06:21 2020
Received: from localhost ([127.0.0.1]:48948 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1j02Or-0006zK-9H
	for submit <at> debbugs.gnu.org; Fri, 07 Feb 2020 07:06:21 -0500
Received: from mail-qv1-f41.google.com ([209.85.219.41]:45953)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1j02Oo-0006z0-Ha
 for 38546 <at> debbugs.gnu.org; Fri, 07 Feb 2020 07:06:19 -0500
Received: by mail-qv1-f41.google.com with SMTP id l14so786727qvu.12
 for <38546 <at> debbugs.gnu.org>; Fri, 07 Feb 2020 04:06:18 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=96t60Xmt1c+v62L4851CRWXuuRNW9mSd9IVCFZdaAJ4=;
 b=qirItC3bmC5wKFLQGUZSymbBvhtFq/GcuLzK+bV677Ebpv0QE1gsR0x0u8v1Iw7DW4
 ImuImkoz5KJHEdXa0dkSiye4AE4+/2gK+G/spjxp1S9tEhLuU6JaaRU40Dh/lxYcwTPs
 ipe7H60SyGN7kH27sf6VolbIfM8+snVG8GELGCvLY2yvg8iIxXDCOQgAlKRL5cBekCJq
 lJnSP73x69CcfynAgQ730Rr5THE4Ud5+aJWbYLrHidq+MuAL07r04vftsTuMavYprDCn
 dr6n19wz8XnZWLa/AmPYkueY1eIzFIpi9bukjzBpEwcXuquAuGqbrDUT6JFfhi29fE/8
 AmFg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=96t60Xmt1c+v62L4851CRWXuuRNW9mSd9IVCFZdaAJ4=;
 b=ES4yquTidt2tpokrlsDJ8gZ5p9KYrOz1AuugWg2tEalmjEQrrYS1vR5CAO1Ia28GqY
 xrU5koohjXeqF8uLe9MpAqxdAAOg9OpnZBe+XG32tM2lW+K0UnL3VaG7OUEpwMhvdGHw
 Oll4wkK8i4QWDGIJhy8AQYvVMRe8Jb04m4vsN0w/ft9L2fBueOzN+zhiBiBhFjfTn61c
 pubCLjuo0W78zNNMwWxL5y6ad+yYUc+A68Oer5WOLuCIFBAuAYp8/pxmOvjhZXoFWm46
 lzcZVlvAgg9SCfp0U/+lcIjOqY8EzjxC9jNMswVP7aPDQzUrHqnt1EQrpjpKLFScdUxc
 fIvg==
X-Gm-Message-State: APjAAAXKC7nVrR7wRQYJQsQUzt+p8gyQtfKd8BL8t/VDjnXpSllorli+
 RQcreA3DNZu4eqqbgFiegt6f1WAyzKwWta9vQ1U=
X-Google-Smtp-Source: APXvYqyULCfAuy3D99EV5m3Z8MNEFwKrPCc1wSmBKCofVvDTG9tbLQjTwBAl4cgOryDAl7tgA/oAJh+f6lEwBQhpaHg=
X-Received: by 2002:a0c:f98e:: with SMTP id t14mr6384643qvn.74.1581077172996; 
 Fri, 07 Feb 2020 04:06:12 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
 <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
In-Reply-To: <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 7 Feb 2020 13:06:01 +0100
Message-ID: <CAJ3okZ3a7_LV55vhe449ETFaTqdSZp7D3Rvr0ipnvkdKr3i_QQ@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B3,


On Tue, 4 Feb 2020 at 19:03, zimoun <zimon.toutoune@HIDDEN> wrote:

> I have tried them. Ouch! The tests eat so much...

The tests fail on my desktop machine with 8GB of RAM.

--8<---------------cut here---------------start------------->8---
running testset Distributed...
ERROR: LoadError: TaskFailedException:
Timed out waiting to read host:port string from worker.
Stacktrace:
 [1] worker_from_id(::Distributed.ProcessGroup, ::Int64) at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/cluster.jl:1059
 [2] worker_from_id at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/cluster.jl:1056
[inlined]
 [3] #remote_do#156 at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/remotecall.jl:482
[inlined]
 [4] remote_do at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/remotecall.jl:482
[inlined]
 [5] kill at /tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/=
stdlib/v1.3/Distributed/src/managers.jl:534
[inlined]
 [6] create_worker(::Distributed.LocalManager, ::WorkerConfig) at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/cluster.jl:581
 [7] setup_launched_worker(::Distributed.LocalManager, ::WorkerConfig,
::Array{Int64,1}) at
/tmp/guix-build-julia-1.3.1.drv-0/julia-1.3.1/usr/share/julia/stdlib/v1.3/D=
istributed/src/cluster.jl:523
 [8] (::Distributed.var"#43#46"{Distributed.LocalManager,Array{Int64,1},Wor=
kerConfig})()
at ./task.jl:333

[...more failed...]
--8<---------------cut here---------------end--------------->8---


Do they pass on your machine?


> And I have not tried yet to build with '--check'.

Still not reproducible as expected [1]. :-)

[1] http://issues.guix.gnu.org/issue/22304


Cheers,
simon

ps:
I think you are busy by your thesis. Cross the fingers. ;-)




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 4 Feb 2020 18:03:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Feb 04 13:03:45 2020
Received: from localhost ([127.0.0.1]:44749 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iz2Y5-0006C7-FB
	for submit <at> debbugs.gnu.org; Tue, 04 Feb 2020 13:03:45 -0500
Received: from mail-qv1-f41.google.com ([209.85.219.41]:38769)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iz2Y4-0006Bu-09
 for 38546 <at> debbugs.gnu.org; Tue, 04 Feb 2020 13:03:44 -0500
Received: by mail-qv1-f41.google.com with SMTP id g6so8996813qvy.5
 for <38546 <at> debbugs.gnu.org>; Tue, 04 Feb 2020 10:03:43 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=2qHUCe/LUaSXTeHazLo1HMuViyqkowq82E/17VJVDgU=;
 b=NEzg2BPQUGbHuwRKr6cWBvbGamyeDvrsSJ9FeGTsPxKI94Pjeb3IAZIDfE+K1l2j1D
 FEx9cOhLRfy4VHNh/mVJVicAAVgUJhir25oGIkm1IkOKvgEIIhxVAILQo+P2auLD4HC5
 JTYdUQm2vXUujH4+lxVt09hUp6gA6FJKhlOUuHZXmS2bhaZjQinkAG58KfVUXCvWHaYS
 hs5lNP6CdRUjuLyn3m2bITPs0kHRUWM6rOk/Hg0pwJuG4r/ivTh8as2X+5xKm9NQLBA2
 Df0s5pJgKjR4VL38VZV1Sg6RwiAb8CDdDydWkqoInOvESRp/HgK7TpWAi1bqEuMc93Ml
 5aLw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=2qHUCe/LUaSXTeHazLo1HMuViyqkowq82E/17VJVDgU=;
 b=nsTF7GoNg25krA+quryOn8PScltQT8Jp1lQ2dXdBQhECFF51JQVJcB0TqjQ6QnMK1Y
 WI+1v/LrBBubASma8Kv1XG0cT1HtnPl2LEDMHhVwH8ysA5Adl74bYh2RNKLMe3MnvOgL
 nxSoGhCrpUIJjHkTgfO5NSS74NDty2rJxwDmVRLk+9QE2Prq6KP055/g4g54qpZceU58
 xaYl7XzRtCeL9A7wA61baNvTO88sfdzfKhBWxYVxJQhYrJjA05wan6QlrjJXW/VMnxrp
 txsBO/x9nKzFBnImBqktVIreWtUdfTPSBEaZSKJ5u108vKxRNrC5XGs3N8HoYOSpDbem
 T70Q==
X-Gm-Message-State: APjAAAUWQyZb3czW/+v9POYnJKzA0rB9O8yHm74URhkwHwqQwBX65swA
 4Ft6vB4k6zr3HWGKCcRe07zjXu6Nw2w66u0T+98=
X-Google-Smtp-Source: APXvYqyxHfrk3+l2ZRdoABUBRr1T60JwfXjQYJifsU/4lLv3oaBynuaK+0dAEgVhogVSAhaUQPMF/Y47sdtK40y24+8=
X-Received: by 2002:a0c:f703:: with SMTP id w3mr28708690qvn.6.1580839418291;
 Tue, 04 Feb 2020 10:03:38 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
 <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
In-Reply-To: <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Tue, 4 Feb 2020 19:03:27 +0100
Message-ID: <CAJ3okZ3xcGohx0sU7Tz-_h+neocE0KPZ59CncUTQQLOzK_ykeA@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B3,

On Fri, 24 Jan 2020 at 18:26, zimoun <zimon.toutoune@HIDDEN> wrote:

> I have not yet tried your patches. Sorry bit busy at work.
> And I will not have any slot next week, so I will be back on the topic
> after the Guix Days. Except if someone beats me. :-)
> (see you there :-)

I have tried them. Ouch! The tests eat so much...

Do you have a special motivation to rename 'llvm-patch' to 'julia-patch'?
(I agree, it is better :-))

Well, only 2 inputs are missing. Do you think it is affordable to pack
them and so remove the commentary?

--8<---------------cut here---------------start------------->8---
;; FIXME: The following inputs are downloaded from upstream to allow us
;; to use the lightweight Julia release tarball.  Ideally, these inputs
;; would eventually be replaced with proper Guix packages.
;; Find dependencies versions here:
;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Versions.m=
ake
--8<---------------cut here---------------end--------------->8---


Otherwise, there is some issues about indentation -- I think you use
Emacs, so check that '.dir-locals.el' is correctly setup -- double
space for sentences in description,
'patch/julia-SOURCE_DATE_EPOCH-mtime.patch' should be added with the
same commit that "Update", etc.
I have half-corrected so I can send you these 2 v2-patches if you want to. =
:-)

And I have not tried yet to build with '--check'.


All the best,
simon




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 24 Jan 2020 17:27:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 24 12:27:18 2020
Received: from localhost ([127.0.0.1]:54715 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iv2jl-0004Wm-KW
	for submit <at> debbugs.gnu.org; Fri, 24 Jan 2020 12:27:18 -0500
Received: from mail-qk1-f180.google.com ([209.85.222.180]:37496)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iv2jh-0004WR-WC
 for 38546 <at> debbugs.gnu.org; Fri, 24 Jan 2020 12:27:15 -0500
Received: by mail-qk1-f180.google.com with SMTP id 21so2807938qky.4
 for <38546 <at> debbugs.gnu.org>; Fri, 24 Jan 2020 09:27:13 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=Og3gX0e1y2GxSuzOWZU5nxXq+/y2M4mnID6thQMq6sM=;
 b=RTcMot8ptoPF3k2nYBEA70SzxJBSSSl395XSsDEVr+Wum99q7D507JARtYb8usNFSn
 kBG2R1KpqolN6gbA839I46NkRJNnhlI193vcXbxvwRuIDXluDvEGXlnlyJplqrbcJNsV
 MHcufoYHIxQcLBvX0Kb3Fb2kBNqtHAvq35pGgwsgOyd8yk6mkozASmL11SQFqy6d077F
 9PSzy8Awgkfqae6iUA4J/sJJOCA1InsJjCB59mWC7kb7dtTuayhSDLaf4N5rleHBnDek
 KemTFyhkhpM0l3pqjsxNj+YcjtNPtVPdXxQHGFQsg6dA9UPpNWye/hTTFvZriWAfbGTG
 dqsg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=Og3gX0e1y2GxSuzOWZU5nxXq+/y2M4mnID6thQMq6sM=;
 b=Y3dGc3mktyy7etOAAbz3DBPOtLgtbrItLMrH4DhnN63goPWABkPSlSM985+pxW1KxT
 mYUqJQDTNyvhJhG2e1wCcfc1Mx4cf6luGhfBSa7/CUUjiiOGE+mCyAKlGjqB1GHmiayN
 3Wyb3TGEIvrO3OFMjc2DoO9CPwzZUdv/wwkkaXpK2nmaFN5H0SZJeTAyZtZpgBuo6quM
 QwqUgjGZLyrlYgjkANxf68b5C9Mp46Pbwm5jI3JQAVV51iRxOSA4EJvW7gYxfvtIbR0P
 WqxGmLvy0bLtumUFM4gvj9HDO8PBHlUBzQWsH2r6mxi65JglqEZ2/EGLdZX2FWt40cct
 73Cw==
X-Gm-Message-State: APjAAAUkFkjn4m9p8nd++5nfrIOeBq86Tc3WOhRfXFgW9DbUG8kpEI8V
 wY70EfW2eRoGKfZi0VJ1JiqIjpz41gGJlHS1dNs=
X-Google-Smtp-Source: APXvYqwSW4rbx3HASvJxazn6vGOiMLVf1NHb0PpWfxJNRjPQOGYLQB0lOOSh7NT8Gb8liGtSp/9XqVxZukrWSu+34Bo=
X-Received: by 2002:a37:710:: with SMTP id 16mr1495843qkh.304.1579886828436;
 Fri, 24 Jan 2020 09:27:08 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
 <877e1jdd62.fsf@HIDDEN>
In-Reply-To: <877e1jdd62.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 24 Jan 2020 18:26:57 +0100
Message-ID: <CAJ3okZ19pt6aq0niwQDKfOES8TMGzDBXVmMS3aiRTFcBXithpQ@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B2,

On Wed, 22 Jan 2020 at 10:59, Nicol=C3=B2 Balzarotti <anothersms@HIDDEN>=
 wrote:

> The first patch (the one I mention in [#]) fixes _one source of_
> non-determinism (the stored mtime inside the precompile cache).  But
> others are present (precompiling the same file 2 times lead to
> differences even in file size, something I reported on [2]).  What I'm
> working on is trying to find out what other sources are and patch them,
> too.  I patched some c code (src/support/timefuncs.c) so that it follows
> SOURCE_DATE_EPOCH too.  This finally lead to same-size files.  I'm now
> working on parsing binary (.ji) files directly with julia built in
> function to have a textual representation of the differences.

Thank you for the explanations. Cool!


> I can't send SOURCE_DATE_EPOCH patches upstream until [3] is merged, as
> patching timefuncts leads to an endless test suite (as they were using
> time() to check for passed time. If time() always returns 1, tests
> sleeps forever).  Yesterday evening I completed that patch (and has been
> approved).  My plans are on finding the hopefully last source of
> non-determinism, patch it and send everything upstream (hoping they
> care).

Awesome if upstream are responsive.


> Thanks! I hope in a 1.4 release where everything is fixed ;)

I have seen that 1.4-rc1 is just released. Hope that everything about
reproducibility will be fixed. ;-)


I have not yet tried your patches. Sorry bit busy at work.
And I will not have any slot next week, so I will be back on the topic
after the Guix Days. Except if someone beats me. :-)
(see you there :-)


Thank you for improving the Julia ecosystem in Guix because Julia is
becoming quite popular.

Cheers,
simon




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 22 Jan 2020 10:00:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 22 05:00:01 2020
Received: from localhost ([127.0.0.1]:49029 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iuCno-0002Kq-O4
	for submit <at> debbugs.gnu.org; Wed, 22 Jan 2020 05:00:01 -0500
Received: from mail-wr1-f44.google.com ([209.85.221.44]:46844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1iuCnl-0002Kb-Vb
 for 38546 <at> debbugs.gnu.org; Wed, 22 Jan 2020 04:59:58 -0500
Received: by mail-wr1-f44.google.com with SMTP id z7so6485998wrl.13
 for <38546 <at> debbugs.gnu.org>; Wed, 22 Jan 2020 01:59:57 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=lY1KYV15J57A8lLX/oOG4h9HBYxTkjr5rUHnSMqYLwk=;
 b=iW3SmouXhXpwIOy75RNp/ozgAcdvPFmtzm4TVpjptSOiY/qGhC6hWUUuHo19lPrDlH
 kDgdet1EItnBLAbjIdeQ3QjOs2C7YDRvvrZYKlIHY76A86yTyqdzx7T9Vj/cY43MY2h7
 W3YTzsAJJGPQJJak1lbt0+Aq6sUcC9SEp4e9rTLuj1+Ihsyo9V+3A9B3WrDr4PJs5QW8
 RH0AvQqASTvR29Rg1hqqsAWAv5J+irk2BcR71NbZ+rQBmN3vlfsqZdtI5vW/Xr/72vc7
 /4N7Yja8t5jUBq7JAlOGSseQJSP0wAPCtntOn/X+z3VLRyDo7qAHm+Bd8ilSLhN5YZVK
 3WAg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=lY1KYV15J57A8lLX/oOG4h9HBYxTkjr5rUHnSMqYLwk=;
 b=WgTFDdn66rBEZZsWs3Zz53zdwDOB+ak08ld8AJaNCgC9V3pHynrJe2blwTWcnGNKNG
 DEMtTyiWM6N8o1bSxV7kjCe5quvNSHM7P6OERdSnIHyY/ywWod1e10ArfBwslEMzV+Ln
 dudEqpxAioOxEocx6WltY0xqxGB5U8xT7ueyipN5/IS6iQxmq40xeS4EwRddW/yjumpj
 t6oBiIDTLWygPdYmmNouLWrYgLJMuZsZrv/Ntnf9eJfRbMGO8aA4a1PaJYEPHi7bjGbO
 jgX/Fy8GH5rJ1Al1+vcMaKczk55xUhfzNXcS2j8SopszEByUGZgQMmmjiso1H6jQSlZ7
 O9Og==
X-Gm-Message-State: APjAAAWIMHP/GkMAsraB8qlvJeKQ5S7BChRcCf5OPSbvpAsYBxYKIm2T
 ja1ISewIhPlIoFiHl2j1mOQarwxLg1Oxpg==
X-Google-Smtp-Source: APXvYqzmW9Bs18SonGYHn+bRNtJ6D7tDabjT4WNBMBjd0BoE5PbtJyHzIWNwaSWJFMi467rHEVA19Q==
X-Received: by 2002:a5d:4692:: with SMTP id u18mr10332627wrq.206.1579687191500; 
 Wed, 22 Jan 2020 01:59:51 -0800 (PST)
Received: from guixSD (host215-142-dynamic.16-79-r.retail.telecomitalia.it.
 [79.16.142.215])
 by smtp.gmail.com with ESMTPSA id e18sm56811371wrr.95.2020.01.22.01.59.49
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 22 Jan 2020 01:59:50 -0800 (PST)
From: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
In-Reply-To: <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
 <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
Date: Wed, 22 Jan 2020 10:59:49 +0100
Message-ID: <877e1jdd62.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Simon,

zimoun <zimon.toutoune@HIDDEN> writes:

> Hi Nicol=C3=B2,
>
> Cool that you figured out a source of non-reproducibility.
>
>
> On Tue, 21 Jan 2020 at 14:45, Nicol=C3=B2 Balzarotti <anothersms@HIDDEN=
m> wrote:
>
>> Sorry, I forgot to send the dsfmt patch.  Also, julia's
>> SOURCE_DATE_EPOCH patch was named differently. I've fixed this in theatt=
ached patches.  You need to apply Add-dsfmt.patch, Update-to-1.3.1
>> and then julia-use-SOURCE_DATE_EPOCH.
>
> This patch 'julia-SOURCE_DATE_EPOCH-mtime.patch' is the one you
> mentioned here [#], right?
>
> Could you send it as an upstream PR?
>
> [#] https://github.com/JuliaLang/julia/issues/34115#issuecomment-568171025
>
>
>> About reproducibility: if I'm not wrong, sys.so contains Base library
>> precompiled ([1]).  Precompilation is still non deterministic (here's
>> [2] an issue on github). Something I did to check precompilation:
>
> I am not sure to well understand the source of non-determinism.
>
> Does the patch about SOURCE_DATE_EPOCH fix the issue of [1] and [2]?
> Or is it something else?
>

The first patch (the one I mention in [#]) fixes _one source of_
non-determinism (the stored mtime inside the precompile cache).  But
others are present (precompiling the same file 2 times lead to
differences even in file size, something I reported on [2]).  What I'm
working on is trying to find out what other sources are and patch them,
too.  I patched some c code (src/support/timefuncs.c) so that it follows
SOURCE_DATE_EPOCH too.  This finally lead to same-size files.  I'm now
working on parsing binary (.ji) files directly with julia built in
function to have a textual representation of the differences.

I can't send SOURCE_DATE_EPOCH patches upstream until [3] is merged, as
patching timefuncts leads to an endless test suite (as they were using
time() to check for passed time. If time() always returns 1, tests
sleeps forever).  Yesterday evening I completed that patch (and has been
approved).  My plans are on finding the hopefully last source of
non-determinism, patch it and send everything upstream (hoping they
care).

>
>> I could not get the same results twice (also, size differs).  I'll work
>> on this on some spare time (for example, there are other places where
>> SOURCE_DATE_EPOCH can be used, but this [3] is a problem I need to
>> solve first).
>
> Is the problem [3] not solved by 'julia-SOURCE_DATE_EPOCH-mtime.patch'?
>
>
>
>> Maybe 1.3.1 (when reviewed) can be merged, since we have
>> the same problem with julia 1.1, but we can wait for the
>> source-date-epoch and julia-xyz patches until we solve this.
>
> My opinion is: if a patch is floating around to fix the
> source-date-epoch issue, let try to push it upstream. If it is
> rejected, let talk later if Guix will include it or not. And in the
> meantime, I will try to review the 1.3.1 because yes I agree that it
> should be included even if we know it is not reproducible -- the
> package Guitarix [@] is updated and not reproducible neither.
>

Thanks! I hope in a 1.4 release where everything is fixed ;)

Nicol=C3=B2

> [@] https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D21803
>
>
> Thank you for working on this.
>
>
> All the best,
> simon
>
>
>> [1] https://docs.julialang.org/en/v1/devdocs/sysimg/
>> [2] https://github.com/JuliaLang/julia/issues/25900
>> [3] https://github.com/JuliaLang/julia/issues/34115




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 22 Jan 2020 09:22:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 22 04:22:34 2020
Received: from localhost ([127.0.0.1]:48995 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iuCDa-0001SU-90
	for submit <at> debbugs.gnu.org; Wed, 22 Jan 2020 04:22:34 -0500
Received: from mail-qk1-f177.google.com ([209.85.222.177]:40309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iuCDX-0001SG-Nw
 for 38546 <at> debbugs.gnu.org; Wed, 22 Jan 2020 04:22:32 -0500
Received: by mail-qk1-f177.google.com with SMTP id c17so5710098qkg.7
 for <38546 <at> debbugs.gnu.org>; Wed, 22 Jan 2020 01:22:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=U3SmDU0rUZPgGHXQuwyxw52agOXwdXfmZDbzWXfwSF8=;
 b=p17QjnX9KHGdy4SA1IRjHycW6charSaF8eyy5P5Yang1RnfCdXgZG6ZSal9CbaqtKq
 lJ2+fKMjJvFHDcEvwrRMvyStWjM/FeFnAnEoeomW+jvHvz8jYhHZtFU+JAn4LLK4F+Dy
 2Os+hsC6WT716msn0SF4YA4lrX89HmNVrz/iRgq0Upq1Ws/qPCNGqkMF50huqe4Qv6wV
 XDzh/jBd3GZYyN44ySzao0f8s67mHPURdH+SpBKvyPXahzXSqHHHvcotQyLjcVTLlnQ9
 uy8NgpgKLHOYFRPdzCY9QORA9UdJr+nx/mxAEWHtI4sHUeBd8Q9weJspUF2KyN/iTbkQ
 8Lug==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=U3SmDU0rUZPgGHXQuwyxw52agOXwdXfmZDbzWXfwSF8=;
 b=fTRB2uRIWiWXKX2IE6hqCvbtHWoWGxIwbfHX2W4DbQdnM11nSJ9ZeehtHpaW/OcdSx
 jZd+h5gOTEgh0PDUY88RgztsYeuY+CBH1IKgHjiry7O5DbUnilAW0K7GlAuycQiRQZNX
 AX1RMwAmts6mUinSR3bnyU3zy4fE/JHGs4xKm2CSRleVzEqxEvcd/zv2MRdmenp4p2lY
 pxCWZWTnzZUCu6u8RvFc8+bHTyUrJtA6EHc0Oi9OUU5OGovGPG3mbim57zDZDZQsyCr4
 89I3DfhL89aAsf7LFEPogK9PSNCh1ypFNnAacv1uA+koG5oO6GeOzolPkTvAkvpfUnTi
 hLEg==
X-Gm-Message-State: APjAAAVfvstqR/Y+z5dXSFR8t2USUZIuAIxdxV/6B9C9V67xNhIl8DT6
 /zmo2nEMstEWJNx5+dCz131ocAXq19v0ONAfxwo=
X-Google-Smtp-Source: APXvYqyexuK7/WtjN+LA3FDbwzr9tysLIh+rWhkqG70QnedKG7oAYVgHFV7vNLMfE7g6J11Hx9Wa9pH8kib71MkJe64=
X-Received: by 2002:a37:a451:: with SMTP id n78mr8198390qke.304.1579684946222; 
 Wed, 22 Jan 2020 01:22:26 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
 <87d0bcly8f.fsf@HIDDEN>
In-Reply-To: <87d0bcly8f.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Wed, 22 Jan 2020 10:22:14 +0100
Message-ID: <CAJ3okZ3p6dkJyiwBqjjaG0Vnn0s07+7YxUG_Mdc3Eq5ixC3qDA@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B2,

Cool that you figured out a source of non-reproducibility.


On Tue, 21 Jan 2020 at 14:45, Nicol=C3=B2 Balzarotti <anothersms@HIDDEN>=
 wrote:

> Sorry, I forgot to send the dsfmt patch.  Also, julia's
> SOURCE_DATE_EPOCH patch was named differently. I've fixed this in theatta=
ched patches.  You need to apply Add-dsfmt.patch, Update-to-1.3.1
> and then julia-use-SOURCE_DATE_EPOCH.

This patch 'julia-SOURCE_DATE_EPOCH-mtime.patch' is the one you
mentioned here [#], right?

Could you send it as an upstream PR?

[#] https://github.com/JuliaLang/julia/issues/34115#issuecomment-568171025


> About reproducibility: if I'm not wrong, sys.so contains Base library
> precompiled ([1]).  Precompilation is still non deterministic (here's
> [2] an issue on github). Something I did to check precompilation:

I am not sure to well understand the source of non-determinism.

Does the patch about SOURCE_DATE_EPOCH fix the issue of [1] and [2]?
Or is it something else?


> I could not get the same results twice (also, size differs).  I'll work
> on this on some spare time (for example, there are other places where
> SOURCE_DATE_EPOCH can be used, but this [3] is a problem I need to
> solve first).

Is the problem [3] not solved by 'julia-SOURCE_DATE_EPOCH-mtime.patch'?



> Maybe 1.3.1 (when reviewed) can be merged, since we have
> the same problem with julia 1.1, but we can wait for the
> source-date-epoch and julia-xyz patches until we solve this.

My opinion is: if a patch is floating around to fix the
source-date-epoch issue, let try to push it upstream. If it is
rejected, let talk later if Guix will include it or not. And in the
meantime, I will try to review the 1.3.1 because yes I agree that it
should be included even if we know it is not reproducible -- the
package Guitarix [@] is updated and not reproducible neither.

[@] https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D21803


Thank you for working on this.


All the best,
simon


> [1] https://docs.julialang.org/en/v1/devdocs/sysimg/
> [2] https://github.com/JuliaLang/julia/issues/25900
> [3] https://github.com/JuliaLang/julia/issues/34115




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 21 Jan 2020 13:45:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 21 08:45:49 2020
Received: from localhost ([127.0.0.1]:46625 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ittqd-00007v-Gd
	for submit <at> debbugs.gnu.org; Tue, 21 Jan 2020 08:45:49 -0500
Received: from mail-wm1-f42.google.com ([209.85.128.42]:51197)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ittqT-0008KR-QX
 for 38546 <at> debbugs.gnu.org; Tue, 21 Jan 2020 08:45:38 -0500
Received: by mail-wm1-f42.google.com with SMTP id a5so3026242wmb.0
 for <38546 <at> debbugs.gnu.org>; Tue, 21 Jan 2020 05:45:29 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version; bh=d8kcpDpD3Y3T8CG5PiGasloqS2xL1IuVNgTGtcgq/GU=;
 b=vKkQA8XIRptzjOX9Y0ahKXyxjLB05ODtvTAfS97PITrN9Xwt9axxXkMQPNURrJMzo6
 2PrKjS/Fc4o6iiT0rr5SjVN6YWwos3UajBAEtHXVwHtjv2nC0BndjKGEmOwi4yhD1IXJ
 P1CrYfg/2KOQHaNqqJOEachzM6sXp2+c4qnhNSefjCN9Ab5IpKGf+gtpNGN7VL99ohFc
 pXbeaNZY11yzftlxGmM6ImYQwoWtFlH+iHGpsT16Vk7PFqvSFWdSsDsNlvWF5/XYpPz8
 hIH0wltpfUITI8wDW19eU/nr+gmVEPBU8CiOtgz6IhYpXNG2kZyrJchC81bxMGf/XCs1
 FB2g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version;
 bh=d8kcpDpD3Y3T8CG5PiGasloqS2xL1IuVNgTGtcgq/GU=;
 b=pomHLwfCUhUroxtrFMieAJcm6UfJIDQJ0CpepVsBx1QoEmau4DYQJ8CJCrFPf9dtbU
 mkd4WBO8pJ/GPZXD9TEKhwHU4bTO6DEmdpnZj+ovZ/E4BaUtrMPFAcisIcn78RmgL7/d
 CQVM6kDtnOiy8AGF+bdjzTlMxeD6cDEDSh2RWsqkzNpUz8sJ4v0msQbXXhZuGtDYccTC
 bULYku5Iw5f+3p3q9huJ7gcdtF4Y1DPIdMPh2nBhfEhTnvTY0iCbAIfg01vl1VEvVZ1c
 gujrnzyivNV1XZiVS1N7JBsCXW/7jjFmPaXnSgKTWUwU6sSittuvjCwpCwUXu3VqB7nl
 PqOg==
X-Gm-Message-State: APjAAAX+3W4Io1w+1t4a1R+NCdW7xgrrZK2IHsLHKwbRAZ3hXytus4yt
 wfrPv7g2ftLouD2HImHnUQcPXc2V2bU=
X-Google-Smtp-Source: APXvYqwVnfNmBF62+Z3k0hvaI9oV2s0gNrVk0QTXBmENEEoO3rv+zUffgNhW+StV3GKsk9ZTRN57oA==
X-Received: by 2002:a1c:6605:: with SMTP id a5mr4274492wmc.112.1579614323527; 
 Tue, 21 Jan 2020 05:45:23 -0800 (PST)
Received: from guixSD ([192.167.192.190])
 by smtp.gmail.com with ESMTPSA id 60sm53474838wrn.86.2020.01.21.05.45.21
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 21 Jan 2020 05:45:22 -0800 (PST)
From: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
In-Reply-To: <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
 <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
Date: Tue, 21 Jan 2020 14:45:20 +0100
Message-ID: <87d0bcly8f.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi Simon, Sorry, I forgot to send the dsfmt patch. Also,
 julia's
 SOURCE_DATE_EPOCH patch was named differently. I've fixed this in theattached
 patches. You need to apply Add-dsfmt.patch, Update-to-1.3.1 and the [...]
 Content analysis details:   (1.9 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: tamu.edu]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.128.42 listed in list.dnswl.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 38546
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.9 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi Simon,

Sorry, I forgot to send the dsfmt patch.  Also, julia's
SOURCE_DATE_EPOCH patch was named differently. I've fixed this in theattach=
ed patches.  You need to apply Add-dsfmt.patch, Update-to-1.3.1
and then julia-use-SOURCE_DATE_EPOCH.

About reproducibility: if I'm not wrong, sys.so contains Base library
precompiled ([1]).  Precompilation is still non deterministic (here's
[2] an issue on github). Something I did to check precompilation:

Since I'm tired of this, I've started investigating better.

Loaded a guix container
#+begin_src bash
mkdir -p /tmp/jlprecompiled/
./pre-inst-env guix environment -u nixbld --no-cwd --container --network --=
expose=3D$(realpath determinism) --share=3D/tmp/jlprecompiled/ --ad-hoc jul=
ia coreutils nss-certs curl tar gzip libfaketime
#+end_src

from this container, run some time this:

#+begin_src bash
export SSL_CERT_DIR=3D"$GUIX_ENVIRONMENT/etc/ssl/certs"
export SSL_CERT_FILE=3D"$SSL_CERT_DIR/ca-certificates.crt"
export GIT_SSL_CAINFO=3D"$SSL_CERT_FILE"

SOURCE_DATE_EPOCH=3D1 julia --startup-file=3Dno -q -e 'using Pkg; Pkg.insta=
ntiate()'
SOURCE_DATE_EPOCH=3D1 faketime '2008-12-24 08:15:42' julia --startup-file=
=3Dno -q -e 'using Random; using Pkg; Pkg.add("Compat"); Random.seed!(0); u=
sing Compat'

cp -r ~/.julia/compiled/v1.3/Compat/ /tmp/jlprecompiled/$RANDOM
sha256sum ~/.julia/compiled/v1.3/Compat/*
# 6c10d65f6cd9cdd5b98e4d5e2b82b7bd00508f0daccef0967dec92cb6468052e  /home/n=
ixbld/.julia/compiled/v1.3/Compat/GSFWK_Pua4I.ji
ls -lah ~/.julia/compiled/v1.3/Compat/*
# -rw------- 1 nixbld users 102K Jan 21 07:39 /home/nixbld/.julia/compiled/=
v1.3/Compat/GSFWK_Pua4I.ji
#+end_src

I could not get the same results twice (also, size differs).  I'll work
on this on some spare time (for example, there are other places where
SOURCE_DATE_EPOCH can be used, but this [3] is a problem I need to
solve first).

Maybe 1.3.1 (when reviewed) can be merged, since we have
the same problem with julia 1.1, but we can wait for the
source-date-epoch and julia-xyz patches until we solve this.

What do you think?

Thanks, Nicol=C3=B2

[1] https://docs.julialang.org/en/v1/devdocs/sysimg/
[2] https://github.com/JuliaLang/julia/issues/25900
[3] https://github.com/JuliaLang/julia/issues/34115


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0001-gnu-Add-dsfmt.patch

From 337ddd64ce4f3a00f33a90496822500dc6df2010 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 28 Dec 2019 00:10:48 +0100
Subject: [PATCH] gnu: Add dsfmt.

* gnu/packages/maths.scm (dsfmt): New variable.
---
 gnu/packages/maths.scm | 63 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 63 insertions(+)

diff --git a/gnu/packages/maths.scm b/gnu/packages/maths.scm
index 8364d528fd..1d35d880bd 100644
--- a/gnu/packages/maths.scm
+++ b/gnu/packages/maths.scm
@@ -372,6 +372,69 @@ semiconductors.")
     (license license:gpl3+)
     (home-page "https://www.gnu.org/software/dionysus/")))
 
+(define-public dsfmt
+  (package
+    (name "dsfmt")
+    (version "2.2.3")
+    (source (origin
+              (method url-fetch)
+              (uri
+               (string-append
+                "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/SFMT/dSFMT-src-"
+                version ".tar.gz"))
+              (sha256
+               (base32
+                "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))
+              ;; julia needs those (and is the only program depending on dsfmt now)
+              (patches
+               (list
+                (origin (method url-fetch)
+                        (uri
+                         "https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/patches/dSFMT.c.patch")
+                        (sha256 (base32 "09mhv11bms8jsmkmdqvlcgljwhzw3b6n9nncpi2b6dla9798hw2y"))
+                        (file-name "dSFMT.c.patch"))
+                (origin (method url-fetch)
+                        (uri
+                         "https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/patches/dSFMT.h.patch")
+                        (sha256 (base32 "1py5rd0yxic335lzka23f6x2dhncrpizpyrk57gi2f28c0p98y5n"))
+                        (file-name "dSFMT.h.patch"))))))
+    (build-system gnu-build-system)
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (delete 'configure)            ;no configure script
+         (replace 'build
+           ;; upstream Makefile does not build a shared library
+           (lambda _
+             (invoke
+              "gcc"
+              ;; flags copied from julia
+              ;; https://github.com/JuliaLang/julia/blob/v1.3.0/deps/dsfmt.mk
+              "-DNDEBUG" "-DDSFMT_MEXP=19937"
+              "-fPIC" "-DDSFMT_DO_NOT_USE_OLD_NAMES"
+              "-O3" "-finline-functions" "-fomit-frame-pointer"
+              "-fno-strict-aliasing" "--param" "max-inline-insns-single=1800"
+              "-Wmissing-prototypes" "-Wall" "-std=c99" "-shared" "dSFMT.c"
+              "-o" "libdSFMT.so")))
+         (replace 'install              ;no "install" target
+           (lambda* (#:key outputs #:allow-other-keys)
+             (let ((lib (string-append (assoc-ref outputs "out")
+                                       "/lib"))
+                   (inc (string-append (assoc-ref outputs "out")
+                                       "/include")))
+               (install-file "libdSFMT.so" lib)
+               (install-file "dSFMT.h" inc)
+               #t))))))
+    (synopsis "Double precision SIMD-oriented Fast Mersenne Twister")
+    (description "Speed up Fast Mersenne Twister generation by avoiding the
+expensive conversion of integer to double (floating point). dSFMT directly
+generates double precision floating point pseudorandom numbers which have the
+IEEE Standard for Binary Floating-Point Arithmetic (ANSI/IEEE Std 754-1985)
+format. dSFMT is only available on the CPUs which use IEEE 754 format double
+precision floating point numbers.")
+    (home-page "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/SFMT/")
+    (license license:bsd-3)))
+
 (define-public gsl
   (package
     (name "gsl")
-- 
2.25.0


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: attachment;
 filename=0001-gnu-julia-Update-to-1.3.1.patch
Content-Transfer-Encoding: quoted-printable

From ae58a1dd7b24989e281b07d9a90e1bb6de5199e2 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 15:14:32 +0100
Subject: [PATCH] gnu: julia: Update to 1.3.1.

* gnu/packages/julia.scm (julia): Update to 1.3.1.
---
 gnu/packages/julia.scm | 281 +++++++++++++++++------------------------
 1 file changed, 115 insertions(+), 166 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..3455dc6239 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2015, 2016, 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2016 Efraim Flashner <efraim@HIDDEN>
+;;; Copyright =C2=A9 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages base)
   #:use-module (gnu packages compression)
+  #:use-module (gnu packages curl)
   #:use-module (gnu packages elf)
   #:use-module (gnu packages gcc)
   #:use-module (gnu packages llvm)
@@ -43,18 +45,30 @@
   #:use-module (gnu packages textutils)
   #:use-module (gnu packages tls)
   #:use-module (gnu packages version-control)
+  #:use-module (gnu packages ssh)
   #:use-module (gnu packages wget)
   #:use-module (ice-9 match))
=20
+(define (julia-patch-url version name)
+  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
+		 "/deps/patches/" name ".patch"))
+
+(define (julia-patch name sha)
+  (let ((version "1.3.1"))
+    (origin (method url-fetch)
+	    (uri (julia-patch-url version name))
+	    (sha256 (base32 sha))
+	    (file-name name))))
+
 (define libuv-julia
-  (let ((commit "26dbe5672c33fc885462c509fe2a9b36f35866fd")
-        (revision "6"))
+  (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
     ;; When upgrading Julia, also upgrade this.
-    ;; Get the commit from https://github.com/JuliaLang/julia/blob/v1.1.1/=
deps/libuv.version
+    ;; Get the commit from
+    ;; https://github.com/JuliaLang/julia/blob/v1.3.1/deps/libuv.version
     (package
       (inherit libuv)
       (name "libuv-julia")
-      (version (string-append "1.9.0-" revision "." (string-take commit 8)=
))
+      (version (string-append "2.0.0" "." (string-take commit 8)))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -63,7 +77,7 @@
                 (file-name (string-append name "-" version "-checkout"))
                 (sha256
                  (base32
-                  "17pn2xmqaramilx897s9grs966i5246gi6sric5alch4g9j4685n"))=
))
+                  "0dn3v6fdp1z382pqg3nhjzk60l61ky9b65mfgaj29fv2da95rwjs"))=
))
       (build-system gnu-build-system)
       (arguments
        (substitute-keyword-arguments (package-arguments libuv)
@@ -72,16 +86,27 @@
              (delete 'autogen)))))
       (home-page "https://github.com/JuliaLang/libuv"))))
=20
-(define (llvm-patch-url version name)
-  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
-		 "/deps/patches/" name))
-
-(define (llvm-patch name sha)
-  (let ((version "1.1.1"))
-    (origin (method url-fetch)
-	    (uri (llvm-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+(define libunwind-julia
+  ;; julia requires a patched version
+  (package
+    (inherit libunwind)
+    (name "libunwind-julia")
+    (version "1.3.1")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "mirror://savannah/libunwind/libunwind-"
+                                  version ".tar.gz"))
+              (sha256
+               (base32
+                "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
+              (patches
+               (list
+	        (julia-patch "libunwind-prefer-extbl"
+                             "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hh=
xfgnh2m1")
+                (julia-patch "libunwind-static-arm"
+                             "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic87=
0zh3lhgq")))))
+    (build-system gnu-build-system)
+    (home-page "https://github.com/JuliaLang/libuv")))
=20
 (define llvm-julia
   (package
@@ -99,39 +124,39 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi=
?bug=3D919628
               (patches
                (list
-	        (llvm-patch "llvm-6.0-D44650.patch"
+	        (julia-patch "llvm-6.0-D44650"
 			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (llvm-patch "llvm-6.0-DISABLE_ABI_CHECKS.patch"
+	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
 			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (llvm-patch "llvm-6.0-NVPTX-addrspaces.patch"
+	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
 			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (llvm-patch "llvm-6.0.0_D27296-libssp.patch"
+	        (julia-patch "llvm-6.0.0_D27296-libssp"
 			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (llvm-patch "llvm-D27629-AArch64-large_model_6.0.1.patch"
+	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
 			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (llvm-patch "llvm-D34078-vectorize-fdiv.patch"
+	        (julia-patch "llvm-D34078-vectorize-fdiv"
 			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (llvm-patch "llvm-D42262-jumpthreading-not-i1.patch"
+	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
 			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (llvm-patch "llvm-D44892-Perf-integration.patch"
+	        (julia-patch "llvm-D44892-Perf-integration"
 			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (llvm-patch "llvm-D46460.patch"
+	        (julia-patch "llvm-D46460"
 			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (llvm-patch "llvm-D49832-SCEVPred.patch"
+	        (julia-patch "llvm-D49832-SCEVPred"
 			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (llvm-patch "llvm-D50010-VNCoercion-ni.patch"
+	        (julia-patch "llvm-D50010-VNCoercion-ni"
 			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (llvm-patch "llvm-D50167-scev-umin.patch"
+	        (julia-patch "llvm-D50167-scev-umin"
 			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (llvm-patch "llvm-OProfile-line-num.patch"
+	        (julia-patch "llvm-OProfile-line-num"
 			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (llvm-patch "llvm-PPC-addrspaces.patch"
+	        (julia-patch "llvm-PPC-addrspaces"
 			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (llvm-patch "llvm-rL323946-LSRTy.patch"
+	        (julia-patch "llvm-rL323946-LSRTy"
 			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (llvm-patch "llvm-rL326967-aligned-load.patch"
+	        (julia-patch "llvm-rL326967-aligned-load"
 			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (llvm-patch "llvm-rL327898.patch"
+	        (julia-patch "llvm-rL327898"
 			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
@@ -158,7 +183,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.3.1")
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -166,7 +191,7 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "0hk983mywimclgnjc41zmlppm5kfdz2aj85ky07p49ilcqxi998f"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
@@ -188,30 +213,24 @@
          (add-after 'unpack 'prepare-deps
            (lambda* (#:key inputs #:allow-other-keys)
              (mkdir "deps/srccache")
-             (copy-file (assoc-ref inputs "dsfmt")
-                        "deps/srccache/dsfmt-2.2.3.tar.gz")
+             ;; no USE_SYSTEM_{OBJCONV/LIBWHICH}
              (copy-file (assoc-ref inputs "objconv")
                         "deps/srccache/objconv.zip")
-             (copy-file (assoc-ref inputs "suitesparse")
-                        "deps/srccache/SuiteSparse-4.4.5.tar.gz")
-             (copy-file (string-append (assoc-ref inputs "virtualenv")
-                                       "/bin/virtualenv")
-                        "julia-env")
              (copy-file (assoc-ref inputs "libwhich")
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9c=
e7e89e"
                                        ".tar.gz"))
-             (copy-file (assoc-ref inputs "rmath")
-                        "deps/srccache/Rmath-julia-0.1.tar.gz")
-
 	     ;; needed by libwhich
 	     (setenv "LD_LIBRARY_PATH"
 		     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs =
pkg)
                                                         "/lib"))
-                                       '("arpack-ng" "fftw" "gmp" "lapack"
-			                 "libgit2" "mpfr" "openblas" "openlibm"
-			                 "openspecfun" "pcre2"))
+                                       '("arpack-ng" "curl" "dsfmt"
+                                         "gmp" "lapack"
+                                         "libssh2" "libgit2"
+                                         "mbedtls" "mpfr"
+                                         "openblas" "openlibm" "pcre2"
+                                         "suitesparse"))
                                   ":"))
 	     #t))
          ;; FIXME: Building the documentation requires Julia packages that
@@ -233,44 +252,12 @@
           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is n=
ot
           ;; used in Guix, we patch runtime_ccall.cpp to contain a static =
map.
           (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix Sys=
tem.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
-
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] =3D "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";=
")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.s=
o")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.=
so"))))))
             (substitute* "base/math.jl"
               (("const libm =3D Base.libm_name")
                (string-append "const libm =3D \""
                               (assoc-ref inputs "openlibm")
                               "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun =3D \"libopenspecfun\"")
-               (string-append "const openspecfun =3D \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+                              "\"")))))
          (add-before 'build 'fix-include-and-link-paths
           (lambda* (#:key inputs #:allow-other-keys)
             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
@@ -278,10 +265,10 @@
             ;; collection of build targets and a list of libraries to link
             ;; against.
             (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(L=
IBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) =
\\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OB=
JS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DO=
BJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_=
debug)"))
=20
             ;; The REPL must be linked with libuv.
             (substitute* "ui/Makefile"
@@ -296,43 +283,34 @@
                               "/include/uv/errno.h")))
             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
-         (add-after 'unpack 'hardcode-paths
            (lambda _
-             (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
-               (("`which") (string-append "`" (which "which")))
-               (("`wget")  (string-append "`" (which "wget"))))
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
              #t))
-         (add-before 'check 'disable-broken-tests
+         (add-before 'check 'fix-broken-tests
            (lambda _
-             (define (touch file-name)
-               (call-with-output-file file-name (const #t)))
-	     ;; FIXME: All git tests works except this one. But *THIS* "fix"
-             ;; is not working, so right now I'm disabling all libgit2.jl =
tests
-	     ;; (substitute* "stdlib/LibGit2/test/libgit2.jl"
-	     ;; (("!LibGit2.use_http_path(cfg, github_cred)") "true")
-	     ;; (("LibGit2.use_http_path(cfg, mygit_cred)") "true"))
-             (map (lambda (test)
-                    (delete-file test)
-                    (touch test))
-	          '("stdlib/Sockets/test/runtests.jl"
-		    "stdlib/Distributed/test/runtests.jl"
-                    ;; FIXME: see above
-		    "stdlib/LibGit2/test/libgit2.jl"))
-	     (substitute* "test/choosetests.jl"
-	       ;; These tests fail, probably because some of the input
-	       ;; binaries have been stripped and thus backtraces don't look
-	       ;; as expected.
-	       (("\"backtrace\",") "")
-	       (("\"cmdlineargs\",") ""))
+             (substitute* "test/choosetests.jl"
+               (("tests =3D testnames")
+                ;; Those failings are not deterministic.  They depends on =
the
+                ;; running order.  I think it depends on the number of
+                ;; runners, disabling it for now
+                ;; https://github.com/JuliaLang/julia/issues/34330
+                "tests =3D filter(e->!in(e,[\"backtrace\",\"exceptions\",\=
"client\",
+                                          \"stacktraces\",\"stress\",\"pre=
compile\"]),
+                                testnames)"))
+             ;; When HOME is not set, julia calls uv_os_homedir, which in
+             ;; turns call getpwuid_r. Add the HOME env variable to the
+             ;; external julia call to fix this
+             (substitute* "test/cmdlineargs.jl"
+               (("\"JULIA_PROJECT\"") "\"HOME\"=3D>\"/tmp\", \"JULIA_PROJE=
CT\""))
+             ;; Marking the test as broken as it's a known bug:
+             ;; https://github.com/JuliaLang/julia/issues/32377
+             (substitute* "stdlib/REPL/test/replcompletions.jl"
+               (("@test count") "@test_broken count"))
 	     #t)))
        #:make-flags
        (list
         (string-append "prefix=3D" (assoc-ref %outputs "out"))
-        (string-append "PREFIX=3D" (assoc-ref %outputs "out"))
=20
         ;; Passing the MARCH flag is necessary to build binary substitutes=
 for
         ;; the supported architectures.
@@ -345,26 +323,21 @@
            ;; platforms, e.g. when running "guix package --search=3D"
            (_ "MARCH=3DUNSUPPORTED"))
=20
-        "CONFIG_SHELL=3Dbash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=3D0"    ;not packaged for Guix and upstream has =
no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=3Dbash"             ;needed to build bundled librari=
es
+        ;; list of "USE_SYSTEM_*" is here:
+        ;; https://github.com/JuliaLang/julia/blob/v1.3.1/Make.inc
+        "USE_SYSTEM_DSFMT=3D1"
+        "USE_SYSTEM_P7ZIP=3D1"
         "USE_SYSTEM_LAPACK=3D1"
         "USE_SYSTEM_BLAS=3D1"
         "USE_BLAS64=3D0"          ;needed when USE_SYSTEM_BLAS=3D1
         "LIBBLAS=3D-lopenblas"
         "LIBBLASNAME=3Dlibopenblas"
=20
-        "USE_SYSTEM_FFTW=3D1"
-        "LIBFFTWNAME=3Dlibfftw3"
-        "LIBFFTWFNAME=3Dlibfftw3f"
-
-        ;; TODO: Suitesparse does not install shared libraries, so we cann=
ot
-        ;; use the suitesparse package.
-        ;; "USE_SYSTEM_SUITESPARSE=3D1"
-        ;; (string-append "SUITESPARSE_INC=3D-I "
-        ;;                (assoc-ref %build-inputs "suitesparse")
-        ;;                "/include")
-
+        "USE_SYSTEM_SUITESPARSE=3D1"
+        (string-append "SUITESPARSE_INC=3D-I "
+                       (assoc-ref %build-inputs "suitesparse")
+                       "/include")
         "USE_GPL_LIBS=3D1"        ;proudly
         "USE_SYSTEM_UTF8PROC=3D1"
         (string-append "UTF8PROC_INC=3D"
@@ -385,16 +358,19 @@
 	"USE_SYSTEM_PATCHELF=3D1"
 	"USE_SYSTEM_PCRE=3D1"
 	"USE_SYSTEM_OPENLIBM=3D1"
-
+        "USE_SYSTEM_LIBM=3D0"
+        "USE_SYSTEM_LIBSSH2=3D1"
+        "USE_SYSTEM_CURL=3D1"
 	"USE_SYSTEM_GMP=3D1"
 	"USE_SYSTEM_MPFR=3D1"
+	"USE_SYSTEM_MBEDTLS=3D1"
 	"USE_SYSTEM_ARPACK=3D1"
 	"USE_SYSTEM_LIBGIT2=3D1"
-	"USE_SYSTEM_ZLIB=3D1"
-	"USE_SYSTEM_OPENSPECFUN=3D1")))
+	"USE_SYSTEM_ZLIB=3D1")))
     (inputs
      `(("llvm" ,llvm-julia)
=20
+       ("p7zip" ,p7zip)
        ;; The bundled version is 3.3.0 so stick to that version.  With oth=
er
        ;; versions, we get test failures in 'linalg/arnoldi' as described =
in
        ;; <https://bugs.gnu.org/30282>.
@@ -403,12 +379,12 @@
        ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
        ("openblas" ,openblas) ;Julia does not build with Atlas
-       ("libunwind" ,libunwind)
+       ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
-       ("openspecfun" ,openspecfun)
+       ("mbedtls" ,mbedtls-apache)
+       ("curl" ,curl)
        ("libgit2" ,libgit2)
-       ("fftw" ,fftw)
-       ("fftwf" ,fftwf)
+       ("libssh2" ,libssh2)
        ("fortran" ,gfortran)
        ("libuv" ,libuv-julia)
        ("pcre2" ,pcre2)
@@ -418,31 +394,12 @@
        ("which" ,which)
        ("zlib" ,zlib)
        ("gmp" ,gmp)
-       ("virtualenv" ,python2-virtualenv)
+       ("suitesparse" ,suitesparse)
        ;; FIXME: The following inputs are downloaded from upstream to allo=
w us
        ;; to use the lightweight Julia release tarball.  Ideally, these in=
puts
        ;; would eventually be replaced with proper Guix packages.
-
-       ;; TODO: run "make -f contrib/repackage_system_suitesparse4.make" t=
o copy static lib
-       ;; Find dependency versions here:
-       ;; https://raw.githubusercontent.com/JuliaLang/julia/77a2c1e245c858=
12dc1c7687540beedecc52758f/deps/Versions.make
-       ("rmath"
-	,(origin
-	   (method git-fetch)
-	   (uri (git-reference
-                 (url "https://github.com/JuliaLang/Rmath-julia")
-                 (commit "v0.1")))
-           (file-name "rmath-julia-0.1-checkout")
-	   (sha256
-	    (base32
-	     "1zkpy0cg5zivq40zbhbdgj9128fqzs2j94wkwih8nc6xaj3gp9p6"))))
-       ("suitesparse"
-        ,(origin
-           (method url-fetch)
-           (uri "http://faculty.cse.tamu.edu/davis/SuiteSparse/SuiteSparse=
-4.4.5.tar.gz")
-           (sha256
-            (base32
-             "1jcbxb8jx5wlcixzf6n5dca2rcfx6mlcms1k2rl5gp67ay3bix43"))))
+       ;; Find dependencies versions here:
+       ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Ve=
rsions.make
        ("objconv"
         ,(origin
            (method url-fetch)
@@ -467,15 +424,7 @@
 	     (sha256
 	      (base32
 	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
-       ("dsfmt"
-        ,(origin
-           (method url-fetch)
-           (uri (string-append
-                 "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/"
-                 "SFMT/dSFMT-src-2.2.3.tar.gz"))
-           (sha256
-            (base32
-             "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))))))
+       ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
        ("perl" ,perl)
--=20
2.25.0


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0001-gnu-julia-use-SOURCE_DATE_EPOCH-for-precompilation-t.patch

From f33153f5f185562d01cfbfbfed43732483132f84 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 13:58:37 +0100
Subject: [PATCH] gnu: julia: use SOURCE_DATE_EPOCH for precompilation
 timestamp

* gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch: new file
---
 gnu/local.mk                                  |  1 +
 gnu/packages/julia.scm                        |  4 ++-
 .../julia-SOURCE_DATE_EPOCH-mtime.patch       | 29 +++++++++++++++++++
 3 files changed, 33 insertions(+), 1 deletion(-)
 create mode 100644 gnu/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch

diff --git a/gnu/local.mk b/gnu/local.mk
index 00ff3b8d61..fe8634b44d 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1010,6 +1010,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/java-xerces-bootclasspath.patch	\
   %D%/packages/patches/java-xerces-build_dont_unzip.patch	\
   %D%/packages/patches/java-xerces-xjavac_taskdef.patch	\
+  %D%/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch      \
   %D%/packages/patches/jbig2dec-ignore-testtest.patch		\
   %D%/packages/patches/kdbusaddons-kinit-file-name.patch	\
   %D%/packages/patches/libvirt-create-machine-cgroup.patch	\
diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 3455dc6239..794980c12f 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -191,7 +191,9 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))
+              (patches
+               (search-patches "julia-SOURCE_DATE_EPOCH-mtime.patch"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
diff --git a/gnu/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch b/gnu/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch
new file mode 100644
index 0000000000..467e6d68d1
--- /dev/null
+++ b/gnu/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch
@@ -0,0 +1,29 @@
+From e4dc28db1d70819505fd1a68fd9d2bfc4fb61a7d Mon Sep 17 00:00:00 2001
+From: nixo <nicolo@HIDDEN>
+Date: Fri, 17 Jan 2020 11:28:30 +0100
+Subject: [PATCH] base: loading: support fake mtime with SOURCE_DATE_EPCOCH
+
+Do this when loading libraries
+---
+ base/loading.jl | 5 ++++-
+ 1 file changed, 4 insertions(+), 1 deletion(-)
+
+diff --git a/base/loading.jl b/base/loading.jl
+index 7f11a2d4fc..1b4686d1dc 100644
+--- a/base/loading.jl
++++ b/base/loading.jl
+@@ -807,7 +807,10 @@ function _include_dependency(mod::Module, _path::AbstractString)
+         path = normpath(joinpath(dirname(prev), _path))
+     end
+     if _track_dependencies[]
+-        push!(_require_dependencies, (mod, path, mtime(path)))
++        push!(_require_dependencies,
++              (mod, path,
++               haskey(ENV, "SOURCE_DATE_EPOCH") ?
++               parse(Float64, ENV["SOURCE_DATE_EPOCH"]) : mtime(path)))
+     end
+     return path, prev
+ end
+-- 
+2.24.1
+
-- 
2.25.0


--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable



zimoun <zimon.toutoune@HIDDEN> writes:

> Hi Nicol=C3=B2,
>
> Thank you for working on this.
> Julia rocks! ;-)
>
>
> However, I am lost with your patch set.
>
> I have tried only the first patch you attached. I hit this error:
>
> --8<---------------cut here---------------start------------->8---
> error: dsfmt: unbound variable
> --8<---------------cut here---------------end--------------->8---
>
> So something is missing. :-)
>
> Then I notice that you change the list of 'patches' and you "forgot"
> to send them too. :-)
>
>
> Almost related, does this update fix the reproducibility bug [1]? For exa=
mple,
>
> --8<---------------cut here---------------start------------->8---
> ./pre-inst-env guix build julia
> ./pre-inst-env guix build julia --check --no-grafts -K
> --8<---------------cut here---------------end--------------->8---
>
>
> [1] https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D22304
>
>
> All the best,
> simon

--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 20 Jan 2020 18:50:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 20 13:50:10 2020
Received: from localhost ([127.0.0.1]:46044 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itc7i-0006Vz-LG
	for submit <at> debbugs.gnu.org; Mon, 20 Jan 2020 13:50:10 -0500
Received: from mail-qv1-f51.google.com ([209.85.219.51]:39113)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1itc7d-0006VO-So
 for 38546 <at> debbugs.gnu.org; Mon, 20 Jan 2020 13:50:05 -0500
Received: by mail-qv1-f51.google.com with SMTP id y8so258410qvk.6
 for <38546 <at> debbugs.gnu.org>; Mon, 20 Jan 2020 10:50:01 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=+pKvQIOButJo3yMYdpr+k99PkYKeukgUlVGI+kHA7gU=;
 b=XehUXOPjsL0RwvQSmnnnc1YmdhM/Zg+UDg/7rYB6BYU/+/GEIPlrUkJyukQLQr+Uh8
 UbhINctn5SkBhKtN5ZNAfemMMhLqNUhRsA6b+MZ5avNP++RQswbA1QeNtZ9aKc4oFwWA
 g+XZYNC6wogIjBXMkz8OYpCxBxo5228vwsJNnrc57MK3a0U39W4Sd5EQwGPs/c7WzeKT
 NQgJTxKYlzpELtCz/0iK5w/KDC4T2upq/MrKM0Kx1xee0UHlB8AdAdXV8v4ohTsD7ZWw
 7iuTxLxSDWlf8jX9mGKjBsbOoN9NGbC1XVlZbQMZAuinMJfC8s3hFMvNvXjeKW6gEWYf
 Vn8w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=+pKvQIOButJo3yMYdpr+k99PkYKeukgUlVGI+kHA7gU=;
 b=T165HNIq6jfINMdyIeLysOXjOugxfrqM/P/RbEyXWMronL+9V9x31hJLfMIkJPWzR1
 HvFqnIkFzHT6hXS5Oh6iCs7hC0usuJWmX3OW4Val88g0eDhmEbXDqGOovHyDbGqt7y6m
 W79jfb/HetU/Y4cWttpS0aRCjNZffAda7jSPYv18Gm4y8z467qNaEfBFBtk6kVguqRHt
 p7oc7F97AgYOHd18A8KylRnLt5q43Qs6UEnx1UMnFwsRm7x9LcOFZM1zP+qa8YeRr0D8
 dgPiUR8Xx7B2iwG3WB0VAxUzY9Lj+bO+FT+V9eL5zE4Mgm3tRCn5CqbtHZDs/RyF9xKr
 h6nQ==
X-Gm-Message-State: APjAAAVZWe03UdBa65L+0jX/kakOL20KqeYxyWyTtwVz4ecuBRs3uVB0
 t+Y9Sa7Jdc1DkzDN97fm4nHrQ0yvftiqOwM85yw=
X-Google-Smtp-Source: APXvYqz/CRUn9N93bKQV3AFkMMyd8aye260JqC33Bj2eRkatVpJ8J2hY1tgvdA40fKOgkKhn48b3FXwiKaK27Lvi6Vo=
X-Received: by 2002:a05:6214:3a1:: with SMTP id
 m1mr1063824qvy.77.1579546196375; 
 Mon, 20 Jan 2020 10:49:56 -0800 (PST)
MIME-Version: 1.0
References: <87v9qpvbyr.fsf@HIDDEN>
 <87wo9ouaq5.fsf@HIDDEN>
In-Reply-To: <87wo9ouaq5.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Mon, 20 Jan 2020 19:49:45 +0100
Message-ID: <CAJ3okZ3qBy4jTCKqsJ2msYA6zTmmWeQSU0ObaZdxc0Cg9zM-Ug@HIDDEN>
Subject: Re: [bug#38546] [00/11] Update Julia, Fix precompilation, add HTTP.jl
To: =?UTF-8?Q?Nicol=C3=B2_Balzarotti?= <anothersms@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Nicol=C3=B2,

Thank you for working on this.
Julia rocks! ;-)


However, I am lost with your patch set.

I have tried only the first patch you attached. I hit this error:

--8<---------------cut here---------------start------------->8---
error: dsfmt: unbound variable
--8<---------------cut here---------------end--------------->8---

So something is missing. :-)

Then I notice that you change the list of 'patches' and you "forgot"
to send them too. :-)


Almost related, does this update fix the reproducibility bug [1]? For examp=
le,

--8<---------------cut here---------------start------------->8---
./pre-inst-env guix build julia
./pre-inst-env guix build julia --check --no-grafts -K
--8<---------------cut here---------------end--------------->8---


[1] https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D22304


All the best,
simon




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 14:35:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 09:35:34 2020
Received: from localhost ([127.0.0.1]:40739 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ispC4-0002De-N3
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 09:35:33 -0500
Received: from mail-wm1-f41.google.com ([209.85.128.41]:33322)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ispBz-0002DJ-NH
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 09:35:19 -0500
Received: by mail-wm1-f41.google.com with SMTP id d139so11487452wmd.0
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 06:35:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=OOezF/FJIOsMXaNmNp6tMDKzk5NwN2V5yRQMS0z0lyI=;
 b=K9EbgtpzFxqi2GjdA38pveJnxRbKFAubcSlkiCbF8zm5I95nEfTaye7ehcRLe0raZ/
 Ml/k4RtqwdBWB/V7NFYaAz8Yo7V3asDdAxFCyUV9A0h6USWIBZ/uVbwEKT2NmR1wORcu
 Mfw/x+YcSBgBPm3ouZs0uSgrPXoXfdnwc/rC1QRrevh54KnwGtjD/2vJzFQjQ6LLhuYm
 /MDiKuEVCoWTV5Q2AXW1wS4dE1She7/n1klkJWvak/ewUO/Gwgyd8LsPtx0NBZU94/Ly
 cePLlvCf4LsXxqoSL5i/2e+Mn5BiZjKMd/ABdKsPBcOkSL5mMcYq+UZicY25foDQq1tR
 FGFQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=OOezF/FJIOsMXaNmNp6tMDKzk5NwN2V5yRQMS0z0lyI=;
 b=dU39yJ3HFtnZ+EWKg8u7crTU9zS1NiM3UMK1GUt5kEj7jJ2x7dllGwjiqbPqW+ZReU
 XZ6GpYM1KRfa/PFhaALCZK+0SYMrKOIj4paZD3Bs6x6aNWqZ6nYp1ZMdroBziGetFZzL
 6Avw0S6Z8UqMfcKZqRDublN4cwkLsIDtJYBp1dyBfkGIzNr2XxwF4iJvROqIVah5a5pD
 abT/Mxcua9GzypArQGO7lWiwPTAzF6I3Lrkv2F9LaaVm0WsiltBKN0BcMNOPijvRH6LZ
 p8EGHfsSr0zrLvi2iIffuhFzoZZwBAEHt/n1UQMi4gj3Q1PGRn2Df/c0ME+iFWF/pwUV
 n0Eg==
X-Gm-Message-State: APjAAAXOrFn00qou/B+dh9FPXeiMKRXdOWRvY9WbGdopzAKxWrW18C3y
 k0t7YOKMDyUO1yOrwGGkjTUCrC4U
X-Google-Smtp-Source: APXvYqz85QCD7M6skuzbv0NR5TQkoBrlgXBvkNn/DhT3k8GWuPscOiOo1WC1bBNgLRetQ7/JZYwOQQ==
X-Received: by 2002:a1c:dcd5:: with SMTP id t204mr9999352wmg.34.1579358109203; 
 Sat, 18 Jan 2020 06:35:09 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id s1sm14270462wmc.23.2020.01.18.06.35.07
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 06:35:08 -0800 (PST)
From: anothersms@HIDDEN (=?utf-8?Q?Nicol=C3=B2?= Balzarotti)
To: 38546 <at> debbugs.gnu.org
Subject: Julia patches v3
Date: Sat, 18 Jan 2020 15:35:06 +0100
Message-ID: <87r1zwu92d.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Sorry again, I fixed some unrelated changes that slipped in
    Thanks, Nicolò From ae58a1dd7b24989e281b07d9a90e1bb6de5199e2 Mon Sep 17
   00:00:00 2001 From: nixo Date: Sat, 18 Jan 2020 15:14:32 +0100 Subject: [PATCH
    01/11] gnu: julia: Update to 1.3.1. 
 
 Content analysis details:   (1.9 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: githubusercontent.com]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.128.41 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.128.41 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.9 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Sorry again, I fixed some unrelated changes that slipped in

Thanks, Nicol=C3=B2


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: attachment;
 filename=0001-gnu-julia-Update-to-1.3.1.patch
Content-Transfer-Encoding: quoted-printable

From ae58a1dd7b24989e281b07d9a90e1bb6de5199e2 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 15:14:32 +0100
Subject: [PATCH 01/11] gnu: julia: Update to 1.3.1.

* gnu/packages/julia.scm (julia): Update to 1.3.1.
---
 gnu/packages/julia.scm | 281 +++++++++++++++++------------------------
 1 file changed, 115 insertions(+), 166 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..3455dc6239 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2015, 2016, 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2016 Efraim Flashner <efraim@HIDDEN>
+;;; Copyright =C2=A9 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages base)
   #:use-module (gnu packages compression)
+  #:use-module (gnu packages curl)
   #:use-module (gnu packages elf)
   #:use-module (gnu packages gcc)
   #:use-module (gnu packages llvm)
@@ -43,18 +45,30 @@
   #:use-module (gnu packages textutils)
   #:use-module (gnu packages tls)
   #:use-module (gnu packages version-control)
+  #:use-module (gnu packages ssh)
   #:use-module (gnu packages wget)
   #:use-module (ice-9 match))
=20
+(define (julia-patch-url version name)
+  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
+		 "/deps/patches/" name ".patch"))
+
+(define (julia-patch name sha)
+  (let ((version "1.3.1"))
+    (origin (method url-fetch)
+	    (uri (julia-patch-url version name))
+	    (sha256 (base32 sha))
+	    (file-name name))))
+
 (define libuv-julia
-  (let ((commit "26dbe5672c33fc885462c509fe2a9b36f35866fd")
-        (revision "6"))
+  (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
     ;; When upgrading Julia, also upgrade this.
-    ;; Get the commit from https://github.com/JuliaLang/julia/blob/v1.1.1/=
deps/libuv.version
+    ;; Get the commit from
+    ;; https://github.com/JuliaLang/julia/blob/v1.3.1/deps/libuv.version
     (package
       (inherit libuv)
       (name "libuv-julia")
-      (version (string-append "1.9.0-" revision "." (string-take commit 8)=
))
+      (version (string-append "2.0.0" "." (string-take commit 8)))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -63,7 +77,7 @@
                 (file-name (string-append name "-" version "-checkout"))
                 (sha256
                  (base32
-                  "17pn2xmqaramilx897s9grs966i5246gi6sric5alch4g9j4685n"))=
))
+                  "0dn3v6fdp1z382pqg3nhjzk60l61ky9b65mfgaj29fv2da95rwjs"))=
))
       (build-system gnu-build-system)
       (arguments
        (substitute-keyword-arguments (package-arguments libuv)
@@ -72,16 +86,27 @@
              (delete 'autogen)))))
       (home-page "https://github.com/JuliaLang/libuv"))))
=20
-(define (llvm-patch-url version name)
-  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
-		 "/deps/patches/" name))
-
-(define (llvm-patch name sha)
-  (let ((version "1.1.1"))
-    (origin (method url-fetch)
-	    (uri (llvm-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+(define libunwind-julia
+  ;; julia requires a patched version
+  (package
+    (inherit libunwind)
+    (name "libunwind-julia")
+    (version "1.3.1")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "mirror://savannah/libunwind/libunwind-"
+                                  version ".tar.gz"))
+              (sha256
+               (base32
+                "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
+              (patches
+               (list
+	        (julia-patch "libunwind-prefer-extbl"
+                             "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hh=
xfgnh2m1")
+                (julia-patch "libunwind-static-arm"
+                             "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic87=
0zh3lhgq")))))
+    (build-system gnu-build-system)
+    (home-page "https://github.com/JuliaLang/libuv")))
=20
 (define llvm-julia
   (package
@@ -99,39 +124,39 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi=
?bug=3D919628
               (patches
                (list
-	        (llvm-patch "llvm-6.0-D44650.patch"
+	        (julia-patch "llvm-6.0-D44650"
 			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (llvm-patch "llvm-6.0-DISABLE_ABI_CHECKS.patch"
+	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
 			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (llvm-patch "llvm-6.0-NVPTX-addrspaces.patch"
+	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
 			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (llvm-patch "llvm-6.0.0_D27296-libssp.patch"
+	        (julia-patch "llvm-6.0.0_D27296-libssp"
 			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (llvm-patch "llvm-D27629-AArch64-large_model_6.0.1.patch"
+	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
 			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (llvm-patch "llvm-D34078-vectorize-fdiv.patch"
+	        (julia-patch "llvm-D34078-vectorize-fdiv"
 			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (llvm-patch "llvm-D42262-jumpthreading-not-i1.patch"
+	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
 			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (llvm-patch "llvm-D44892-Perf-integration.patch"
+	        (julia-patch "llvm-D44892-Perf-integration"
 			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (llvm-patch "llvm-D46460.patch"
+	        (julia-patch "llvm-D46460"
 			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (llvm-patch "llvm-D49832-SCEVPred.patch"
+	        (julia-patch "llvm-D49832-SCEVPred"
 			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (llvm-patch "llvm-D50010-VNCoercion-ni.patch"
+	        (julia-patch "llvm-D50010-VNCoercion-ni"
 			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (llvm-patch "llvm-D50167-scev-umin.patch"
+	        (julia-patch "llvm-D50167-scev-umin"
 			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (llvm-patch "llvm-OProfile-line-num.patch"
+	        (julia-patch "llvm-OProfile-line-num"
 			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (llvm-patch "llvm-PPC-addrspaces.patch"
+	        (julia-patch "llvm-PPC-addrspaces"
 			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (llvm-patch "llvm-rL323946-LSRTy.patch"
+	        (julia-patch "llvm-rL323946-LSRTy"
 			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (llvm-patch "llvm-rL326967-aligned-load.patch"
+	        (julia-patch "llvm-rL326967-aligned-load"
 			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (llvm-patch "llvm-rL327898.patch"
+	        (julia-patch "llvm-rL327898"
 			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
@@ -158,7 +183,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.3.1")
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -166,7 +191,7 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "0hk983mywimclgnjc41zmlppm5kfdz2aj85ky07p49ilcqxi998f"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
@@ -188,30 +213,24 @@
          (add-after 'unpack 'prepare-deps
            (lambda* (#:key inputs #:allow-other-keys)
              (mkdir "deps/srccache")
-             (copy-file (assoc-ref inputs "dsfmt")
-                        "deps/srccache/dsfmt-2.2.3.tar.gz")
+             ;; no USE_SYSTEM_{OBJCONV/LIBWHICH}
              (copy-file (assoc-ref inputs "objconv")
                         "deps/srccache/objconv.zip")
-             (copy-file (assoc-ref inputs "suitesparse")
-                        "deps/srccache/SuiteSparse-4.4.5.tar.gz")
-             (copy-file (string-append (assoc-ref inputs "virtualenv")
-                                       "/bin/virtualenv")
-                        "julia-env")
              (copy-file (assoc-ref inputs "libwhich")
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9c=
e7e89e"
                                        ".tar.gz"))
-             (copy-file (assoc-ref inputs "rmath")
-                        "deps/srccache/Rmath-julia-0.1.tar.gz")
-
 	     ;; needed by libwhich
 	     (setenv "LD_LIBRARY_PATH"
 		     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs =
pkg)
                                                         "/lib"))
-                                       '("arpack-ng" "fftw" "gmp" "lapack"
-			                 "libgit2" "mpfr" "openblas" "openlibm"
-			                 "openspecfun" "pcre2"))
+                                       '("arpack-ng" "curl" "dsfmt"
+                                         "gmp" "lapack"
+                                         "libssh2" "libgit2"
+                                         "mbedtls" "mpfr"
+                                         "openblas" "openlibm" "pcre2"
+                                         "suitesparse"))
                                   ":"))
 	     #t))
          ;; FIXME: Building the documentation requires Julia packages that
@@ -233,44 +252,12 @@
           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is n=
ot
           ;; used in Guix, we patch runtime_ccall.cpp to contain a static =
map.
           (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix Sys=
tem.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
-
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] =3D "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";=
")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.s=
o")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.=
so"))))))
             (substitute* "base/math.jl"
               (("const libm =3D Base.libm_name")
                (string-append "const libm =3D \""
                               (assoc-ref inputs "openlibm")
                               "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun =3D \"libopenspecfun\"")
-               (string-append "const openspecfun =3D \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+                              "\"")))))
          (add-before 'build 'fix-include-and-link-paths
           (lambda* (#:key inputs #:allow-other-keys)
             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
@@ -278,10 +265,10 @@
             ;; collection of build targets and a list of libraries to link
             ;; against.
             (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(L=
IBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) =
\\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OB=
JS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DO=
BJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_=
debug)"))
=20
             ;; The REPL must be linked with libuv.
             (substitute* "ui/Makefile"
@@ -296,43 +283,34 @@
                               "/include/uv/errno.h")))
             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
-         (add-after 'unpack 'hardcode-paths
            (lambda _
-             (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
-               (("`which") (string-append "`" (which "which")))
-               (("`wget")  (string-append "`" (which "wget"))))
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
              #t))
-         (add-before 'check 'disable-broken-tests
+         (add-before 'check 'fix-broken-tests
            (lambda _
-             (define (touch file-name)
-               (call-with-output-file file-name (const #t)))
-	     ;; FIXME: All git tests works except this one. But *THIS* "fix"
-             ;; is not working, so right now I'm disabling all libgit2.jl =
tests
-	     ;; (substitute* "stdlib/LibGit2/test/libgit2.jl"
-	     ;; (("!LibGit2.use_http_path(cfg, github_cred)") "true")
-	     ;; (("LibGit2.use_http_path(cfg, mygit_cred)") "true"))
-             (map (lambda (test)
-                    (delete-file test)
-                    (touch test))
-	          '("stdlib/Sockets/test/runtests.jl"
-		    "stdlib/Distributed/test/runtests.jl"
-                    ;; FIXME: see above
-		    "stdlib/LibGit2/test/libgit2.jl"))
-	     (substitute* "test/choosetests.jl"
-	       ;; These tests fail, probably because some of the input
-	       ;; binaries have been stripped and thus backtraces don't look
-	       ;; as expected.
-	       (("\"backtrace\",") "")
-	       (("\"cmdlineargs\",") ""))
+             (substitute* "test/choosetests.jl"
+               (("tests =3D testnames")
+                ;; Those failings are not deterministic.  They depends on =
the
+                ;; running order.  I think it depends on the number of
+                ;; runners, disabling it for now
+                ;; https://github.com/JuliaLang/julia/issues/34330
+                "tests =3D filter(e->!in(e,[\"backtrace\",\"exceptions\",\=
"client\",
+                                          \"stacktraces\",\"stress\",\"pre=
compile\"]),
+                                testnames)"))
+             ;; When HOME is not set, julia calls uv_os_homedir, which in
+             ;; turns call getpwuid_r. Add the HOME env variable to the
+             ;; external julia call to fix this
+             (substitute* "test/cmdlineargs.jl"
+               (("\"JULIA_PROJECT\"") "\"HOME\"=3D>\"/tmp\", \"JULIA_PROJE=
CT\""))
+             ;; Marking the test as broken as it's a known bug:
+             ;; https://github.com/JuliaLang/julia/issues/32377
+             (substitute* "stdlib/REPL/test/replcompletions.jl"
+               (("@test count") "@test_broken count"))
 	     #t)))
        #:make-flags
        (list
         (string-append "prefix=3D" (assoc-ref %outputs "out"))
-        (string-append "PREFIX=3D" (assoc-ref %outputs "out"))
=20
         ;; Passing the MARCH flag is necessary to build binary substitutes=
 for
         ;; the supported architectures.
@@ -345,26 +323,21 @@
            ;; platforms, e.g. when running "guix package --search=3D"
            (_ "MARCH=3DUNSUPPORTED"))
=20
-        "CONFIG_SHELL=3Dbash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=3D0"    ;not packaged for Guix and upstream has =
no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=3Dbash"             ;needed to build bundled librari=
es
+        ;; list of "USE_SYSTEM_*" is here:
+        ;; https://github.com/JuliaLang/julia/blob/v1.3.1/Make.inc
+        "USE_SYSTEM_DSFMT=3D1"
+        "USE_SYSTEM_P7ZIP=3D1"
         "USE_SYSTEM_LAPACK=3D1"
         "USE_SYSTEM_BLAS=3D1"
         "USE_BLAS64=3D0"          ;needed when USE_SYSTEM_BLAS=3D1
         "LIBBLAS=3D-lopenblas"
         "LIBBLASNAME=3Dlibopenblas"
=20
-        "USE_SYSTEM_FFTW=3D1"
-        "LIBFFTWNAME=3Dlibfftw3"
-        "LIBFFTWFNAME=3Dlibfftw3f"
-
-        ;; TODO: Suitesparse does not install shared libraries, so we cann=
ot
-        ;; use the suitesparse package.
-        ;; "USE_SYSTEM_SUITESPARSE=3D1"
-        ;; (string-append "SUITESPARSE_INC=3D-I "
-        ;;                (assoc-ref %build-inputs "suitesparse")
-        ;;                "/include")
-
+        "USE_SYSTEM_SUITESPARSE=3D1"
+        (string-append "SUITESPARSE_INC=3D-I "
+                       (assoc-ref %build-inputs "suitesparse")
+                       "/include")
         "USE_GPL_LIBS=3D1"        ;proudly
         "USE_SYSTEM_UTF8PROC=3D1"
         (string-append "UTF8PROC_INC=3D"
@@ -385,16 +358,19 @@
 	"USE_SYSTEM_PATCHELF=3D1"
 	"USE_SYSTEM_PCRE=3D1"
 	"USE_SYSTEM_OPENLIBM=3D1"
-
+        "USE_SYSTEM_LIBM=3D0"
+        "USE_SYSTEM_LIBSSH2=3D1"
+        "USE_SYSTEM_CURL=3D1"
 	"USE_SYSTEM_GMP=3D1"
 	"USE_SYSTEM_MPFR=3D1"
+	"USE_SYSTEM_MBEDTLS=3D1"
 	"USE_SYSTEM_ARPACK=3D1"
 	"USE_SYSTEM_LIBGIT2=3D1"
-	"USE_SYSTEM_ZLIB=3D1"
-	"USE_SYSTEM_OPENSPECFUN=3D1")))
+	"USE_SYSTEM_ZLIB=3D1")))
     (inputs
      `(("llvm" ,llvm-julia)
=20
+       ("p7zip" ,p7zip)
        ;; The bundled version is 3.3.0 so stick to that version.  With oth=
er
        ;; versions, we get test failures in 'linalg/arnoldi' as described =
in
        ;; <https://bugs.gnu.org/30282>.
@@ -403,12 +379,12 @@
        ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
        ("openblas" ,openblas) ;Julia does not build with Atlas
-       ("libunwind" ,libunwind)
+       ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
-       ("openspecfun" ,openspecfun)
+       ("mbedtls" ,mbedtls-apache)
+       ("curl" ,curl)
        ("libgit2" ,libgit2)
-       ("fftw" ,fftw)
-       ("fftwf" ,fftwf)
+       ("libssh2" ,libssh2)
        ("fortran" ,gfortran)
        ("libuv" ,libuv-julia)
        ("pcre2" ,pcre2)
@@ -418,31 +394,12 @@
        ("which" ,which)
        ("zlib" ,zlib)
        ("gmp" ,gmp)
-       ("virtualenv" ,python2-virtualenv)
+       ("suitesparse" ,suitesparse)
        ;; FIXME: The following inputs are downloaded from upstream to allo=
w us
        ;; to use the lightweight Julia release tarball.  Ideally, these in=
puts
        ;; would eventually be replaced with proper Guix packages.
-
-       ;; TODO: run "make -f contrib/repackage_system_suitesparse4.make" t=
o copy static lib
-       ;; Find dependency versions here:
-       ;; https://raw.githubusercontent.com/JuliaLang/julia/77a2c1e245c858=
12dc1c7687540beedecc52758f/deps/Versions.make
-       ("rmath"
-	,(origin
-	   (method git-fetch)
-	   (uri (git-reference
-                 (url "https://github.com/JuliaLang/Rmath-julia")
-                 (commit "v0.1")))
-           (file-name "rmath-julia-0.1-checkout")
-	   (sha256
-	    (base32
-	     "1zkpy0cg5zivq40zbhbdgj9128fqzs2j94wkwih8nc6xaj3gp9p6"))))
-       ("suitesparse"
-        ,(origin
-           (method url-fetch)
-           (uri "http://faculty.cse.tamu.edu/davis/SuiteSparse/SuiteSparse=
-4.4.5.tar.gz")
-           (sha256
-            (base32
-             "1jcbxb8jx5wlcixzf6n5dca2rcfx6mlcms1k2rl5gp67ay3bix43"))))
+       ;; Find dependencies versions here:
+       ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Ve=
rsions.make
        ("objconv"
         ,(origin
            (method url-fetch)
@@ -467,15 +424,7 @@
 	     (sha256
 	      (base32
 	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
-       ("dsfmt"
-        ,(origin
-           (method url-fetch)
-           (uri (string-append
-                 "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/"
-                 "SFMT/dSFMT-src-2.2.3.tar.gz"))
-           (sha256
-            (base32
-             "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))))))
+       ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
        ("perl" ,perl)
--=20
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0002-gnu-julia-use-SOURCE_DATE_EPOCH-for-precompilation-t.patch

From f849311d8b97688966d5e6d93d856c7c50d9eab2 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 13:58:37 +0100
Subject: [PATCH 02/11] gnu: julia: use SOURCE_DATE_EPOCH for precompilation
 timestamp

* gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch: new file
---
 gnu/local.mk                                  |  1 +
 gnu/packages/julia.scm                        |  4 ++-
 ...ia-fake-mtime-with-SOURCE_DATE_EPOCH.patch | 29 +++++++++++++++++++
 3 files changed, 33 insertions(+), 1 deletion(-)
 create mode 100644 gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch

diff --git a/gnu/local.mk b/gnu/local.mk
index 00ff3b8d61..fe8634b44d 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1010,6 +1010,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/java-xerces-bootclasspath.patch	\
   %D%/packages/patches/java-xerces-build_dont_unzip.patch	\
   %D%/packages/patches/java-xerces-xjavac_taskdef.patch	\
+  %D%/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch      \
   %D%/packages/patches/jbig2dec-ignore-testtest.patch		\
   %D%/packages/patches/kdbusaddons-kinit-file-name.patch	\
   %D%/packages/patches/libvirt-create-machine-cgroup.patch	\
diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 3455dc6239..156dc722f9 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -191,7 +191,9 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))
+              (patches
+               (search-patches "julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
diff --git a/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
new file mode 100644
index 0000000000..467e6d68d1
--- /dev/null
+++ b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
@@ -0,0 +1,29 @@
+From e4dc28db1d70819505fd1a68fd9d2bfc4fb61a7d Mon Sep 17 00:00:00 2001
+From: nixo <nicolo@HIDDEN>
+Date: Fri, 17 Jan 2020 11:28:30 +0100
+Subject: [PATCH] base: loading: support fake mtime with SOURCE_DATE_EPCOCH
+
+Do this when loading libraries
+---
+ base/loading.jl | 5 ++++-
+ 1 file changed, 4 insertions(+), 1 deletion(-)
+
+diff --git a/base/loading.jl b/base/loading.jl
+index 7f11a2d4fc..1b4686d1dc 100644
+--- a/base/loading.jl
++++ b/base/loading.jl
+@@ -807,7 +807,10 @@ function _include_dependency(mod::Module, _path::AbstractString)
+         path = normpath(joinpath(dirname(prev), _path))
+     end
+     if _track_dependencies[]
+-        push!(_require_dependencies, (mod, path, mtime(path)))
++        push!(_require_dependencies,
++              (mod, path,
++               haskey(ENV, "SOURCE_DATE_EPOCH") ?
++               parse(Float64, ENV["SOURCE_DATE_EPOCH"]) : mtime(path)))
+     end
+     return path, prev
+ end
+-- 
+2.24.1
+
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0003-gnu-julia-Adjust-indentation.patch

From 5d453dbdc1939a4a334730bab55d20c48a8afcf0 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Fri, 10 Jan 2020 10:25:49 +0100
Subject: [PATCH 03/11] gnu: julia: Adjust indentation.

* gnu/packages/julia.scm (julia): Correct indentation, untabify
---
 gnu/packages/julia.scm | 216 ++++++++++++++++++++---------------------
 1 file changed, 108 insertions(+), 108 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 156dc722f9..40924b0ced 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -51,14 +51,14 @@
 
 (define (julia-patch-url version name)
   (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" version
-		 "/deps/patches/" name ".patch"))
+                 "/deps/patches/" name ".patch"))
 
 (define (julia-patch name sha)
   (let ((version "1.3.1"))
     (origin (method url-fetch)
-	    (uri (julia-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+            (uri (julia-patch-url version name))
+            (sha256 (base32 sha))
+            (file-name name))))
 
 (define libuv-julia
   (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
@@ -101,7 +101,7 @@
                 "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
               (patches
                (list
-	        (julia-patch "libunwind-prefer-extbl"
+                (julia-patch "libunwind-prefer-extbl"
                              "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hhxfgnh2m1")
                 (julia-patch "libunwind-static-arm"
                              "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic870zh3lhgq")))))
@@ -124,45 +124,45 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=919628
               (patches
                (list
-	        (julia-patch "llvm-6.0-D44650"
-			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
-			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
-			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (julia-patch "llvm-6.0.0_D27296-libssp"
-			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
-			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (julia-patch "llvm-D34078-vectorize-fdiv"
-			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
-			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (julia-patch "llvm-D44892-Perf-integration"
-			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (julia-patch "llvm-D46460"
-			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (julia-patch "llvm-D49832-SCEVPred"
-			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (julia-patch "llvm-D50010-VNCoercion-ni"
-			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (julia-patch "llvm-D50167-scev-umin"
-			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (julia-patch "llvm-OProfile-line-num"
-			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (julia-patch "llvm-PPC-addrspaces"
-			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (julia-patch "llvm-rL323946-LSRTy"
-			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (julia-patch "llvm-rL326967-aligned-load"
-			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (julia-patch "llvm-rL327898"
-			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
+                (julia-patch "llvm-6.0-D44650"
+                            "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
+                (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
+                            "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
+                (julia-patch "llvm-6.0-NVPTX-addrspaces"
+                            "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
+                (julia-patch "llvm-6.0.0_D27296-libssp"
+                            "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
+                (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
+                            "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
+                (julia-patch "llvm-D34078-vectorize-fdiv"
+                            "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
+                (julia-patch "llvm-D42262-jumpthreading-not-i1"
+                            "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
+                (julia-patch "llvm-D44892-Perf-integration"
+                            "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
+                (julia-patch "llvm-D46460"
+                            "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
+                (julia-patch "llvm-D49832-SCEVPred"
+                            "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
+                (julia-patch "llvm-D50010-VNCoercion-ni"
+                            "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
+                (julia-patch "llvm-D50167-scev-umin"
+                            "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
+                (julia-patch "llvm-OProfile-line-num"
+                            "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
+                (julia-patch "llvm-PPC-addrspaces"
+                            "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
+                (julia-patch "llvm-rL323946-LSRTy"
+                            "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
+                (julia-patch "llvm-rL326967-aligned-load"
+                            "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
+                (julia-patch "llvm-rL327898"
+                            "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
        ((#:configure-flags flags)
         `(list ;; Taken from NixOS. Only way I could get libLLVM-6.0.so
-	  "-DCMAKE_BUILD_TYPE=Release"
+          "-DCMAKE_BUILD_TYPE=Release"
 
           ;; Build a native compiler and the NVPTX backend (NVIDIA) since
           ;; Julia insists on it, nothing more.  This reduces build times and
@@ -170,15 +170,15 @@
           ,(string-append "-DLLVM_TARGETS_TO_BUILD=" (system->llvm-target))
           "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=NVPTX"
 
-	  "-DLLVM_INSTALL_UTILS=ON"
-	  "-DLLVM_BUILD_TESTS=ON"
-	  "-DLLVM_ENABLE_FFI=ON"
-	  "-DLLVM_ENABLE_RTTI=ON"
+          "-DLLVM_INSTALL_UTILS=ON"
+          "-DLLVM_BUILD_TESTS=ON"
+          "-DLLVM_ENABLE_FFI=ON"
+          "-DLLVM_ENABLE_RTTI=ON"
           ;; "-DLLVM_HOST_TRIPLE=${stdenv.hostPlatform.config}"
           ;; "-DLLVM_DEFAULT_TARGET_TRIPLE=${stdenv.hostPlatform.config}"
-	  ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
-	  "-DLLVM_ENABLE_DUMP=ON"
-	  "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
+          ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
+          "-DLLVM_ENABLE_DUMP=ON"
+          "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
 
 (define-public julia
   (package
@@ -222,9 +222,9 @@
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"
                                        ".tar.gz"))
-	     ;; needed by libwhich
-	     (setenv "LD_LIBRARY_PATH"
-		     (string-join (map (lambda (pkg)
+             ;; needed by libwhich
+             (setenv "LD_LIBRARY_PATH"
+                     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs pkg)
                                                         "/lib"))
                                        '("arpack-ng" "curl" "dsfmt"
@@ -234,7 +234,7 @@
                                          "openblas" "openlibm" "pcre2"
                                          "suitesparse"))
                                   ":"))
-	     #t))
+             #t))
          ;; FIXME: Building the documentation requires Julia packages that
          ;; would be downloaded from the Internet.  We should build them in a
          ;; separate build phase.
@@ -250,40 +250,40 @@
            ;; Some tests require a home directory to be set.
            (lambda _ (setenv "HOME" "/tmp") #t))
          (add-after 'unpack 'hardcode-soname-map
-          ;; ./src/runtime_ccall.cpp creates a map from library names to paths
-          ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
-          ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
-          (lambda* (#:key inputs #:allow-other-keys)
-            (substitute* "base/math.jl"
-              (("const libm = Base.libm_name")
-               (string-append "const libm = \""
-                              (assoc-ref inputs "openlibm")
-                              "/lib/libopenlibm.so"
-                              "\"")))))
+           ;; ./src/runtime_ccall.cpp creates a map from library names to paths
+           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
+           ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
+           (lambda* (#:key inputs #:allow-other-keys)
+             (substitute* "base/math.jl"
+               (("const libm = Base.libm_name")
+                (string-append "const libm = \""
+                               (assoc-ref inputs "openlibm")
+                               "/lib/libopenlibm.so"
+                               "\"")))))
          (add-before 'build 'fix-include-and-link-paths
-          (lambda* (#:key inputs #:allow-other-keys)
-            ;; LIBUTF8PROC is a linker flag, not a build target.  It is
-            ;; included in the LIBFILES_* variable which is used as a
-            ;; collection of build targets and a list of libraries to link
-            ;; against.
-            (substitute* "src/flisp/Makefile"
+           (lambda* (#:key inputs #:allow-other-keys)
+             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
+             ;; included in the LIBFILES_* variable which is used as a
+             ;; collection of build targets and a list of libraries to link
+             ;; against.
+             (substitute* "src/flisp/Makefile"
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OBJS\\) \\$\\(LIBFILES_release\\)")
                 "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DOBJS\\) \\$\\(LIBFILES_debug\\)")
                 "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_debug)"))
 
-            ;; The REPL must be linked with libuv.
-            (substitute* "ui/Makefile"
-              (("JLDFLAGS \\+= ")
-               (string-append "JLDFLAGS += "
-                              (assoc-ref %build-inputs "libuv")
-                              "/lib/libuv.so ")))
+             ;; The REPL must be linked with libuv.
+             (substitute* "ui/Makefile"
+               (("JLDFLAGS \\+= ")
+                (string-append "JLDFLAGS += "
+                               (assoc-ref %build-inputs "libuv")
+                               "/lib/libuv.so ")))
 
-            (substitute* "base/Makefile"
-              (("\\$\\(build_includedir\\)/uv/errno.h")
-               (string-append (assoc-ref inputs "libuv")
-                              "/include/uv/errno.h")))
-            #t))
+             (substitute* "base/Makefile"
+               (("\\$\\(build_includedir\\)/uv/errno.h")
+                (string-append (assoc-ref inputs "libuv")
+                               "/include/uv/errno.h")))
+             #t))
          (add-before 'build 'replace-default-shell
            (lambda _
              (substitute* "base/client.jl"
@@ -309,7 +309,7 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-	     #t)))
+             #t)))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
@@ -332,7 +332,7 @@
         "USE_SYSTEM_P7ZIP=1"
         "USE_SYSTEM_LAPACK=1"
         "USE_SYSTEM_BLAS=1"
-        "USE_BLAS64=0"          ;needed when USE_SYSTEM_BLAS=1
+        "USE_BLAS64=0"                  ;needed when USE_SYSTEM_BLAS=1
         "LIBBLAS=-lopenblas"
         "LIBBLASNAME=libopenblas"
 
@@ -340,35 +340,35 @@
         (string-append "SUITESPARSE_INC=-I "
                        (assoc-ref %build-inputs "suitesparse")
                        "/include")
-        "USE_GPL_LIBS=1"        ;proudly
+        "USE_GPL_LIBS=1"                ;proudly
         "USE_SYSTEM_UTF8PROC=1"
         (string-append "UTF8PROC_INC="
                        (assoc-ref %build-inputs "utf8proc")
                        "/include")
         "USE_SYSTEM_LLVM=1"
-	"LLVM_VER=6.0.1"
+        "LLVM_VER=6.0.1"
 
-	"USE_LLVM_SHLIB=1"
-	"USE_SYSTEM_LIBUNWIND=1"
-	"USE_SYSTEM_LIBUV=1"
-	(string-append "LIBUV="
-		       (assoc-ref %build-inputs "libuv")
-		       "/lib/libuv.so")
-	(string-append "LIBUV_INC="
-		       (assoc-ref %build-inputs "libuv")
-		       "/include")
-	"USE_SYSTEM_PATCHELF=1"
-	"USE_SYSTEM_PCRE=1"
-	"USE_SYSTEM_OPENLIBM=1"
+        "USE_LLVM_SHLIB=1"
+        "USE_SYSTEM_LIBUNWIND=1"
+        "USE_SYSTEM_LIBUV=1"
+        (string-append "LIBUV="
+                       (assoc-ref %build-inputs "libuv")
+                       "/lib/libuv.so")
+        (string-append "LIBUV_INC="
+                       (assoc-ref %build-inputs "libuv")
+                       "/include")
+        "USE_SYSTEM_PATCHELF=1"
+        "USE_SYSTEM_PCRE=1"
+        "USE_SYSTEM_OPENLIBM=1"
         "USE_SYSTEM_LIBM=0"
         "USE_SYSTEM_LIBSSH2=1"
         "USE_SYSTEM_CURL=1"
-	"USE_SYSTEM_GMP=1"
-	"USE_SYSTEM_MPFR=1"
-	"USE_SYSTEM_MBEDTLS=1"
-	"USE_SYSTEM_ARPACK=1"
-	"USE_SYSTEM_LIBGIT2=1"
-	"USE_SYSTEM_ZLIB=1")))
+        "USE_SYSTEM_GMP=1"
+        "USE_SYSTEM_MPFR=1"
+        "USE_SYSTEM_MBEDTLS=1"
+        "USE_SYSTEM_ARPACK=1"
+        "USE_SYSTEM_LIBGIT2=1"
+        "USE_SYSTEM_ZLIB=1")))
     (inputs
      `(("llvm" ,llvm-julia)
 
@@ -378,9 +378,9 @@
        ;; <https://bugs.gnu.org/30282>.
        ("arpack-ng" ,arpack-ng-3.3.0)
 
-       ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
+       ("coreutils" ,coreutils)         ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
-       ("openblas" ,openblas) ;Julia does not build with Atlas
+       ("openblas" ,openblas)           ;Julia does not build with Atlas
        ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
        ("mbedtls" ,mbedtls-apache)
@@ -412,20 +412,20 @@
             (base32
              "0wp6ld9vk11f4nnkn56627zmlv9k5vafi99qa3yyn1pgcd61zcfs"))))
        ("libwhich"
-	,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
+        ,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
            (origin
              ;; Note: We use a /tarball URL, but that's because Julia's build
              ;; system checks the hash of that tarball; thus we can't use
              ;; 'git-fetch'.
-	     (method url-fetch)
-	     (uri (string-append
+             (method url-fetch)
+             (uri (string-append
                    "https://api.github.com/repos/vtjnash/libwhich/tarball/"
                    commit))
              (file-name (string-append "libwhich-" (string-take commit 7)
                                        ".tar.gz"))
-	     (sha256
-	      (base32
-	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
+             (sha256
+              (base32
+               "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
        ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0004-gnu-julia-use-wrapper-to-set-JULIA_LOAD_PATH-and-JUL.patch

From a14f7c993da9ead8b497de94c112f0a3ec93ef6c Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:23:44 +0100
Subject: [PATCH 04/11] gnu: julia: use wrapper to set JULIA_LOAD_PATH and
 JULIA_DEPOT_PATH

---
 gnu/packages/julia.scm | 20 ++++++++++++++++++--
 1 file changed, 18 insertions(+), 2 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 40924b0ced..39c7d6d34f 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -309,7 +309,20 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-             #t)))
+             #t))
+         (add-after 'install 'make-wrapper
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let* ((out (assoc-ref outputs "out"))
+                    (bin (string-append out "/bin"))
+                    (program "julia"))
+               (with-directory-excursion bin
+                 (wrap-program program
+                   `("JULIA_LOAD_PATH" ":" prefix
+                     ("" "$JULIA_LOAD_PATH")))
+                 (wrap-program program
+                   `("JULIA_DEPOT_PATH" ":" prefix
+                     ("" "$JULIA_DEPOT_PATH"))))
+               #t))))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
@@ -436,7 +449,10 @@
     (native-search-paths
      (list (search-path-specification
             (variable "JULIA_LOAD_PATH")
-            (files (list "share/julia/packages/")))))
+            (files (list "share/julia/packages/")))
+           (search-path-specification
+            (variable "JULIA_DEPOT_PATH")
+            (files (list "share/julia/")))))
     ;; Julia is not officially released for ARM and MIPS.
     ;; See https://github.com/JuliaLang/julia/issues/10639
     (supported-systems '("i686-linux" "x86_64-linux" "aarch64-linux"))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: attachment;
 filename=0005-gnu-build-julia-build-system-fix-package-precompilat.patch
Content-Transfer-Encoding: quoted-printable

From fe7101742199677293cdbbd34be8992c95f7bd8c Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Fri, 17 Jan 2020 19:40:55 +0100
Subject: [PATCH 05/11] gnu: build: julia-build-system: fix package
 precompilation

---
 guix/build/julia-build-system.scm | 51 +++++++++++++------------------
 1 file changed, 22 insertions(+), 29 deletions(-)

diff --git a/guix/build/julia-build-system.scm b/guix/build/julia-build-sys=
tem.scm
index ff6fcf5fe3..dbd4af623d 100644
--- a/guix/build/julia-build-system.scm
+++ b/guix/build/julia-build-system.scm
@@ -1,5 +1,5 @@
 ;;; GNU Guix --- Functional package management for GNU
-;;; Copyright =C2=A9 2019 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
+;;; Copyright =C2=A9 2019, 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,53 +37,46 @@
 ;; subpath where we store the package content
 (define %package-path "/share/julia/packages/")
=20
-(define (generate-load-path inputs outputs)
-  (string-append
-   (string-join (map (match-lambda
-                       ((_ . path)
-                        (string-append path %package-path)))
-                     ;; Restrict to inputs beginning with "julia-".
-                     (filter (match-lambda
-                               ((name . _)
-                                (string-prefix? "julia-" name)))
-                             inputs))
-                ":")
-   (string-append ":" (assoc-ref outputs "out") %package-path)
-   ;; stdlib is always required to find Julia's standard libraries.
-   ;; usually there are other two paths in this variable:
-   ;; "@" and "@v#.#"
-   ":@stdlib"))
-
 (define* (install #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package-dir (string-append out %package-path
-                                     (string-append
-                                      (strip-store-file-name source)))))
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+                                     (strip-store-file-name source))))
     (mkdir-p package-dir)
-    (copy-recursively source package-dir))
+    (copy-recursively (getcwd) package-dir))
   #t)
=20
-;; TODO: Precompilation is working, but I don't know how to tell
-;; julia to use use it. If (on rantime) we set HOME to
-;; store path, julia tries to write files there (failing)
 (define* (precompile #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (builddir (string-append out "/share/julia/"))
          (package (strip-store-file-name source)))
     (mkdir-p builddir)
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
-    ;; Actual precompilation
-    (invoke-julia (string-append "using " package)))
+    ;; add new package dir to the load path
+    (setenv "JULIA_LOAD_PATH"
+            (string-append builddir "packages/" ":"
+                           (or (getenv "JULIA_LOAD_PATH")
+                               "")))
+    ;; Actual precompilation.
+    (invoke-julia
+     ;; when using julia as a user, julia writes precompile cache to the f=
irst
+     ;; entry of the DEPOT_PATH list (by default, the home dir).  We want =
to
+     ;; write it to the store, so let's push the store path as the first
+     ;; element of DEPOT_PATH.  Once the cache file exists, this hack is n=
ot
+     ;; needed anymore (like in the check phase).  If the user install new
+     ;; pacakges, those will be installed and precompiled in the home dir
+     (string-append "pushfirst!(DEPOT_PATH, pop!(DEPOT_PATH)); using " pac=
kage)))
   #t)
=20
 (define* (check #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package (strip-store-file-name source))
          (builddir (string-append out "/share/julia/")))
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+    (setenv "JULIA_LOAD_PATH" (string-append builddir "packages/"))
     (invoke-julia (string-append "using Pkg;Pkg.test(\"" package "\")")))
   #t)
=20
--=20
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0006-gnu-Add-julia-compat.patch

From 607383a2523efd85f8ec454c31fee8fb68b38249 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:05:00 +0100
Subject: [PATCH 06/11] gnu: Add julia-compat.

* gnu/packages/julia-xyz.scm: New file
* gnu/packages/julia-xyz.scm (julia-compat): New variable
---
 gnu/local.mk               |  1 +
 gnu/packages/julia-xyz.scm | 27 +++++++++++++++++++++++++++
 2 files changed, 28 insertions(+)
 create mode 100644 gnu/packages/julia-xyz.scm

diff --git a/gnu/local.mk b/gnu/local.mk
index fe8634b44d..e07229ee20 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -277,6 +277,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/packages/jrnl.scm				\
   %D%/packages/jose.scm				\
   %D%/packages/julia.scm			\
+  %D%/packages/julia-xyz.scm			\
   %D%/packages/jupyter.scm			\
   %D%/packages/kawa.scm				\
   %D%/packages/kde.scm				\
diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
new file mode 100644
index 0000000000..7d9faa63e9
--- /dev/null
+++ b/gnu/packages/julia-xyz.scm
@@ -0,0 +1,27 @@
+(define-module (gnu packages julia-xyz)
+  #:use-module ((guix licenses) #:prefix license:)
+  #:use-module (guix packages)
+  #:use-module (guix git-download)
+  #:use-module (guix build-system julia))
+
+(define-public julia-compat
+  (package
+    (name "julia-compat")
+    (version "3.2.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/Compat.jl")
+             (commit (string-append "v" version))))
+       (file-name "Compat")
+       (sha256
+        (base32 "0d21h3l2ry2mmlhpg7b9cxifayzwcv7r13h5wydcbd5pjf6k4qd4"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/Compat.jl")
+    (synopsis "Compatibility across Julia versions")
+    (description "The Compat package is designed to ease interoperability
+between older and newer versions of the Julia language.  The Compat package
+provides a macro that lets you use the latest syntax in a backwards-compatible
+way.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0007-gnu-Add-julia-inifile.patch

From c503ef2c5421939ed28a7f6a676c9c70f812d3fb Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:06:11 +0100
Subject: [PATCH 07/11] gnu: Add julia-inifile.

* gnu/packages/julia-xyz.scm (julia-inifile): New variable.
---
 gnu/packages/julia-xyz.scm | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 7d9faa63e9..6b8053e5f8 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -25,3 +25,23 @@ between older and newer versions of the Julia language.  The Compat package
 provides a macro that lets you use the latest syntax in a backwards-compatible
 way.")
     (license license:expat)))
+
+(define-public julia-inifile
+  (package
+    (name "julia-inifile")
+    (version "0.5.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaIO/IniFile.jl")
+             (commit "8ba59958495fa276d6489d2c3903e765d75e0bc0")))
+       (file-name "IniFile")
+       (sha256
+        (base32 "11h6f99jpbg729lplw841m68jprka7q3n8yw390bndlmcdsjabpd"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaIO/IniFile.jl")
+    (synopsis "Reading Windows-style INI files")
+    (description "This is a julia package that defines an IniFile type that
+allows to interface with @file{.ini} files")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0008-gnu-Add-julia-sha.patch

From a2ff2e6f01b022972205d4efd47cf06e9ec1899b Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:07:13 +0100
Subject: [PATCH 08/11] gnu: Add julia-sha.

* gnu/packages/julia-xyz.scm (julia-sha): New variable.
---
 gnu/packages/julia-xyz.scm | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 6b8053e5f8..92ffde58e7 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -45,3 +45,26 @@ way.")
     (description "This is a julia package that defines an IniFile type that
 allows to interface with @file{.ini} files")
     (license license:expat)))
+
+(define-public julia-sha
+  (package
+    (name "julia-sha")
+    (version "0.5.7")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/staticfloat/SHA.jl")
+             (commit (string-append "v" version))))
+       (file-name "SHA")
+       (sha256
+        (base32 "10a09kg9z0m8rvwmlgsna6p342kyvizx2axdqc6pzyhraddr8jrp"))))
+    (propagated-inputs `(("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://github.com/staticfloat/SHA.jl")
+    (synopsis
+     "Performant, 100% native-julia SHA1, SHA2, and SHA3 implementation")
+    (description "Julia package implementing SHA algorithms.  Each exported
+function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
+@code{IO} object.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0009-gnu-Add-julia-binaryprovider.patch

From 189ca6851f5f57ce09e65c81e9b8f50ba0008a80 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:07:36 +0100
Subject: [PATCH 09/11] gnu: Add julia-binaryprovider.

* gnu/packages/julia-xyz.scm (julia-binaryprovider): New variable.
---
 gnu/packages/julia-xyz.scm | 33 +++++++++++++++++++++++++++++++++
 1 file changed, 33 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 92ffde58e7..0f8e04b4d1 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -68,3 +68,36 @@ allows to interface with @file{.ini} files")
 function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
 @code{IO} object.")
     (license license:expat)))
+
+(define-public julia-binaryprovider
+  (package
+    (name "julia-binaryprovider")
+    (version "0.5.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaPackaging/BinaryProvider.jl")
+             (commit (string-append "v" version))))
+       (file-name "BinaryProvider")
+       (sha256
+        (base32 "174jmg4w8ncgfhdvfnm0p4cnlayw31j4s9sksqlwz1sipywqvww7"))))
+    (propagated-inputs `(("julia-sha" ,julia-sha)))
+    ;; We don't really need BinaryProvider (as guix provides the binaries) but
+    ;; since it's a dependency of other packages we want to precompile it.
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'disable-engine-probe
+           (lambda _
+             (substitute* "src/BinaryProvider.jl"
+               ;; Precompilation tries to download things from the internet,
+               ;; disable the download part
+               (("probe_platform_engines") "# probe_platform_engines"))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaPackaging/BinaryProvider.jl")
+    (synopsis "Reliable Binary provider for Julia")
+    (description "@code{BinaryProvider.jl} simplifies the installation of
+binaries required by julia packages.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0010-gnu-Add-julia-mbedtls.patch

From 87b37b3f041709a1926f441a9643b723ca2ef8a1 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:11:14 +0100
Subject: [PATCH 10/11] gnu: Add julia-mbedtls.

* gnu/packages/julia-xyz.scm (julia-mbedtls): New variable.
---
 gnu/packages/julia-xyz.scm | 49 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 48 insertions(+), 1 deletion(-)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 0f8e04b4d1..3e9f532697 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -2,7 +2,8 @@
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix packages)
   #:use-module (guix git-download)
-  #:use-module (guix build-system julia))
+  #:use-module (guix build-system julia)
+  #:use-module (gnu packages tls))
 
 (define-public julia-compat
   (package
@@ -101,3 +102,49 @@ function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
     (description "@code{BinaryProvider.jl} simplifies the installation of
 binaries required by julia packages.")
     (license license:expat)))
+
+(define-public julia-mbedtls
+  (package
+    (name "julia-mbedtls")
+    (version "0.7.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/MbedTLS.jl")
+             (commit (string-append "v" version))))
+       (file-name "MbedTLS")
+       (sha256
+        (base32 "1a8snw9gi21lm6r3kh6ly7ngi99s9k5shqkfiizj3g9li20q23h2"))))
+    (propagated-inputs
+     `(("julia-binaryprovider" ,julia-binaryprovider)
+       ("mbedtls-apache" ,mbedtls-apache)))
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-before 'precompile 'build-deps
+           (lambda* (#:key outputs source inputs #:allow-other-keys)
+             (let ((f (open-file
+                       (string-append
+                        (assoc-ref outputs "out")
+                        "/share/julia/packages/"
+                        (string-append
+                         (strip-store-file-name source) "/deps/deps.jl"))
+                       "w")))
+               (display (string-append "const libmbedcrypto = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedcrypto.so\"\n") f)
+               (display (string-append "const libmbedtls = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedtls.so\"\n") f)
+               (display (string-append "const libmbedx509 = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedx509.so\"\n") f)
+               (close-port f))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/MbedTLS.jl")
+    (synopsis "Apache's mbed TLS library wrapper")
+    (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
+cryptography C libary for Julia.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0011-gnu-Add-julia-http.patch

From 488857fdd17d1cb8d479dd18b367b33cb449cd22 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:11:45 +0100
Subject: [PATCH 11/11] gnu: Add julia-http.

* gnu/packages/julia-xyz.scm (julia-http): New variable.
---
 gnu/packages/julia-xyz.scm | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 3e9f532697..ff1bb483f9 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -148,3 +148,27 @@ binaries required by julia packages.")
     (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
 cryptography C libary for Julia.")
     (license license:expat)))
+
+(define-public julia-http
+  (package
+    (name "julia-http")
+    (version "0.8.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaWeb/HTTP.jl")
+             (commit (string-append "v" version))))
+       (file-name "HTTP")
+       (sha256
+        (base32 "0928fvncfp07i5hvqxjyj8i27xmxxllas1m5idqq2i8h7jshzq3y"))))
+    (propagated-inputs
+     `(("julia-inifile" ,julia-inifile)
+       ("julia-mbedtls" ,julia-mbedtls)
+       ("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://juliaweb.github.io/HTTP.jl/")
+    (synopsis "HTTP support for Julia")
+    (description "@code{HTTP.jl} is a Julia library for HTTP Messages,
+implementing both a client and a server.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:59:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:59:42 2020
Received: from localhost ([127.0.0.1]:40723 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isodO-0001E9-DU
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:59:42 -0500
Received: from mail-wm1-f52.google.com ([209.85.128.52]:50780)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isodH-0001Dm-3z
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:59:29 -0500
Received: by mail-wm1-f52.google.com with SMTP id a5so10097201wmb.0
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:59:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:cc:date:message-id:mime-version;
 bh=6vu/fPFsnCpmnhTd17Kv8VExsvNtxxb9wm1ONMXicQA=;
 b=DpYZAbmMlt3euU7ncdAOjE9k9mGjsWgxoJunqTOKHRBOKlNi7E5T+m2vLhAP4Me6il
 rILsoDPz/EQaa889Iy5S+CrYLl39wkAbNOGKymnyI8lMj5aqt0oFbeEF6SFeezYxzoxg
 EM732StktOLIrcOABAzKCk71fBOcLejq+7GSzFV+sOBMt8hVA8uABeVLBV/yZdnbIzJE
 ytD/dfj2X7AVKddHVC7QOB4LkJP6Su2xRbIbN+9urqZ4Nq+tJtgXCGyQf3nOPSbOhMw7
 qg4++wmaJcbzqY1qiNU+SSVhWtR7cvcmB4EOFnp9HaN3UCtDrbflJG1yspZgr8fuL5fa
 vbFg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:cc:date:message-id:mime-version;
 bh=6vu/fPFsnCpmnhTd17Kv8VExsvNtxxb9wm1ONMXicQA=;
 b=R1o/8bJ6YUd2iNypIBe6mmdVYTrN5ZmWU1Vck6zBhUDKJmOoO/WKgSonAR9AbSQ/LX
 Hm+m3gdbcc73c9dj7X9s1lA7yYey4aAwhr5WlZM6yB/7HrgUUsFvZQfCjlZlHnkmRMMC
 4SUAxzfquHvlcPbyhQb+DPc8aXwVzVAyJ6LrvCWrEqI+gmdMvYbRjTxAcX6TejYDrMnu
 H33zLe4FNRKpCw3QrfmOXeGkCvmWisRtcMtPw+DLbMsn54/Q2zYfciVDmH/I0MRYF3Gb
 Xscw3mqOxYtt1yA3tH7B6FDL9BaEyf2iMa1IkdlWEJxp2FEsFVJO+BPJCDepVa7g4N6A
 OT9A==
X-Gm-Message-State: APjAAAULaPyKNyKw6oNS/fzmiufm3vKx2z+UrghS38mdhLSwEQKSXmle
 4GbB6C+MlMxk6MTNciPLBKI=
X-Google-Smtp-Source: APXvYqz0rVgpz3s6i6PJm9eMEOt+66vGCRD/kH1ema9K6OyBJDRhU9PlHHq8q7QRsYyRA53NuWFUrQ==
X-Received: by 2002:a1c:67c3:: with SMTP id b186mr9626146wmc.36.1579355957093; 
 Sat, 18 Jan 2020 05:59:17 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id t25sm14005193wmj.19.2020.01.18.05.59.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:59:15 -0800 (PST)
From: anothersms@HIDDEN (=?utf-8?Q?Nicol=C3=B2?= Balzarotti)
To: 38546 <at> debbugs.gnu.org
Subject: [00/11] Update Julia, Fix precompilation, add HTTP.jl
Date: Sat, 18 Jan 2020 14:59:14 +0100
Message-ID: <87wo9ouaq5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  I'm sending the patches again as attachments since I think
 some of them was badly formatted. From
 74c02f9b22a4d7cf0bc9a98c17ed69af80cacb0e
 Mon Sep 17 00:00:00 2001 From: nixo Date: Thu, 12 Dec 2019 09:43:20 +0100
 Subject: [PATCH 01/11] gnu: julia: Update to 1.3.1. 
 Content analysis details:   (1.9 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: flashner.co.il]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.128.52 listed in list.dnswl.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.128.52 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.9 (/)

--=-=-=
Content-Type: text/plain


I'm sending the patches again as attachments since I think some of them
was badly formatted.


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: attachment;
 filename=0001-gnu-julia-Update-to-1.3.1.patch
Content-Transfer-Encoding: quoted-printable

From 74c02f9b22a4d7cf0bc9a98c17ed69af80cacb0e Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Thu, 12 Dec 2019 09:43:20 +0100
Subject: [PATCH 01/11] gnu: julia: Update to 1.3.1.

* gnu/packages/julia.scm (julia): Update to 1.3.1.
* gnu/packages/julia.scm (libuv-julia): Update to 2.0.0.
---
 gnu/packages/julia.scm | 278 +++++++++++++++++------------------------
 1 file changed, 113 insertions(+), 165 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..e4db39afbd 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2015, 2016, 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2016 Efraim Flashner <efraim@HIDDEN>
+;;; Copyright =C2=A9 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages base)
   #:use-module (gnu packages compression)
+  #:use-module (gnu packages curl)
   #:use-module (gnu packages elf)
   #:use-module (gnu packages gcc)
   #:use-module (gnu packages llvm)
@@ -43,18 +45,30 @@
   #:use-module (gnu packages textutils)
   #:use-module (gnu packages tls)
   #:use-module (gnu packages version-control)
+  #:use-module (gnu packages ssh)
   #:use-module (gnu packages wget)
   #:use-module (ice-9 match))
=20
+(define (julia-patch-url version name)
+  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
+		 "/deps/patches/" name ".patch"))
+
+(define (julia-patch name sha)
+  (let ((version "1.3.1"))
+    (origin (method url-fetch)
+	    (uri (julia-patch-url version name))
+	    (sha256 (base32 sha))
+	    (file-name name))))
+
 (define libuv-julia
-  (let ((commit "26dbe5672c33fc885462c509fe2a9b36f35866fd")
-        (revision "6"))
+  (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
     ;; When upgrading Julia, also upgrade this.
-    ;; Get the commit from https://github.com/JuliaLang/julia/blob/v1.1.1/=
deps/libuv.version
+    ;; Get the commit from
+    ;; https://github.com/JuliaLang/julia/blob/v1.3.1/deps/libuv.version
     (package
       (inherit libuv)
       (name "libuv-julia")
-      (version (string-append "1.9.0-" revision "." (string-take commit 8)=
))
+      (version (string-append "2.0.0" "." (string-take commit 8)))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -63,7 +77,7 @@
                 (file-name (string-append name "-" version "-checkout"))
                 (sha256
                  (base32
-                  "17pn2xmqaramilx897s9grs966i5246gi6sric5alch4g9j4685n"))=
))
+                  "0dn3v6fdp1z382pqg3nhjzk60l61ky9b65mfgaj29fv2da95rwjs"))=
))
       (build-system gnu-build-system)
       (arguments
        (substitute-keyword-arguments (package-arguments libuv)
@@ -72,16 +86,27 @@
              (delete 'autogen)))))
       (home-page "https://github.com/JuliaLang/libuv"))))
=20
-(define (llvm-patch-url version name)
-  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
-		 "/deps/patches/" name))
-
-(define (llvm-patch name sha)
-  (let ((version "1.1.1"))
-    (origin (method url-fetch)
-	    (uri (llvm-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+(define libunwind-julia
+  ;; julia requires a patched version
+  (package
+    (inherit libunwind)
+    (name "libunwind-julia")
+    (version "1.3.1")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "mirror://savannah/libunwind/libunwind-"
+                                  version ".tar.gz"))
+              (sha256
+               (base32
+                "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
+              (patches
+               (list
+	        (julia-patch "libunwind-prefer-extbl"
+                             "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hh=
xfgnh2m1")
+                (julia-patch "libunwind-static-arm"
+                             "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic87=
0zh3lhgq")))))
+    (build-system gnu-build-system)
+    (home-page "https://github.com/JuliaLang/libuv")))
=20
 (define llvm-julia
   (package
@@ -99,39 +124,39 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi=
?bug=3D919628
               (patches
                (list
-	        (llvm-patch "llvm-6.0-D44650.patch"
+	        (julia-patch "llvm-6.0-D44650"
 			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (llvm-patch "llvm-6.0-DISABLE_ABI_CHECKS.patch"
+	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
 			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (llvm-patch "llvm-6.0-NVPTX-addrspaces.patch"
+	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
 			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (llvm-patch "llvm-6.0.0_D27296-libssp.patch"
+	        (julia-patch "llvm-6.0.0_D27296-libssp"
 			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (llvm-patch "llvm-D27629-AArch64-large_model_6.0.1.patch"
+	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
 			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (llvm-patch "llvm-D34078-vectorize-fdiv.patch"
+	        (julia-patch "llvm-D34078-vectorize-fdiv"
 			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (llvm-patch "llvm-D42262-jumpthreading-not-i1.patch"
+	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
 			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (llvm-patch "llvm-D44892-Perf-integration.patch"
+	        (julia-patch "llvm-D44892-Perf-integration"
 			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (llvm-patch "llvm-D46460.patch"
+	        (julia-patch "llvm-D46460"
 			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (llvm-patch "llvm-D49832-SCEVPred.patch"
+	        (julia-patch "llvm-D49832-SCEVPred"
 			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (llvm-patch "llvm-D50010-VNCoercion-ni.patch"
+	        (julia-patch "llvm-D50010-VNCoercion-ni"
 			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (llvm-patch "llvm-D50167-scev-umin.patch"
+	        (julia-patch "llvm-D50167-scev-umin"
 			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (llvm-patch "llvm-OProfile-line-num.patch"
+	        (julia-patch "llvm-OProfile-line-num"
 			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (llvm-patch "llvm-PPC-addrspaces.patch"
+	        (julia-patch "llvm-PPC-addrspaces"
 			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (llvm-patch "llvm-rL323946-LSRTy.patch"
+	        (julia-patch "llvm-rL323946-LSRTy"
 			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (llvm-patch "llvm-rL326967-aligned-load.patch"
+	        (julia-patch "llvm-rL326967-aligned-load"
 			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (llvm-patch "llvm-rL327898.patch"
+	        (julia-patch "llvm-rL327898"
 			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
@@ -158,7 +183,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.3.1")
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -166,7 +191,7 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "0hk983mywimclgnjc41zmlppm5kfdz2aj85ky07p49ilcqxi998f"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
@@ -188,30 +213,24 @@
          (add-after 'unpack 'prepare-deps
            (lambda* (#:key inputs #:allow-other-keys)
              (mkdir "deps/srccache")
-             (copy-file (assoc-ref inputs "dsfmt")
-                        "deps/srccache/dsfmt-2.2.3.tar.gz")
+             ;; no USE_SYSTEM_{OBJCONV/LIBWHICH}
              (copy-file (assoc-ref inputs "objconv")
                         "deps/srccache/objconv.zip")
-             (copy-file (assoc-ref inputs "suitesparse")
-                        "deps/srccache/SuiteSparse-4.4.5.tar.gz")
-             (copy-file (string-append (assoc-ref inputs "virtualenv")
-                                       "/bin/virtualenv")
-                        "julia-env")
              (copy-file (assoc-ref inputs "libwhich")
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9c=
e7e89e"
                                        ".tar.gz"))
-             (copy-file (assoc-ref inputs "rmath")
-                        "deps/srccache/Rmath-julia-0.1.tar.gz")
-
 	     ;; needed by libwhich
 	     (setenv "LD_LIBRARY_PATH"
 		     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs =
pkg)
                                                         "/lib"))
-                                       '("arpack-ng" "fftw" "gmp" "lapack"
-			                 "libgit2" "mpfr" "openblas" "openlibm"
-			                 "openspecfun" "pcre2"))
+                                       '("arpack-ng" "curl" "dsfmt"
+                                         "gmp" "lapack"
+                                         "libssh2" "libgit2"
+                                         "mbedtls" "mpfr"
+                                         "openblas" "openlibm" "pcre2"
+                                         "suitesparse"))
                                   ":"))
 	     #t))
          ;; FIXME: Building the documentation requires Julia packages that
@@ -233,44 +252,12 @@
           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is n=
ot
           ;; used in Guix, we patch runtime_ccall.cpp to contain a static =
map.
           (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix Sys=
tem.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
-
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] =3D "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";=
")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.s=
o")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.=
so"))))))
             (substitute* "base/math.jl"
               (("const libm =3D Base.libm_name")
                (string-append "const libm =3D \""
                               (assoc-ref inputs "openlibm")
                               "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun =3D \"libopenspecfun\"")
-               (string-append "const openspecfun =3D \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+                              "\"")))))
          (add-before 'build 'fix-include-and-link-paths
           (lambda* (#:key inputs #:allow-other-keys)
             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
@@ -278,10 +265,10 @@
             ;; collection of build targets and a list of libraries to link
             ;; against.
             (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(L=
IBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) =
\\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OB=
JS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DO=
BJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_=
debug)"))
=20
             ;; The REPL must be linked with libuv.
             (substitute* "ui/Makefile"
@@ -296,38 +283,28 @@
                               "/include/uv/errno.h")))
             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
-         (add-after 'unpack 'hardcode-paths
            (lambda _
-             (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
-               (("`which") (string-append "`" (which "which")))
-               (("`wget")  (string-append "`" (which "wget"))))
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
              #t))
-         (add-before 'check 'disable-broken-tests
+         (add-before 'check 'fix-broken-tests
            (lambda _
-             (define (touch file-name)
-               (call-with-output-file file-name (const #t)))
-	     ;; FIXME: All git tests works except this one. But *THIS* "fix"
-             ;; is not working, so right now I'm disabling all libgit2.jl =
tests
-	     ;; (substitute* "stdlib/LibGit2/test/libgit2.jl"
-	     ;; (("!LibGit2.use_http_path(cfg, github_cred)") "true")
-	     ;; (("LibGit2.use_http_path(cfg, mygit_cred)") "true"))
-             (map (lambda (test)
-                    (delete-file test)
-                    (touch test))
-	          '("stdlib/Sockets/test/runtests.jl"
-		    "stdlib/Distributed/test/runtests.jl"
-                    ;; FIXME: see above
-		    "stdlib/LibGit2/test/libgit2.jl"))
-	     (substitute* "test/choosetests.jl"
-	       ;; These tests fail, probably because some of the input
-	       ;; binaries have been stripped and thus backtraces don't look
-	       ;; as expected.
-	       (("\"backtrace\",") "")
-	       (("\"cmdlineargs\",") ""))
+             (substitute* "test/choosetests.jl"
+               (("tests =3D testnames")
+                ;; Those failings are not deterministic.  They depends on =
the
+                ;; running order.  I think it depends on the number of
+                ;; runners, disabling it for now
+                ;; https://github.com/JuliaLang/julia/issues/34330
+                "tests =3D filter(e->!in(e,[\"backtrace\",\"exceptions\",\=
"client\",\"stacktraces\"]),testnames)"))
+             ;; When HOME is not set, julia calls uv_os_homedir, which in
+             ;; turns call getpwuid_r. Add the HOME env variable to the
+             ;; external julia call to fix this
+             (substitute* "test/cmdlineargs.jl"
+               (("\"JULIA_PROJECT\"") "\"HOME\"=3D>\"/tmp\", \"JULIA_PROJE=
CT\""))
+             ;; Marking the test as broken as it's a known bug:
+             ;; https://github.com/JuliaLang/julia/issues/32377
+             (substitute* "stdlib/REPL/test/replcompletions.jl"
+               (("@test count") "@test_broken count"))
 	     #t)))
        #:make-flags
        (list
@@ -345,26 +322,21 @@
            ;; platforms, e.g. when running "guix package --search=3D"
            (_ "MARCH=3DUNSUPPORTED"))
=20
-        "CONFIG_SHELL=3Dbash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=3D0"    ;not packaged for Guix and upstream has =
no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=3Dbash"             ;needed to build bundled librari=
es
+        ;; list of "USE_SYSTEM_*" is here:
+        ;; https://github.com/JuliaLang/julia/blob/v1.3.1/Make.inc
+        "USE_SYSTEM_DSFMT=3D1"
+        "USE_SYSTEM_P7ZIP=3D1"
         "USE_SYSTEM_LAPACK=3D1"
         "USE_SYSTEM_BLAS=3D1"
         "USE_BLAS64=3D0"          ;needed when USE_SYSTEM_BLAS=3D1
         "LIBBLAS=3D-lopenblas"
         "LIBBLASNAME=3Dlibopenblas"
=20
-        "USE_SYSTEM_FFTW=3D1"
-        "LIBFFTWNAME=3Dlibfftw3"
-        "LIBFFTWFNAME=3Dlibfftw3f"
-
-        ;; TODO: Suitesparse does not install shared libraries, so we cann=
ot
-        ;; use the suitesparse package.
-        ;; "USE_SYSTEM_SUITESPARSE=3D1"
-        ;; (string-append "SUITESPARSE_INC=3D-I "
-        ;;                (assoc-ref %build-inputs "suitesparse")
-        ;;                "/include")
-
+        "USE_SYSTEM_SUITESPARSE=3D1"
+        (string-append "SUITESPARSE_INC=3D-I "
+                       (assoc-ref %build-inputs "suitesparse")
+                       "/include")
         "USE_GPL_LIBS=3D1"        ;proudly
         "USE_SYSTEM_UTF8PROC=3D1"
         (string-append "UTF8PROC_INC=3D"
@@ -385,16 +357,19 @@
 	"USE_SYSTEM_PATCHELF=3D1"
 	"USE_SYSTEM_PCRE=3D1"
 	"USE_SYSTEM_OPENLIBM=3D1"
-
+        "USE_SYSTEM_LIBM=3D0"
+        "USE_SYSTEM_LIBSSH2=3D1"
+        "USE_SYSTEM_CURL=3D1"
 	"USE_SYSTEM_GMP=3D1"
 	"USE_SYSTEM_MPFR=3D1"
+	"USE_SYSTEM_MBEDTLS=3D1"
 	"USE_SYSTEM_ARPACK=3D1"
 	"USE_SYSTEM_LIBGIT2=3D1"
-	"USE_SYSTEM_ZLIB=3D1"
-	"USE_SYSTEM_OPENSPECFUN=3D1")))
+	"USE_SYSTEM_ZLIB=3D1")))
     (inputs
      `(("llvm" ,llvm-julia)
=20
+       ("p7zip" ,p7zip)
        ;; The bundled version is 3.3.0 so stick to that version.  With oth=
er
        ;; versions, we get test failures in 'linalg/arnoldi' as described =
in
        ;; <https://bugs.gnu.org/30282>.
@@ -403,12 +378,12 @@
        ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
        ("openblas" ,openblas) ;Julia does not build with Atlas
-       ("libunwind" ,libunwind)
+       ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
-       ("openspecfun" ,openspecfun)
+       ("mbedtls" ,mbedtls-apache)
+       ("curl" ,curl)
        ("libgit2" ,libgit2)
-       ("fftw" ,fftw)
-       ("fftwf" ,fftwf)
+       ("libssh2" ,libssh2)
        ("fortran" ,gfortran)
        ("libuv" ,libuv-julia)
        ("pcre2" ,pcre2)
@@ -418,31 +393,12 @@
        ("which" ,which)
        ("zlib" ,zlib)
        ("gmp" ,gmp)
-       ("virtualenv" ,python2-virtualenv)
+       ("suitesparse" ,suitesparse)
        ;; FIXME: The following inputs are downloaded from upstream to allo=
w us
        ;; to use the lightweight Julia release tarball.  Ideally, these in=
puts
        ;; would eventually be replaced with proper Guix packages.
-
-       ;; TODO: run "make -f contrib/repackage_system_suitesparse4.make" t=
o copy static lib
-       ;; Find dependency versions here:
-       ;; https://raw.githubusercontent.com/JuliaLang/julia/77a2c1e245c858=
12dc1c7687540beedecc52758f/deps/Versions.make
-       ("rmath"
-	,(origin
-	   (method git-fetch)
-	   (uri (git-reference
-                 (url "https://github.com/JuliaLang/Rmath-julia")
-                 (commit "v0.1")))
-           (file-name "rmath-julia-0.1-checkout")
-	   (sha256
-	    (base32
-	     "1zkpy0cg5zivq40zbhbdgj9128fqzs2j94wkwih8nc6xaj3gp9p6"))))
-       ("suitesparse"
-        ,(origin
-           (method url-fetch)
-           (uri "http://faculty.cse.tamu.edu/davis/SuiteSparse/SuiteSparse=
-4.4.5.tar.gz")
-           (sha256
-            (base32
-             "1jcbxb8jx5wlcixzf6n5dca2rcfx6mlcms1k2rl5gp67ay3bix43"))))
+       ;; Find dependencies versions here:
+       ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Ve=
rsions.make
        ("objconv"
         ,(origin
            (method url-fetch)
@@ -467,15 +423,7 @@
 	     (sha256
 	      (base32
 	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
-       ("dsfmt"
-        ,(origin
-           (method url-fetch)
-           (uri (string-append
-                 "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/"
-                 "SFMT/dSFMT-src-2.2.3.tar.gz"))
-           (sha256
-            (base32
-             "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))))))
+       ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
        ("perl" ,perl)
--=20
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0002-gnu-julia-use-SOURCE_DATE_EPOCH-for-precompilation-t.patch

From aa245450a7c8a92c29388cc6603ff43f278dfdd7 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 13:58:37 +0100
Subject: [PATCH 02/11] gnu: julia: use SOURCE_DATE_EPOCH for precompilation
 timestamp

* gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch: new file
---
 gnu/local.mk                                  |  1 +
 gnu/packages/julia.scm                        |  4 ++-
 ...ia-fake-mtime-with-SOURCE_DATE_EPOCH.patch | 29 +++++++++++++++++++
 3 files changed, 33 insertions(+), 1 deletion(-)
 create mode 100644 gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch

diff --git a/gnu/local.mk b/gnu/local.mk
index 00ff3b8d61..fe8634b44d 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1010,6 +1010,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/java-xerces-bootclasspath.patch	\
   %D%/packages/patches/java-xerces-build_dont_unzip.patch	\
   %D%/packages/patches/java-xerces-xjavac_taskdef.patch	\
+  %D%/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch      \
   %D%/packages/patches/jbig2dec-ignore-testtest.patch		\
   %D%/packages/patches/kdbusaddons-kinit-file-name.patch	\
   %D%/packages/patches/libvirt-create-machine-cgroup.patch	\
diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index e4db39afbd..a66309b611 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -191,7 +191,9 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))
+              (patches
+               (search-patches "julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
diff --git a/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
new file mode 100644
index 0000000000..467e6d68d1
--- /dev/null
+++ b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
@@ -0,0 +1,29 @@
+From e4dc28db1d70819505fd1a68fd9d2bfc4fb61a7d Mon Sep 17 00:00:00 2001
+From: nixo <nicolo@HIDDEN>
+Date: Fri, 17 Jan 2020 11:28:30 +0100
+Subject: [PATCH] base: loading: support fake mtime with SOURCE_DATE_EPCOCH
+
+Do this when loading libraries
+---
+ base/loading.jl | 5 ++++-
+ 1 file changed, 4 insertions(+), 1 deletion(-)
+
+diff --git a/base/loading.jl b/base/loading.jl
+index 7f11a2d4fc..1b4686d1dc 100644
+--- a/base/loading.jl
++++ b/base/loading.jl
+@@ -807,7 +807,10 @@ function _include_dependency(mod::Module, _path::AbstractString)
+         path = normpath(joinpath(dirname(prev), _path))
+     end
+     if _track_dependencies[]
+-        push!(_require_dependencies, (mod, path, mtime(path)))
++        push!(_require_dependencies,
++              (mod, path,
++               haskey(ENV, "SOURCE_DATE_EPOCH") ?
++               parse(Float64, ENV["SOURCE_DATE_EPOCH"]) : mtime(path)))
+     end
+     return path, prev
+ end
+-- 
+2.24.1
+
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0003-gnu-julia-Adjust-indentation.patch

From 66a9b56bfbc66d5c4c21e5f67c6f759a7f838786 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Fri, 10 Jan 2020 10:25:49 +0100
Subject: [PATCH 03/11] gnu: julia: Adjust indentation.

* gnu/packages/julia.scm (julia): Correct indentation, untabify
---
 gnu/packages/julia.scm | 216 ++++++++++++++++++++---------------------
 1 file changed, 108 insertions(+), 108 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index a66309b611..e1c4685227 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -51,14 +51,14 @@
 
 (define (julia-patch-url version name)
   (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" version
-		 "/deps/patches/" name ".patch"))
+                 "/deps/patches/" name ".patch"))
 
 (define (julia-patch name sha)
   (let ((version "1.3.1"))
     (origin (method url-fetch)
-	    (uri (julia-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+            (uri (julia-patch-url version name))
+            (sha256 (base32 sha))
+            (file-name name))))
 
 (define libuv-julia
   (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
@@ -101,7 +101,7 @@
                 "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
               (patches
                (list
-	        (julia-patch "libunwind-prefer-extbl"
+                (julia-patch "libunwind-prefer-extbl"
                              "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hhxfgnh2m1")
                 (julia-patch "libunwind-static-arm"
                              "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic870zh3lhgq")))))
@@ -124,45 +124,45 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=919628
               (patches
                (list
-	        (julia-patch "llvm-6.0-D44650"
-			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
-			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
-			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (julia-patch "llvm-6.0.0_D27296-libssp"
-			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
-			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (julia-patch "llvm-D34078-vectorize-fdiv"
-			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
-			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (julia-patch "llvm-D44892-Perf-integration"
-			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (julia-patch "llvm-D46460"
-			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (julia-patch "llvm-D49832-SCEVPred"
-			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (julia-patch "llvm-D50010-VNCoercion-ni"
-			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (julia-patch "llvm-D50167-scev-umin"
-			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (julia-patch "llvm-OProfile-line-num"
-			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (julia-patch "llvm-PPC-addrspaces"
-			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (julia-patch "llvm-rL323946-LSRTy"
-			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (julia-patch "llvm-rL326967-aligned-load"
-			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (julia-patch "llvm-rL327898"
-			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
+                (julia-patch "llvm-6.0-D44650"
+                            "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
+                (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
+                            "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
+                (julia-patch "llvm-6.0-NVPTX-addrspaces"
+                            "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
+                (julia-patch "llvm-6.0.0_D27296-libssp"
+                            "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
+                (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
+                            "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
+                (julia-patch "llvm-D34078-vectorize-fdiv"
+                            "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
+                (julia-patch "llvm-D42262-jumpthreading-not-i1"
+                            "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
+                (julia-patch "llvm-D44892-Perf-integration"
+                            "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
+                (julia-patch "llvm-D46460"
+                            "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
+                (julia-patch "llvm-D49832-SCEVPred"
+                            "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
+                (julia-patch "llvm-D50010-VNCoercion-ni"
+                            "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
+                (julia-patch "llvm-D50167-scev-umin"
+                            "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
+                (julia-patch "llvm-OProfile-line-num"
+                            "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
+                (julia-patch "llvm-PPC-addrspaces"
+                            "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
+                (julia-patch "llvm-rL323946-LSRTy"
+                            "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
+                (julia-patch "llvm-rL326967-aligned-load"
+                            "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
+                (julia-patch "llvm-rL327898"
+                            "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
        ((#:configure-flags flags)
         `(list ;; Taken from NixOS. Only way I could get libLLVM-6.0.so
-	  "-DCMAKE_BUILD_TYPE=Release"
+          "-DCMAKE_BUILD_TYPE=Release"
 
           ;; Build a native compiler and the NVPTX backend (NVIDIA) since
           ;; Julia insists on it, nothing more.  This reduces build times and
@@ -170,15 +170,15 @@
           ,(string-append "-DLLVM_TARGETS_TO_BUILD=" (system->llvm-target))
           "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=NVPTX"
 
-	  "-DLLVM_INSTALL_UTILS=ON"
-	  "-DLLVM_BUILD_TESTS=ON"
-	  "-DLLVM_ENABLE_FFI=ON"
-	  "-DLLVM_ENABLE_RTTI=ON"
+          "-DLLVM_INSTALL_UTILS=ON"
+          "-DLLVM_BUILD_TESTS=ON"
+          "-DLLVM_ENABLE_FFI=ON"
+          "-DLLVM_ENABLE_RTTI=ON"
           ;; "-DLLVM_HOST_TRIPLE=${stdenv.hostPlatform.config}"
           ;; "-DLLVM_DEFAULT_TARGET_TRIPLE=${stdenv.hostPlatform.config}"
-	  ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
-	  "-DLLVM_ENABLE_DUMP=ON"
-	  "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
+          ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
+          "-DLLVM_ENABLE_DUMP=ON"
+          "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
 
 (define-public julia
   (package
@@ -222,9 +222,9 @@
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"
                                        ".tar.gz"))
-	     ;; needed by libwhich
-	     (setenv "LD_LIBRARY_PATH"
-		     (string-join (map (lambda (pkg)
+             ;; needed by libwhich
+             (setenv "LD_LIBRARY_PATH"
+                     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs pkg)
                                                         "/lib"))
                                        '("arpack-ng" "curl" "dsfmt"
@@ -234,7 +234,7 @@
                                          "openblas" "openlibm" "pcre2"
                                          "suitesparse"))
                                   ":"))
-	     #t))
+             #t))
          ;; FIXME: Building the documentation requires Julia packages that
          ;; would be downloaded from the Internet.  We should build them in a
          ;; separate build phase.
@@ -250,40 +250,40 @@
            ;; Some tests require a home directory to be set.
            (lambda _ (setenv "HOME" "/tmp") #t))
          (add-after 'unpack 'hardcode-soname-map
-          ;; ./src/runtime_ccall.cpp creates a map from library names to paths
-          ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
-          ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
-          (lambda* (#:key inputs #:allow-other-keys)
-            (substitute* "base/math.jl"
-              (("const libm = Base.libm_name")
-               (string-append "const libm = \""
-                              (assoc-ref inputs "openlibm")
-                              "/lib/libopenlibm.so"
-                              "\"")))))
+           ;; ./src/runtime_ccall.cpp creates a map from library names to paths
+           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
+           ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
+           (lambda* (#:key inputs #:allow-other-keys)
+             (substitute* "base/math.jl"
+               (("const libm = Base.libm_name")
+                (string-append "const libm = \""
+                               (assoc-ref inputs "openlibm")
+                               "/lib/libopenlibm.so"
+                               "\"")))))
          (add-before 'build 'fix-include-and-link-paths
-          (lambda* (#:key inputs #:allow-other-keys)
-            ;; LIBUTF8PROC is a linker flag, not a build target.  It is
-            ;; included in the LIBFILES_* variable which is used as a
-            ;; collection of build targets and a list of libraries to link
-            ;; against.
-            (substitute* "src/flisp/Makefile"
+           (lambda* (#:key inputs #:allow-other-keys)
+             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
+             ;; included in the LIBFILES_* variable which is used as a
+             ;; collection of build targets and a list of libraries to link
+             ;; against.
+             (substitute* "src/flisp/Makefile"
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OBJS\\) \\$\\(LIBFILES_release\\)")
                 "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DOBJS\\) \\$\\(LIBFILES_debug\\)")
                 "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_debug)"))
 
-            ;; The REPL must be linked with libuv.
-            (substitute* "ui/Makefile"
-              (("JLDFLAGS \\+= ")
-               (string-append "JLDFLAGS += "
-                              (assoc-ref %build-inputs "libuv")
-                              "/lib/libuv.so ")))
+             ;; The REPL must be linked with libuv.
+             (substitute* "ui/Makefile"
+               (("JLDFLAGS \\+= ")
+                (string-append "JLDFLAGS += "
+                               (assoc-ref %build-inputs "libuv")
+                               "/lib/libuv.so ")))
 
-            (substitute* "base/Makefile"
-              (("\\$\\(build_includedir\\)/uv/errno.h")
-               (string-append (assoc-ref inputs "libuv")
-                              "/include/uv/errno.h")))
-            #t))
+             (substitute* "base/Makefile"
+               (("\\$\\(build_includedir\\)/uv/errno.h")
+                (string-append (assoc-ref inputs "libuv")
+                               "/include/uv/errno.h")))
+             #t))
          (add-before 'build 'replace-default-shell
            (lambda _
              (substitute* "base/client.jl"
@@ -307,7 +307,7 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-	     #t)))
+             #t)))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
@@ -331,7 +331,7 @@
         "USE_SYSTEM_P7ZIP=1"
         "USE_SYSTEM_LAPACK=1"
         "USE_SYSTEM_BLAS=1"
-        "USE_BLAS64=0"          ;needed when USE_SYSTEM_BLAS=1
+        "USE_BLAS64=0"                  ;needed when USE_SYSTEM_BLAS=1
         "LIBBLAS=-lopenblas"
         "LIBBLASNAME=libopenblas"
 
@@ -339,35 +339,35 @@
         (string-append "SUITESPARSE_INC=-I "
                        (assoc-ref %build-inputs "suitesparse")
                        "/include")
-        "USE_GPL_LIBS=1"        ;proudly
+        "USE_GPL_LIBS=1"                ;proudly
         "USE_SYSTEM_UTF8PROC=1"
         (string-append "UTF8PROC_INC="
                        (assoc-ref %build-inputs "utf8proc")
                        "/include")
         "USE_SYSTEM_LLVM=1"
-	"LLVM_VER=6.0.1"
+        "LLVM_VER=6.0.1"
 
-	"USE_LLVM_SHLIB=1"
-	"USE_SYSTEM_LIBUNWIND=1"
-	"USE_SYSTEM_LIBUV=1"
-	(string-append "LIBUV="
-		       (assoc-ref %build-inputs "libuv")
-		       "/lib/libuv.so")
-	(string-append "LIBUV_INC="
-		       (assoc-ref %build-inputs "libuv")
-		       "/include")
-	"USE_SYSTEM_PATCHELF=1"
-	"USE_SYSTEM_PCRE=1"
-	"USE_SYSTEM_OPENLIBM=1"
+        "USE_LLVM_SHLIB=1"
+        "USE_SYSTEM_LIBUNWIND=1"
+        "USE_SYSTEM_LIBUV=1"
+        (string-append "LIBUV="
+                       (assoc-ref %build-inputs "libuv")
+                       "/lib/libuv.so")
+        (string-append "LIBUV_INC="
+                       (assoc-ref %build-inputs "libuv")
+                       "/include")
+        "USE_SYSTEM_PATCHELF=1"
+        "USE_SYSTEM_PCRE=1"
+        "USE_SYSTEM_OPENLIBM=1"
         "USE_SYSTEM_LIBM=0"
         "USE_SYSTEM_LIBSSH2=1"
         "USE_SYSTEM_CURL=1"
-	"USE_SYSTEM_GMP=1"
-	"USE_SYSTEM_MPFR=1"
-	"USE_SYSTEM_MBEDTLS=1"
-	"USE_SYSTEM_ARPACK=1"
-	"USE_SYSTEM_LIBGIT2=1"
-	"USE_SYSTEM_ZLIB=1")))
+        "USE_SYSTEM_GMP=1"
+        "USE_SYSTEM_MPFR=1"
+        "USE_SYSTEM_MBEDTLS=1"
+        "USE_SYSTEM_ARPACK=1"
+        "USE_SYSTEM_LIBGIT2=1"
+        "USE_SYSTEM_ZLIB=1")))
     (inputs
      `(("llvm" ,llvm-julia)
 
@@ -377,9 +377,9 @@
        ;; <https://bugs.gnu.org/30282>.
        ("arpack-ng" ,arpack-ng-3.3.0)
 
-       ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
+       ("coreutils" ,coreutils)         ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
-       ("openblas" ,openblas) ;Julia does not build with Atlas
+       ("openblas" ,openblas)           ;Julia does not build with Atlas
        ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
        ("mbedtls" ,mbedtls-apache)
@@ -411,20 +411,20 @@
             (base32
              "0wp6ld9vk11f4nnkn56627zmlv9k5vafi99qa3yyn1pgcd61zcfs"))))
        ("libwhich"
-	,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
+        ,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
            (origin
              ;; Note: We use a /tarball URL, but that's because Julia's build
              ;; system checks the hash of that tarball; thus we can't use
              ;; 'git-fetch'.
-	     (method url-fetch)
-	     (uri (string-append
+             (method url-fetch)
+             (uri (string-append
                    "https://api.github.com/repos/vtjnash/libwhich/tarball/"
                    commit))
              (file-name (string-append "libwhich-" (string-take commit 7)
                                        ".tar.gz"))
-	     (sha256
-	      (base32
-	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
+             (sha256
+              (base32
+               "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
        ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0004-use-wrapper-to-set-JULIA_LOAD_PATH-and-JULIA_DEPOT_P.patch

From fe1f84062e88b6e4d77f35f12d7219fd47687c3a Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:23:44 +0100
Subject: [PATCH 04/11] use wrapper to set JULIA_LOAD_PATH and JULIA_DEPOT_PATH

---
 gnu/packages/julia.scm | 25 +++++++++++++++++++++----
 1 file changed, 21 insertions(+), 4 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index e1c4685227..39c7d6d34f 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -297,7 +297,9 @@
                 ;; running order.  I think it depends on the number of
                 ;; runners, disabling it for now
                 ;; https://github.com/JuliaLang/julia/issues/34330
-                "tests = filter(e->!in(e,[\"backtrace\",\"exceptions\",\"client\",\"stacktraces\"]),testnames)"))
+                "tests = filter(e->!in(e,[\"backtrace\",\"exceptions\",\"client\",
+                                          \"stacktraces\",\"stress\",\"precompile\"]),
+                                testnames)"))
              ;; When HOME is not set, julia calls uv_os_homedir, which in
              ;; turns call getpwuid_r. Add the HOME env variable to the
              ;; external julia call to fix this
@@ -307,11 +309,23 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-             #t)))
+             #t))
+         (add-after 'install 'make-wrapper
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let* ((out (assoc-ref outputs "out"))
+                    (bin (string-append out "/bin"))
+                    (program "julia"))
+               (with-directory-excursion bin
+                 (wrap-program program
+                   `("JULIA_LOAD_PATH" ":" prefix
+                     ("" "$JULIA_LOAD_PATH")))
+                 (wrap-program program
+                   `("JULIA_DEPOT_PATH" ":" prefix
+                     ("" "$JULIA_DEPOT_PATH"))))
+               #t))))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
-        (string-append "PREFIX=" (assoc-ref %outputs "out"))
 
         ;; Passing the MARCH flag is necessary to build binary substitutes for
         ;; the supported architectures.
@@ -435,7 +449,10 @@
     (native-search-paths
      (list (search-path-specification
             (variable "JULIA_LOAD_PATH")
-            (files (list "share/julia/packages/")))))
+            (files (list "share/julia/packages/")))
+           (search-path-specification
+            (variable "JULIA_DEPOT_PATH")
+            (files (list "share/julia/")))))
     ;; Julia is not officially released for ARM and MIPS.
     ;; See https://github.com/JuliaLang/julia/issues/10639
     (supported-systems '("i686-linux" "x86_64-linux" "aarch64-linux"))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: attachment;
 filename=0005-gnu-build-julia-build-system-fix-package-precompilat.patch
Content-Transfer-Encoding: quoted-printable

From 3191a0958c97831bc65750a6c4231d449e92aca3 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Fri, 17 Jan 2020 19:40:55 +0100
Subject: [PATCH 05/11] gnu: build: julia-build-system: fix package
 precompilation

---
 guix/build/julia-build-system.scm | 51 +++++++++++++------------------
 1 file changed, 22 insertions(+), 29 deletions(-)

diff --git a/guix/build/julia-build-system.scm b/guix/build/julia-build-sys=
tem.scm
index ff6fcf5fe3..dbd4af623d 100644
--- a/guix/build/julia-build-system.scm
+++ b/guix/build/julia-build-system.scm
@@ -1,5 +1,5 @@
 ;;; GNU Guix --- Functional package management for GNU
-;;; Copyright =C2=A9 2019 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
+;;; Copyright =C2=A9 2019, 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,53 +37,46 @@
 ;; subpath where we store the package content
 (define %package-path "/share/julia/packages/")
=20
-(define (generate-load-path inputs outputs)
-  (string-append
-   (string-join (map (match-lambda
-                       ((_ . path)
-                        (string-append path %package-path)))
-                     ;; Restrict to inputs beginning with "julia-".
-                     (filter (match-lambda
-                               ((name . _)
-                                (string-prefix? "julia-" name)))
-                             inputs))
-                ":")
-   (string-append ":" (assoc-ref outputs "out") %package-path)
-   ;; stdlib is always required to find Julia's standard libraries.
-   ;; usually there are other two paths in this variable:
-   ;; "@" and "@v#.#"
-   ":@stdlib"))
-
 (define* (install #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package-dir (string-append out %package-path
-                                     (string-append
-                                      (strip-store-file-name source)))))
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+                                     (strip-store-file-name source))))
     (mkdir-p package-dir)
-    (copy-recursively source package-dir))
+    (copy-recursively (getcwd) package-dir))
   #t)
=20
-;; TODO: Precompilation is working, but I don't know how to tell
-;; julia to use use it. If (on rantime) we set HOME to
-;; store path, julia tries to write files there (failing)
 (define* (precompile #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (builddir (string-append out "/share/julia/"))
          (package (strip-store-file-name source)))
     (mkdir-p builddir)
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
-    ;; Actual precompilation
-    (invoke-julia (string-append "using " package)))
+    ;; add new package dir to the load path
+    (setenv "JULIA_LOAD_PATH"
+            (string-append builddir "packages/" ":"
+                           (or (getenv "JULIA_LOAD_PATH")
+                               "")))
+    ;; Actual precompilation.
+    (invoke-julia
+     ;; when using julia as a user, julia writes precompile cache to the f=
irst
+     ;; entry of the DEPOT_PATH list (by default, the home dir).  We want =
to
+     ;; write it to the store, so let's push the store path as the first
+     ;; element of DEPOT_PATH.  Once the cache file exists, this hack is n=
ot
+     ;; needed anymore (like in the check phase).  If the user install new
+     ;; pacakges, those will be installed and precompiled in the home dir
+     (string-append "pushfirst!(DEPOT_PATH, pop!(DEPOT_PATH)); using " pac=
kage)))
   #t)
=20
 (define* (check #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package (strip-store-file-name source))
          (builddir (string-append out "/share/julia/")))
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+    (setenv "JULIA_LOAD_PATH" (string-append builddir "packages/"))
     (invoke-julia (string-append "using Pkg;Pkg.test(\"" package "\")")))
   #t)
=20
--=20
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0006-gnu-Add-julia-compat.patch

From 7aabfd980a00fa292e73db66230a0558389a9011 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:05:00 +0100
Subject: [PATCH 06/11] gnu: Add julia-compat.

* gnu/packages/julia-xyz.scm: New file
* gnu/packages/julia-xyz.scm (julia-compat): New variable
---
 gnu/local.mk               |  1 +
 gnu/packages/julia-xyz.scm | 27 +++++++++++++++++++++++++++
 2 files changed, 28 insertions(+)
 create mode 100644 gnu/packages/julia-xyz.scm

diff --git a/gnu/local.mk b/gnu/local.mk
index fe8634b44d..e07229ee20 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -277,6 +277,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/packages/jrnl.scm				\
   %D%/packages/jose.scm				\
   %D%/packages/julia.scm			\
+  %D%/packages/julia-xyz.scm			\
   %D%/packages/jupyter.scm			\
   %D%/packages/kawa.scm				\
   %D%/packages/kde.scm				\
diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
new file mode 100644
index 0000000000..7d9faa63e9
--- /dev/null
+++ b/gnu/packages/julia-xyz.scm
@@ -0,0 +1,27 @@
+(define-module (gnu packages julia-xyz)
+  #:use-module ((guix licenses) #:prefix license:)
+  #:use-module (guix packages)
+  #:use-module (guix git-download)
+  #:use-module (guix build-system julia))
+
+(define-public julia-compat
+  (package
+    (name "julia-compat")
+    (version "3.2.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/Compat.jl")
+             (commit (string-append "v" version))))
+       (file-name "Compat")
+       (sha256
+        (base32 "0d21h3l2ry2mmlhpg7b9cxifayzwcv7r13h5wydcbd5pjf6k4qd4"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/Compat.jl")
+    (synopsis "Compatibility across Julia versions")
+    (description "The Compat package is designed to ease interoperability
+between older and newer versions of the Julia language.  The Compat package
+provides a macro that lets you use the latest syntax in a backwards-compatible
+way.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0007-gnu-Add-julia-inifile.patch

From 9d6e97b3b87480fbc5f7dc32ad8e9db838e141ff Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:06:11 +0100
Subject: [PATCH 07/11] gnu: Add julia-inifile.

* gnu/packages/julia-xyz.scm (julia-inifile): New variable.
---
 gnu/packages/julia-xyz.scm | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 7d9faa63e9..6b8053e5f8 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -25,3 +25,23 @@ between older and newer versions of the Julia language.  The Compat package
 provides a macro that lets you use the latest syntax in a backwards-compatible
 way.")
     (license license:expat)))
+
+(define-public julia-inifile
+  (package
+    (name "julia-inifile")
+    (version "0.5.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaIO/IniFile.jl")
+             (commit "8ba59958495fa276d6489d2c3903e765d75e0bc0")))
+       (file-name "IniFile")
+       (sha256
+        (base32 "11h6f99jpbg729lplw841m68jprka7q3n8yw390bndlmcdsjabpd"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaIO/IniFile.jl")
+    (synopsis "Reading Windows-style INI files")
+    (description "This is a julia package that defines an IniFile type that
+allows to interface with @file{.ini} files")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0008-gnu-Add-julia-sha.patch

From bc96f48b6916eab179f7f1a911e54182e9c9ed71 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:07:13 +0100
Subject: [PATCH 08/11] gnu: Add julia-sha.

* gnu/packages/julia-xyz.scm (julia-sha): New variable.
---
 gnu/packages/julia-xyz.scm | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 6b8053e5f8..92ffde58e7 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -45,3 +45,26 @@ way.")
     (description "This is a julia package that defines an IniFile type that
 allows to interface with @file{.ini} files")
     (license license:expat)))
+
+(define-public julia-sha
+  (package
+    (name "julia-sha")
+    (version "0.5.7")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/staticfloat/SHA.jl")
+             (commit (string-append "v" version))))
+       (file-name "SHA")
+       (sha256
+        (base32 "10a09kg9z0m8rvwmlgsna6p342kyvizx2axdqc6pzyhraddr8jrp"))))
+    (propagated-inputs `(("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://github.com/staticfloat/SHA.jl")
+    (synopsis
+     "Performant, 100% native-julia SHA1, SHA2, and SHA3 implementation")
+    (description "Julia package implementing SHA algorithms.  Each exported
+function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
+@code{IO} object.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0009-gnu-Add-julia-binaryprovider.patch

From d1094a0e8346807904a96424d8c8c59c6a91bf40 Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:07:36 +0100
Subject: [PATCH 09/11] gnu: Add julia-binaryprovider.

* gnu/packages/julia-xyz.scm (julia-binaryprovider): New variable.
---
 gnu/packages/julia-xyz.scm | 33 +++++++++++++++++++++++++++++++++
 1 file changed, 33 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 92ffde58e7..0f8e04b4d1 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -68,3 +68,36 @@ allows to interface with @file{.ini} files")
 function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
 @code{IO} object.")
     (license license:expat)))
+
+(define-public julia-binaryprovider
+  (package
+    (name "julia-binaryprovider")
+    (version "0.5.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaPackaging/BinaryProvider.jl")
+             (commit (string-append "v" version))))
+       (file-name "BinaryProvider")
+       (sha256
+        (base32 "174jmg4w8ncgfhdvfnm0p4cnlayw31j4s9sksqlwz1sipywqvww7"))))
+    (propagated-inputs `(("julia-sha" ,julia-sha)))
+    ;; We don't really need BinaryProvider (as guix provides the binaries) but
+    ;; since it's a dependency of other packages we want to precompile it.
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'disable-engine-probe
+           (lambda _
+             (substitute* "src/BinaryProvider.jl"
+               ;; Precompilation tries to download things from the internet,
+               ;; disable the download part
+               (("probe_platform_engines") "# probe_platform_engines"))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaPackaging/BinaryProvider.jl")
+    (synopsis "Reliable Binary provider for Julia")
+    (description "@code{BinaryProvider.jl} simplifies the installation of
+binaries required by julia packages.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0010-gnu-Add-julia-mbedtls.patch

From 5239d2a1c3dc713496817eb0018a062af4b280be Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:11:14 +0100
Subject: [PATCH 10/11] gnu: Add julia-mbedtls.

* gnu/packages/julia-xyz.scm (julia-mbedtls): New variable.
---
 gnu/packages/julia-xyz.scm | 49 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 48 insertions(+), 1 deletion(-)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 0f8e04b4d1..3e9f532697 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -2,7 +2,8 @@
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix packages)
   #:use-module (guix git-download)
-  #:use-module (guix build-system julia))
+  #:use-module (guix build-system julia)
+  #:use-module (gnu packages tls))
 
 (define-public julia-compat
   (package
@@ -101,3 +102,49 @@ function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
     (description "@code{BinaryProvider.jl} simplifies the installation of
 binaries required by julia packages.")
     (license license:expat)))
+
+(define-public julia-mbedtls
+  (package
+    (name "julia-mbedtls")
+    (version "0.7.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/MbedTLS.jl")
+             (commit (string-append "v" version))))
+       (file-name "MbedTLS")
+       (sha256
+        (base32 "1a8snw9gi21lm6r3kh6ly7ngi99s9k5shqkfiizj3g9li20q23h2"))))
+    (propagated-inputs
+     `(("julia-binaryprovider" ,julia-binaryprovider)
+       ("mbedtls-apache" ,mbedtls-apache)))
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-before 'precompile 'build-deps
+           (lambda* (#:key outputs source inputs #:allow-other-keys)
+             (let ((f (open-file
+                       (string-append
+                        (assoc-ref outputs "out")
+                        "/share/julia/packages/"
+                        (string-append
+                         (strip-store-file-name source) "/deps/deps.jl"))
+                       "w")))
+               (display (string-append "const libmbedcrypto = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedcrypto.so\"\n") f)
+               (display (string-append "const libmbedtls = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedtls.so\"\n") f)
+               (display (string-append "const libmbedx509 = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedx509.so\"\n") f)
+               (close-port f))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/MbedTLS.jl")
+    (synopsis "Apache's mbed TLS library wrapper")
+    (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
+cryptography C libary for Julia.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=0011-gnu-Add-julia-http.patch

From bd7ba60316819b1201966dc650f50e4c320a4dfd Mon Sep 17 00:00:00 2001
From: nixo <nicolo@HIDDEN>
Date: Sat, 18 Jan 2020 14:11:45 +0100
Subject: [PATCH 11/11] gnu: Add julia-http.

* gnu/packages/julia-xyz.scm (julia-http): New variable.
---
 gnu/packages/julia-xyz.scm | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 3e9f532697..ff1bb483f9 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -148,3 +148,27 @@ binaries required by julia packages.")
     (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
 cryptography C libary for Julia.")
     (license license:expat)))
+
+(define-public julia-http
+  (package
+    (name "julia-http")
+    (version "0.8.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaWeb/HTTP.jl")
+             (commit (string-append "v" version))))
+       (file-name "HTTP")
+       (sha256
+        (base32 "0928fvncfp07i5hvqxjyj8i27xmxxllas1m5idqq2i8h7jshzq3y"))))
+    (propagated-inputs
+     `(("julia-inifile" ,julia-inifile)
+       ("julia-mbedtls" ,julia-mbedtls)
+       ("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://juliaweb.github.io/HTTP.jl/")
+    (synopsis "HTTP support for Julia")
+    (description "@code{HTTP.jl} is a Julia library for HTTP Messages,
+implementing both a client and a server.")
+    (license license:expat)))
-- 
2.24.1


--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:42:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:42:22 2020
Received: from localhost ([127.0.0.1]:40717 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoMn-0007Im-8j
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:42:22 -0500
Received: from mail-wm1-f42.google.com ([209.85.128.42]:40889)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoMj-0007IW-Pj
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:42:20 -0500
Received: by mail-wm1-f42.google.com with SMTP id t14so10280365wmi.5
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:42:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:references:date:message-id:mime-version
 :content-transfer-encoding;
 bh=bW1S8bDWJbJhqaIS9Jdn2qL5jp0mx9Yn5vHV92cDygE=;
 b=f/WG3z9595Scw+5nBwAsUjIZtZJOvZ2E/rhhrbVFRu7KernxvlWMCGIEpTy2pQxsfC
 OVsHovgpKtQheF5AUADiU0h2krVTGNwA3EI7D5VgisLPHAIiOFeRIjRYGXI3vB+jSfze
 KmEeDg1dw/2iHAGK3gihIGU0iaB2ukkxf5ym0X4wmz8soc7UhNaFIPUp9g5cwa6sz0lx
 Y6LfwxdrLSK7RE97dRV8tdPpmn971GuS0jKYFNute/w4N4+Z5iNq+aZxku7q4itVDWrP
 uDJT1SHls0/1//3mCHD4NzQXfcqkqbcGtZKh8umrv6fYEWvR919Z1LDJegT7nDiofryu
 aLSw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=bW1S8bDWJbJhqaIS9Jdn2qL5jp0mx9Yn5vHV92cDygE=;
 b=qlaPj75Nu/rsGM8hz88IpVV29ZNllKgnt6+JbfKMLpXyUIgqleErY8HhYZkcMPVc4V
 x76lvl7OFeOHN5kgpyaVR2mB0RMJ329KOt01ZA4+KfVlU+edEZqX9AKjhNw/izCEQlVB
 p6E/+cd08BPmqv1WiFDlKTntojyq6qs6hhS/9lMEJQGMALUB/snRnqFt5z1Ewx7W3LLD
 lmQmF1uu7Y/ibREcLDfqzq5Z1CxIwAgjdK9qR0NmxTjrmBvUBdqcmw0HX5/IRP7/P4R0
 ir6u+Zyh0AmY5XpQau21xlPOhCyGf5I0gYrYWxCyQj/6gI9C/xHi9R1QgQF1pz6tdU3T
 0n1w==
X-Gm-Message-State: APjAAAV1fXfyFT9gSUh8R70PIqA2jlr8CrCnJmAu6gDYLEAOSXrJ7TN1
 DYqn3rF2tmdCxAOMH5kUHySR1zP+
X-Google-Smtp-Source: APXvYqwez6mncml5ubP5IehquWyBNv3FwL7xOC2Rfsa0Q94Dt0yez6piqC8HVNoFYWbNm8zODCZPNQ==
X-Received: by 2002:a05:600c:1050:: with SMTP id
 16mr9853939wmx.20.1579354931688; 
 Sat, 18 Jan 2020 05:42:11 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id p17sm362366wmk.30.2020.01.18.05.42.10
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:42:11 -0800 (PST)
From: anothersms@HIDDEN (=?utf-8?Q?Nicol=C3=B2?= Balzarotti)
To: 38546 <at> debbugs.gnu.org
Subject: =?utf-8?Q?=5BNicol=C3=B2?= Balzarotti] [PATCH 00/10] Update julia
 to 1.3.1, fix precompilation, add HTTP.jl
References: <87zhekvqpj.fsf@HIDDEN>
Date: Sat, 18 Jan 2020 14:42:10 +0100
Message-ID: <8736ccvq31.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Ok I had time to look at this again.

1. Package installation can be done both the julia way and the guix way
2. SOURCE_DATE_EPOCH is respected in package precompile timestamp. Other fi=
xes are needed to get reproducible builds, but for now that means that pack=
age cache is used.
3. This patch adds some first julia package (HTTP.jl and dependencies)=20
4. Updated julia to 1.3.1 (latest release). It's working great and the
build recipe is simplified a lot.  However, some test is failing.  The
"interesting" part is that when running tests alone, they are working.
It seems like the problem arise when tests are run on the _same core_
and not on different cores.  I opened a issue upstream for this
(https://github.com/JuliaLang/julia/issues/34330), I'll have to look
further on it, but for now if it's fine for me this is ready to be merged.

I'm sending the patch series here.

Thanks, Nicol=C3=B2

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> (+Cc: bug report.)
>
> Nicol=C3=B2 Balzarotti <anothersms@HIDDEN> skribis:
>
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>>
>>> Hi!
>>>
>>> nixo <anothersms@HIDDEN> skribis:
>>>
>>>> This set of patches improve the state of julia-build-system.
>>>>
>>>> 1. set path JULIA_LOAD_PATH to enable installing packages, and
>>>>   JULIA_DEPOT_PATH to allow guix-precompiled cache to be recognized by=
 julia. To
>>>
>>> These two environment variables are supported upstream, right?
>>
>> Yes, those variables are documented here:
>> https://docs.julialang.org/en/v1/manual/environment-variables/index.html
>
> Great.
>
>> Should user be allowed to manually install packages in his own private
>> home folder manually? (I just tried with R: R recognize the store is RO
>> and ask for an alternative path). I'll try to allow "standard" package
>> installation and submit the patch again (also, I just read you other
>> comments, so I'll fix everything!)
>
> I think users should have the option to install packages in the normal
> Julia way, without Guix.
>
>>>>   do this, a small "hack" with libfaketime was required (julia decides=
 if the
>>>>   cache is valid by comparing source ".jl" mtime with cache ".ji" file=
, in which
>>>>   julia stores a timestamp. We need to force this timestamp to be equa=
l to the
>>>>   mtime of guix-store files).
>>>
>>> OK.  This hack shouldn=E2=80=99t break =E2=80=9Cnormal=E2=80=9D Julia u=
ses (outside of the
>>> store), right?
>> You are right, the issue is that julia finds its src (.jl) file to have
>> a different (although older) timestamp (because guix fixes the
>> mtime). This applies only to cache files placed in the store. Other
>> cache files (non-guix installed files) have the right timestamp, so are
>> not affected (I don't know if this explanation is clear. The TLDR is:
>> with this hack store works without double-precompilation, non-store
>> works normally, too).
>> However, I'll check if I can make it work with SOURCE_DATE_EPOCH. I
>> already read the code responsible for precompilation, so hopefully it
>> won't take too much time
>
> Awesome, thanks!
>
> Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:41:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:41:55 2020
Received: from localhost ([127.0.0.1]:40713 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoMA-0007HV-Te
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:41:55 -0500
Received: from mail-wr1-f68.google.com ([209.85.221.68]:42352)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoM1-0007HA-L2
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:41:41 -0500
Received: by mail-wr1-f68.google.com with SMTP id q6so25149030wro.9
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:41:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:references:message-id:mime-version
 :content-transfer-encoding;
 bh=ofg0BDSa2celyTp1X58OFZPxovSXjNotoVaw3+LwfuA=;
 b=ksOoz+OwisizL8/Y67lK25GqGmUoDFQ10D2O3ViYXRvmlBF0y6bC8CaJAC/qiXFiCv
 tnvqIQWU9XexEnvgwCNBC3hLQ785E3m4NPJqkMA0pCxEZbLU0yEy7GZD5YMqWyRvo6GR
 clDubqm3pCxgC8Vht7Aci+LR6NQKV9VOoEX2lcNbR+cOceM5SaH0sLp2vT8W75fRCgh3
 50Zas49xuQQrLYsq0BeeQhvqfCwvHR1TzwJIWmufFrq5YC2p+aOiENw0iGQLdF9oISy+
 IODe2d/4yTCgHAr1eXGvz3CKrryV68ong0tITCLkJtqDOfzMudTDBdZ8tZjATbw3iaIR
 kP3g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:references:message-id
 :mime-version:content-transfer-encoding;
 bh=ofg0BDSa2celyTp1X58OFZPxovSXjNotoVaw3+LwfuA=;
 b=O+8/xMuT66H3YelR8RpyaC6p5szWm1OgJbvMM5nBJKBqSZ8r/XZbmZ/4y3QKAmkn7z
 dJA52FixCy26uqlXFVa9/ETq+FwbqaHMp4uOOzHoiWGMdgo2d17mB/43yvOt3UYe9Btm
 A7F19pUDZk1Cpwcg0gmFHhpd8rdodbN70SqUQtJxDT7fmIjJFBH03zGo1avzWhHGrv3k
 6kIjwftmfCyK04FejQ111MCvAlomLNK9Tm7QMFhtWtS+w0Wz0sZdbk+OBAmjXkUXdTdF
 h4DZoeFLw7qW4A50TBrefisGNiI696uoXCseSTssUiWAo4Vc/mRz5zqbgzKMM9Et91kp
 y9ew==
X-Gm-Message-State: APjAAAUqiTx7nHCBRcVr40zZ4anLRf5TP3CLt9QLI9HTTk87L/jWzJ0R
 c+pplJi33whC+4PbAuakmopaJGBq
X-Google-Smtp-Source: APXvYqy7e8/jJN0ovD/qsFuxvqo9+7ypBwcYwpRcGohTGH4RUxGRyrMaZniZfOBMLb2bVaw1A2HLlg==
X-Received: by 2002:a5d:558d:: with SMTP id i13mr8409544wrv.364.1579354887012; 
 Sat, 18 Jan 2020 05:41:27 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id i16sm14974818wmb.36.2020.01.18.05.41.25
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:41:26 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 01/11] gnu: julia: Update to 1.3.1.
Date: Thu, 12 Dec 2019 09:43:20 +0100
References: <87pnfgvqgt.fsf@HIDDEN>
Message-ID: <875zh8vq4a.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 4.0 (++++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/packages/julia.scm (julia): Update to 1.3.1. *
 gnu/packages/julia.scm
 (libuv-julia): Update to 2.0.0. --- gnu/packages/julia.scm | 278
 +++++++++++++++++ 1 file changed, 1 [...] 
 Content analysis details:   (4.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: libmpfr.so]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.68 listed in wl.mailspike.net]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
 date
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.68 listed in list.dnswl.org]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 3.0 (+++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/julia.scm (julia): Update to 1.3.1. * gnu/packages/julia.scm
    (libuv-julia): Update to 2.0.0. --- gnu/packages/julia.scm | 278 +++++++++++++++++
    1 file changed, 1 [...] 
 
 Content analysis details:   (3.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: libmpfr.so]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
                             date
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager


* gnu/packages/julia.scm (julia): Update to 1.3.1.
* gnu/packages/julia.scm (libuv-julia): Update to 2.0.0.
---
 gnu/packages/julia.scm | 278 +++++++++++++++++------------------------
 1 file changed, 113 insertions(+), 165 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..e4db39afbd 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2015, 2016, 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2016 Efraim Flashner <efraim@HIDDEN>
+;;; Copyright =C2=A9 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages base)
   #:use-module (gnu packages compression)
+  #:use-module (gnu packages curl)
   #:use-module (gnu packages elf)
   #:use-module (gnu packages gcc)
   #:use-module (gnu packages llvm)
@@ -43,18 +45,30 @@
   #:use-module (gnu packages textutils)
   #:use-module (gnu packages tls)
   #:use-module (gnu packages version-control)
+  #:use-module (gnu packages ssh)
   #:use-module (gnu packages wget)
   #:use-module (ice-9 match))
=20
+(define (julia-patch-url version name)
+  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
+		 "/deps/patches/" name ".patch"))
+
+(define (julia-patch name sha)
+  (let ((version "1.3.1"))
+    (origin (method url-fetch)
+	    (uri (julia-patch-url version name))
+	    (sha256 (base32 sha))
+	    (file-name name))))
+
 (define libuv-julia
-  (let ((commit "26dbe5672c33fc885462c509fe2a9b36f35866fd")
-        (revision "6"))
+  (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
     ;; When upgrading Julia, also upgrade this.
-    ;; Get the commit from https://github.com/JuliaLang/julia/blob/v1.1.1/=
deps/libuv.version
+    ;; Get the commit from
+    ;; https://github.com/JuliaLang/julia/blob/v1.3.1/deps/libuv.version
     (package
       (inherit libuv)
       (name "libuv-julia")
-      (version (string-append "1.9.0-" revision "." (string-take commit 8)=
))
+      (version (string-append "2.0.0" "." (string-take commit 8)))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -63,7 +77,7 @@
                 (file-name (string-append name "-" version "-checkout"))
                 (sha256
                  (base32
-                  "17pn2xmqaramilx897s9grs966i5246gi6sric5alch4g9j4685n"))=
))
+                  "0dn3v6fdp1z382pqg3nhjzk60l61ky9b65mfgaj29fv2da95rwjs"))=
))
       (build-system gnu-build-system)
       (arguments
        (substitute-keyword-arguments (package-arguments libuv)
@@ -72,16 +86,27 @@
              (delete 'autogen)))))
       (home-page "https://github.com/JuliaLang/libuv"))))
=20
-(define (llvm-patch-url version name)
-  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
-		 "/deps/patches/" name))
-
-(define (llvm-patch name sha)
-  (let ((version "1.1.1"))
-    (origin (method url-fetch)
-	    (uri (llvm-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+(define libunwind-julia
+  ;; julia requires a patched version
+  (package
+    (inherit libunwind)
+    (name "libunwind-julia")
+    (version "1.3.1")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "mirror://savannah/libunwind/libunwind-"
+                                  version ".tar.gz"))
+              (sha256
+               (base32
+                "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
+              (patches
+               (list
+	        (julia-patch "libunwind-prefer-extbl"
+                             "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hh=
xfgnh2m1")
+                (julia-patch "libunwind-static-arm"
+                             "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic87=
0zh3lhgq")))))
+    (build-system gnu-build-system)
+    (home-page "https://github.com/JuliaLang/libuv")))
=20
 (define llvm-julia
   (package
@@ -99,39 +124,39 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi=
?bug=3D919628
               (patches
                (list
-	        (llvm-patch "llvm-6.0-D44650.patch"
+	        (julia-patch "llvm-6.0-D44650"
 			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (llvm-patch "llvm-6.0-DISABLE_ABI_CHECKS.patch"
+	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
 			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (llvm-patch "llvm-6.0-NVPTX-addrspaces.patch"
+	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
 			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (llvm-patch "llvm-6.0.0_D27296-libssp.patch"
+	        (julia-patch "llvm-6.0.0_D27296-libssp"
 			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (llvm-patch "llvm-D27629-AArch64-large_model_6.0.1.patch"
+	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
 			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (llvm-patch "llvm-D34078-vectorize-fdiv.patch"
+	        (julia-patch "llvm-D34078-vectorize-fdiv"
 			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (llvm-patch "llvm-D42262-jumpthreading-not-i1.patch"
+	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
 			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (llvm-patch "llvm-D44892-Perf-integration.patch"
+	        (julia-patch "llvm-D44892-Perf-integration"
 			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (llvm-patch "llvm-D46460.patch"
+	        (julia-patch "llvm-D46460"
 			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (llvm-patch "llvm-D49832-SCEVPred.patch"
+	        (julia-patch "llvm-D49832-SCEVPred"
 			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (llvm-patch "llvm-D50010-VNCoercion-ni.patch"
+	        (julia-patch "llvm-D50010-VNCoercion-ni"
 			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (llvm-patch "llvm-D50167-scev-umin.patch"
+	        (julia-patch "llvm-D50167-scev-umin"
 			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (llvm-patch "llvm-OProfile-line-num.patch"
+	        (julia-patch "llvm-OProfile-line-num"
 			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (llvm-patch "llvm-PPC-addrspaces.patch"
+	        (julia-patch "llvm-PPC-addrspaces"
 			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (llvm-patch "llvm-rL323946-LSRTy.patch"
+	        (julia-patch "llvm-rL323946-LSRTy"
 			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (llvm-patch "llvm-rL326967-aligned-load.patch"
+	        (julia-patch "llvm-rL326967-aligned-load"
 			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (llvm-patch "llvm-rL327898.patch"
+	        (julia-patch "llvm-rL327898"
 			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
@@ -158,7 +183,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.3.1")
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -166,7 +191,7 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "0hk983mywimclgnjc41zmlppm5kfdz2aj85ky07p49ilcqxi998f"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
@@ -188,30 +213,24 @@
          (add-after 'unpack 'prepare-deps
            (lambda* (#:key inputs #:allow-other-keys)
              (mkdir "deps/srccache")
-             (copy-file (assoc-ref inputs "dsfmt")
-                        "deps/srccache/dsfmt-2.2.3.tar.gz")
+             ;; no USE_SYSTEM_{OBJCONV/LIBWHICH}
              (copy-file (assoc-ref inputs "objconv")
                         "deps/srccache/objconv.zip")
-             (copy-file (assoc-ref inputs "suitesparse")
-                        "deps/srccache/SuiteSparse-4.4.5.tar.gz")
-             (copy-file (string-append (assoc-ref inputs "virtualenv")
-                                       "/bin/virtualenv")
-                        "julia-env")
              (copy-file (assoc-ref inputs "libwhich")
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9c=
e7e89e"
                                        ".tar.gz"))
-             (copy-file (assoc-ref inputs "rmath")
-                        "deps/srccache/Rmath-julia-0.1.tar.gz")
-
 	     ;; needed by libwhich
 	     (setenv "LD_LIBRARY_PATH"
 		     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs =
pkg)
                                                         "/lib"))
-                                       '("arpack-ng" "fftw" "gmp" "lapack"
-			                 "libgit2" "mpfr" "openblas" "openlibm"
-			                 "openspecfun" "pcre2"))
+                                       '("arpack-ng" "curl" "dsfmt"
+                                         "gmp" "lapack"
+                                         "libssh2" "libgit2"
+                                         "mbedtls" "mpfr"
+                                         "openblas" "openlibm" "pcre2"
+                                         "suitesparse"))
                                   ":"))
 	     #t))
          ;; FIXME: Building the documentation requires Julia packages that
@@ -233,44 +252,12 @@
           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is n=
ot
           ;; used in Guix, we patch runtime_ccall.cpp to contain a static =
map.
           (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix Sys=
tem.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
-
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] =3D "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";=
")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.s=
o")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.=
so"))))))
             (substitute* "base/math.jl"
               (("const libm =3D Base.libm_name")
                (string-append "const libm =3D \""
                               (assoc-ref inputs "openlibm")
                               "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun =3D \"libopenspecfun\"")
-               (string-append "const openspecfun =3D \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+                              "\"")))))
          (add-before 'build 'fix-include-and-link-paths
           (lambda* (#:key inputs #:allow-other-keys)
             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
@@ -278,10 +265,10 @@
             ;; collection of build targets and a list of libraries to link
             ;; against.
             (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(L=
IBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) =
\\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OB=
JS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DO=
BJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_=
debug)"))
=20
             ;; The REPL must be linked with libuv.
             (substitute* "ui/Makefile"
@@ -296,38 +283,28 @@
                               "/include/uv/errno.h")))
             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
-         (add-after 'unpack 'hardcode-paths
            (lambda _
-             (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
-               (("`which") (string-append "`" (which "which")))
-               (("`wget")  (string-append "`" (which "wget"))))
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
              #t))
-         (add-before 'check 'disable-broken-tests
+         (add-before 'check 'fix-broken-tests
            (lambda _
-             (define (touch file-name)
-               (call-with-output-file file-name (const #t)))
-	     ;; FIXME: All git tests works except this one. But *THIS* "fix"
-             ;; is not working, so right now I'm disabling all libgit2.jl =
tests
-	     ;; (substitute* "stdlib/LibGit2/test/libgit2.jl"
-	     ;; (("!LibGit2.use_http_path(cfg, github_cred)") "true")
-	     ;; (("LibGit2.use_http_path(cfg, mygit_cred)") "true"))
-             (map (lambda (test)
-                    (delete-file test)
-                    (touch test))
-	          '("stdlib/Sockets/test/runtests.jl"
-		    "stdlib/Distributed/test/runtests.jl"
-                    ;; FIXME: see above
-		    "stdlib/LibGit2/test/libgit2.jl"))
-	     (substitute* "test/choosetests.jl"
-	       ;; These tests fail, probably because some of the input
-	       ;; binaries have been stripped and thus backtraces don't look
-	       ;; as expected.
-	       (("\"backtrace\",") "")
-	       (("\"cmdlineargs\",") ""))
+             (substitute* "test/choosetests.jl"
+               (("tests =3D testnames")
+                ;; Those failings are not deterministic.  They depends on =
the
+                ;; running order.  I think it depends on the number of
+                ;; runners, disabling it for now
+                ;; https://github.com/JuliaLang/julia/issues/34330
+                "tests =3D filter(e->!in(e,[\"backtrace\",\"exceptions\",\=
"client\",\"stacktraces\"]),testnames)"))
+             ;; When HOME is not set, julia calls uv_os_homedir, which in
+             ;; turns call getpwuid_r. Add the HOME env variable to the
+             ;; external julia call to fix this
+             (substitute* "test/cmdlineargs.jl"
+               (("\"JULIA_PROJECT\"") "\"HOME\"=3D>\"/tmp\", \"JULIA_PROJE=
CT\""))
+             ;; Marking the test as broken as it's a known bug:
+             ;; https://github.com/JuliaLang/julia/issues/32377
+             (substitute* "stdlib/REPL/test/replcompletions.jl"
+               (("@test count") "@test_broken count"))
 	     #t)))
        #:make-flags
        (list
@@ -345,26 +322,21 @@
            ;; platforms, e.g. when running "guix package --search=3D"
            (_ "MARCH=3DUNSUPPORTED"))
=20
-        "CONFIG_SHELL=3Dbash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=3D0"    ;not packaged for Guix and upstream has =
no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=3Dbash"             ;needed to build bundled librari=
es
+        ;; list of "USE_SYSTEM_*" is here:
+        ;; https://github.com/JuliaLang/julia/blob/v1.3.1/Make.inc
+        "USE_SYSTEM_DSFMT=3D1"
+        "USE_SYSTEM_P7ZIP=3D1"
         "USE_SYSTEM_LAPACK=3D1"
         "USE_SYSTEM_BLAS=3D1"
         "USE_BLAS64=3D0"          ;needed when USE_SYSTEM_BLAS=3D1
         "LIBBLAS=3D-lopenblas"
         "LIBBLASNAME=3Dlibopenblas"
=20
-        "USE_SYSTEM_FFTW=3D1"
-        "LIBFFTWNAME=3Dlibfftw3"
-        "LIBFFTWFNAME=3Dlibfftw3f"
-
-        ;; TODO: Suitesparse does not install shared libraries, so we cann=
ot
-        ;; use the suitesparse package.
-        ;; "USE_SYSTEM_SUITESPARSE=3D1"
-        ;; (string-append "SUITESPARSE_INC=3D-I "
-        ;;                (assoc-ref %build-inputs "suitesparse")
-        ;;                "/include")
-
+        "USE_SYSTEM_SUITESPARSE=3D1"
+        (string-append "SUITESPARSE_INC=3D-I "
+                       (assoc-ref %build-inputs "suitesparse")
+                       "/include")
         "USE_GPL_LIBS=3D1"        ;proudly
         "USE_SYSTEM_UTF8PROC=3D1"
         (string-append "UTF8PROC_INC=3D"
@@ -385,16 +357,19 @@
 	"USE_SYSTEM_PATCHELF=3D1"
 	"USE_SYSTEM_PCRE=3D1"
 	"USE_SYSTEM_OPENLIBM=3D1"
-
+        "USE_SYSTEM_LIBM=3D0"
+        "USE_SYSTEM_LIBSSH2=3D1"
+        "USE_SYSTEM_CURL=3D1"
 	"USE_SYSTEM_GMP=3D1"
 	"USE_SYSTEM_MPFR=3D1"
+	"USE_SYSTEM_MBEDTLS=3D1"
 	"USE_SYSTEM_ARPACK=3D1"
 	"USE_SYSTEM_LIBGIT2=3D1"
-	"USE_SYSTEM_ZLIB=3D1"
-	"USE_SYSTEM_OPENSPECFUN=3D1")))
+	"USE_SYSTEM_ZLIB=3D1")))
     (inputs
      `(("llvm" ,llvm-julia)
=20
+       ("p7zip" ,p7zip)
        ;; The bundled version is 3.3.0 so stick to that version.  With oth=
er
        ;; versions, we get test failures in 'linalg/arnoldi' as described =
in
        ;; <https://bugs.gnu.org/30282>.
@@ -403,12 +378,12 @@
        ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
        ("openblas" ,openblas) ;Julia does not build with Atlas
-       ("libunwind" ,libunwind)
+       ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
-       ("openspecfun" ,openspecfun)
+       ("mbedtls" ,mbedtls-apache)
+       ("curl" ,curl)
        ("libgit2" ,libgit2)
-       ("fftw" ,fftw)
-       ("fftwf" ,fftwf)
+       ("libssh2" ,libssh2)
        ("fortran" ,gfortran)
        ("libuv" ,libuv-julia)
        ("pcre2" ,pcre2)
@@ -418,31 +393,12 @@
        ("which" ,which)
        ("zlib" ,zlib)
        ("gmp" ,gmp)
-       ("virtualenv" ,python2-virtualenv)
+       ("suitesparse" ,suitesparse)
        ;; FIXME: The following inputs are downloaded from upstream to allo=
w us
        ;; to use the lightweight Julia release tarball.  Ideally, these in=
puts
        ;; would eventually be replaced with proper Guix packages.
-
-       ;; TODO: run "make -f contrib/repackage_system_suitesparse4.make" t=
o copy static lib
-       ;; Find dependency versions here:
-       ;; https://raw.githubusercontent.com/JuliaLang/julia/77a2c1e245c858=
12dc1c7687540beedecc52758f/deps/Versions.make
-       ("rmath"
-	,(origin
-	   (method git-fetch)
-	   (uri (git-reference
-                 (url "https://github.com/JuliaLang/Rmath-julia")
-                 (commit "v0.1")))
-           (file-name "rmath-julia-0.1-checkout")
-	   (sha256
-	    (base32
-	     "1zkpy0cg5zivq40zbhbdgj9128fqzs2j94wkwih8nc6xaj3gp9p6"))))
-       ("suitesparse"
-        ,(origin
-           (method url-fetch)
-           (uri "http://faculty.cse.tamu.edu/davis/SuiteSparse/SuiteSparse=
-4.4.5.tar.gz")
-           (sha256
-            (base32
-             "1jcbxb8jx5wlcixzf6n5dca2rcfx6mlcms1k2rl5gp67ay3bix43"))))
+       ;; Find dependencies versions here:
+       ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Ve=
rsions.make
        ("objconv"
         ,(origin
            (method url-fetch)
@@ -467,15 +423,7 @@
 	     (sha256
 	      (base32
 	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
-       ("dsfmt"
-        ,(origin
-           (method url-fetch)
-           (uri (string-append
-                 "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/"
-                 "SFMT/dSFMT-src-2.2.3.tar.gz"))
-           (sha256
-            (base32
-             "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))))))
+       ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
        ("perl" ,perl)
--=20
2.24.1




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:37:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:37:06 2020
Received: from localhost ([127.0.0.1]:40709 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoHW-00079z-5b
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:37:06 -0500
Received: from mail-wr1-f66.google.com ([209.85.221.66]:33331)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoHQ-00079h-4F
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:36:52 -0500
Received: by mail-wr1-f66.google.com with SMTP id b6so25265878wrq.0
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:36:48 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:references:date:message-id:mime-version
 :content-transfer-encoding;
 bh=ofg0BDSa2celyTp1X58OFZPxovSXjNotoVaw3+LwfuA=;
 b=Pezg3jqq2aMex5AeJSff/U7wjuROuxEnr6NvqCWrvk+ab+p6kM7jfqSEeNLW3WNim6
 u4eTnPAffWjK1MHG22c9FF4RTDR8E0PVirshC7GJ4qEvfH4yyAXIJoajW8I3xtH0TcSf
 tqroZAYD/Q+9n+PohxATl38+NTLPGazSlp3zgLNZN6KLV4VWtlrvX3uZ/1lXxlolKPPP
 ScJZOCoyWV2XMoEYWKdnaj3oIPYjr6VGrhh46SKOLxcPI1G5wvgdNSMeDW8A4cI7Kali
 IGZ97t7OsdJby47+/Sf3moMGPsl319d9XoQYCJr/EvV8KnHHq/2kCmez8UlIR2fV6bH7
 sgsQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=ofg0BDSa2celyTp1X58OFZPxovSXjNotoVaw3+LwfuA=;
 b=o0FZNspRqYvbIGWiwATyZfAhPqCllszoYO0L3nHQ/dXKV5iAESuLCtd55GKvfqAqcn
 IF0YgDS8hB7Dh2Gl0dSw2l1xUZLmk993vRpCfxs//zJsMKb3ko7xm/8d05QGDg0ofCth
 +WcRju1tnGR8pyFZaVXVvsd9bjkp69721vtcbF7kGqZ77J+MycSb5nNuzOgE1hlEZsZx
 eloi8ou9GGMf7iBWLkX+OuvF96vllGJ0eGCePOBT7M9b/pDB1FLrue0iOT/+qqeYIwse
 iuTTEJ/rYDSe3Pl/ZVQFpsYVpYr8WhkDkdF9F2BInNnLTREKln9I8JM71ulWZKZfvpCF
 nEWA==
X-Gm-Message-State: APjAAAXym+eJqQvb39Hd/l3t9DZEabfMArmXtzSSSl6clZDqRXNB0Z0w
 FmFgErijDRfe8zT3KohpfMwRe621
X-Google-Smtp-Source: APXvYqwXElXZH9KXLPGqD9LJFwMDsU9n7zjov13vOdL1TCFCSvJ59XPXyPJMPqMbzMm/gP9BS6RapA==
X-Received: by 2002:adf:e8ca:: with SMTP id k10mr8027149wrn.50.1579354601722; 
 Sat, 18 Jan 2020 05:36:41 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id o4sm38380394wrw.97.2020.01.18.05.36.40
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:36:41 -0800 (PST)
From: anothersms@HIDDEN (=?utf-8?Q?Nicol=C3=B2?= Balzarotti)
To: 38546 <at> debbugs.gnu.org
Subject: [nixo] [PATCH 01/11] gnu: julia: Update to 1.3.1.
References: <87pnfgvqgt.fsf@HIDDEN>
Date: Sat, 18 Jan 2020 14:36:40 +0100
Message-ID: <878sm4vqc7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/packages/julia.scm (julia): Update to 1.3.1. *
 gnu/packages/julia.scm
 (libuv-julia): Update to 2.0.0. --- gnu/packages/julia.scm | 278
 +++++++++++++++++ 1 file changed, 1 [...] 
 Content analysis details:   (1.9 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.66 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.66 listed in wl.mailspike.net]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.9 (/)


* gnu/packages/julia.scm (julia): Update to 1.3.1.
* gnu/packages/julia.scm (libuv-julia): Update to 2.0.0.
---
 gnu/packages/julia.scm | 278 +++++++++++++++++------------------------
 1 file changed, 113 insertions(+), 165 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..e4db39afbd 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2015, 2016, 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2016 Efraim Flashner <efraim@HIDDEN>
+;;; Copyright =C2=A9 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -28,6 +29,7 @@
   #:use-module (gnu packages algebra)
   #:use-module (gnu packages base)
   #:use-module (gnu packages compression)
+  #:use-module (gnu packages curl)
   #:use-module (gnu packages elf)
   #:use-module (gnu packages gcc)
   #:use-module (gnu packages llvm)
@@ -43,18 +45,30 @@
   #:use-module (gnu packages textutils)
   #:use-module (gnu packages tls)
   #:use-module (gnu packages version-control)
+  #:use-module (gnu packages ssh)
   #:use-module (gnu packages wget)
   #:use-module (ice-9 match))
=20
+(define (julia-patch-url version name)
+  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
+		 "/deps/patches/" name ".patch"))
+
+(define (julia-patch name sha)
+  (let ((version "1.3.1"))
+    (origin (method url-fetch)
+	    (uri (julia-patch-url version name))
+	    (sha256 (base32 sha))
+	    (file-name name))))
+
 (define libuv-julia
-  (let ((commit "26dbe5672c33fc885462c509fe2a9b36f35866fd")
-        (revision "6"))
+  (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
     ;; When upgrading Julia, also upgrade this.
-    ;; Get the commit from https://github.com/JuliaLang/julia/blob/v1.1.1/=
deps/libuv.version
+    ;; Get the commit from
+    ;; https://github.com/JuliaLang/julia/blob/v1.3.1/deps/libuv.version
     (package
       (inherit libuv)
       (name "libuv-julia")
-      (version (string-append "1.9.0-" revision "." (string-take commit 8)=
))
+      (version (string-append "2.0.0" "." (string-take commit 8)))
       (source (origin
                 (method git-fetch)
                 (uri (git-reference
@@ -63,7 +77,7 @@
                 (file-name (string-append name "-" version "-checkout"))
                 (sha256
                  (base32
-                  "17pn2xmqaramilx897s9grs966i5246gi6sric5alch4g9j4685n"))=
))
+                  "0dn3v6fdp1z382pqg3nhjzk60l61ky9b65mfgaj29fv2da95rwjs"))=
))
       (build-system gnu-build-system)
       (arguments
        (substitute-keyword-arguments (package-arguments libuv)
@@ -72,16 +86,27 @@
              (delete 'autogen)))))
       (home-page "https://github.com/JuliaLang/libuv"))))
=20
-(define (llvm-patch-url version name)
-  (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" ver=
sion
-		 "/deps/patches/" name))
-
-(define (llvm-patch name sha)
-  (let ((version "1.1.1"))
-    (origin (method url-fetch)
-	    (uri (llvm-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+(define libunwind-julia
+  ;; julia requires a patched version
+  (package
+    (inherit libunwind)
+    (name "libunwind-julia")
+    (version "1.3.1")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append "mirror://savannah/libunwind/libunwind-"
+                                  version ".tar.gz"))
+              (sha256
+               (base32
+                "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
+              (patches
+               (list
+	        (julia-patch "libunwind-prefer-extbl"
+                             "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hh=
xfgnh2m1")
+                (julia-patch "libunwind-static-arm"
+                             "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic87=
0zh3lhgq")))))
+    (build-system gnu-build-system)
+    (home-page "https://github.com/JuliaLang/libuv")))
=20
 (define llvm-julia
   (package
@@ -99,39 +124,39 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi=
?bug=3D919628
               (patches
                (list
-	        (llvm-patch "llvm-6.0-D44650.patch"
+	        (julia-patch "llvm-6.0-D44650"
 			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (llvm-patch "llvm-6.0-DISABLE_ABI_CHECKS.patch"
+	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
 			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (llvm-patch "llvm-6.0-NVPTX-addrspaces.patch"
+	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
 			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (llvm-patch "llvm-6.0.0_D27296-libssp.patch"
+	        (julia-patch "llvm-6.0.0_D27296-libssp"
 			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (llvm-patch "llvm-D27629-AArch64-large_model_6.0.1.patch"
+	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
 			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (llvm-patch "llvm-D34078-vectorize-fdiv.patch"
+	        (julia-patch "llvm-D34078-vectorize-fdiv"
 			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (llvm-patch "llvm-D42262-jumpthreading-not-i1.patch"
+	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
 			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (llvm-patch "llvm-D44892-Perf-integration.patch"
+	        (julia-patch "llvm-D44892-Perf-integration"
 			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (llvm-patch "llvm-D46460.patch"
+	        (julia-patch "llvm-D46460"
 			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (llvm-patch "llvm-D49832-SCEVPred.patch"
+	        (julia-patch "llvm-D49832-SCEVPred"
 			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (llvm-patch "llvm-D50010-VNCoercion-ni.patch"
+	        (julia-patch "llvm-D50010-VNCoercion-ni"
 			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (llvm-patch "llvm-D50167-scev-umin.patch"
+	        (julia-patch "llvm-D50167-scev-umin"
 			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (llvm-patch "llvm-OProfile-line-num.patch"
+	        (julia-patch "llvm-OProfile-line-num"
 			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (llvm-patch "llvm-PPC-addrspaces.patch"
+	        (julia-patch "llvm-PPC-addrspaces"
 			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (llvm-patch "llvm-rL323946-LSRTy.patch"
+	        (julia-patch "llvm-rL323946-LSRTy"
 			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (llvm-patch "llvm-rL326967-aligned-load.patch"
+	        (julia-patch "llvm-rL326967-aligned-load"
 			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (llvm-patch "llvm-rL327898.patch"
+	        (julia-patch "llvm-rL327898"
 			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
@@ -158,7 +183,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.3.1")
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -166,7 +191,7 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "0hk983mywimclgnjc41zmlppm5kfdz2aj85ky07p49ilcqxi998f"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
@@ -188,30 +213,24 @@
          (add-after 'unpack 'prepare-deps
            (lambda* (#:key inputs #:allow-other-keys)
              (mkdir "deps/srccache")
-             (copy-file (assoc-ref inputs "dsfmt")
-                        "deps/srccache/dsfmt-2.2.3.tar.gz")
+             ;; no USE_SYSTEM_{OBJCONV/LIBWHICH}
              (copy-file (assoc-ref inputs "objconv")
                         "deps/srccache/objconv.zip")
-             (copy-file (assoc-ref inputs "suitesparse")
-                        "deps/srccache/SuiteSparse-4.4.5.tar.gz")
-             (copy-file (string-append (assoc-ref inputs "virtualenv")
-                                       "/bin/virtualenv")
-                        "julia-env")
              (copy-file (assoc-ref inputs "libwhich")
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9c=
e7e89e"
                                        ".tar.gz"))
-             (copy-file (assoc-ref inputs "rmath")
-                        "deps/srccache/Rmath-julia-0.1.tar.gz")
-
 	     ;; needed by libwhich
 	     (setenv "LD_LIBRARY_PATH"
 		     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs =
pkg)
                                                         "/lib"))
-                                       '("arpack-ng" "fftw" "gmp" "lapack"
-			                 "libgit2" "mpfr" "openblas" "openlibm"
-			                 "openspecfun" "pcre2"))
+                                       '("arpack-ng" "curl" "dsfmt"
+                                         "gmp" "lapack"
+                                         "libssh2" "libgit2"
+                                         "mbedtls" "mpfr"
+                                         "openblas" "openlibm" "pcre2"
+                                         "suitesparse"))
                                   ":"))
 	     #t))
          ;; FIXME: Building the documentation requires Julia packages that
@@ -233,44 +252,12 @@
           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is n=
ot
           ;; used in Guix, we patch runtime_ccall.cpp to contain a static =
map.
           (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix Sys=
tem.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
-
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] =3D "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";=
")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.s=
o")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.=
so"))))))
             (substitute* "base/math.jl"
               (("const libm =3D Base.libm_name")
                (string-append "const libm =3D \""
                               (assoc-ref inputs "openlibm")
                               "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun =3D \"libopenspecfun\"")
-               (string-append "const openspecfun =3D \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+                              "\"")))))
          (add-before 'build 'fix-include-and-link-paths
           (lambda* (#:key inputs #:allow-other-keys)
             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
@@ -278,10 +265,10 @@
             ;; collection of build targets and a list of libraries to link
             ;; against.
             (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(L=
IBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) =
\\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OB=
JS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DO=
BJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_=
debug)"))
=20
             ;; The REPL must be linked with libuv.
             (substitute* "ui/Makefile"
@@ -296,38 +283,28 @@
                               "/include/uv/errno.h")))
             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
-         (add-after 'unpack 'hardcode-paths
            (lambda _
-             (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
-               (("`which") (string-append "`" (which "which")))
-               (("`wget")  (string-append "`" (which "wget"))))
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
              #t))
-         (add-before 'check 'disable-broken-tests
+         (add-before 'check 'fix-broken-tests
            (lambda _
-             (define (touch file-name)
-               (call-with-output-file file-name (const #t)))
-	     ;; FIXME: All git tests works except this one. But *THIS* "fix"
-             ;; is not working, so right now I'm disabling all libgit2.jl =
tests
-	     ;; (substitute* "stdlib/LibGit2/test/libgit2.jl"
-	     ;; (("!LibGit2.use_http_path(cfg, github_cred)") "true")
-	     ;; (("LibGit2.use_http_path(cfg, mygit_cred)") "true"))
-             (map (lambda (test)
-                    (delete-file test)
-                    (touch test))
-	          '("stdlib/Sockets/test/runtests.jl"
-		    "stdlib/Distributed/test/runtests.jl"
-                    ;; FIXME: see above
-		    "stdlib/LibGit2/test/libgit2.jl"))
-	     (substitute* "test/choosetests.jl"
-	       ;; These tests fail, probably because some of the input
-	       ;; binaries have been stripped and thus backtraces don't look
-	       ;; as expected.
-	       (("\"backtrace\",") "")
-	       (("\"cmdlineargs\",") ""))
+             (substitute* "test/choosetests.jl"
+               (("tests =3D testnames")
+                ;; Those failings are not deterministic.  They depends on =
the
+                ;; running order.  I think it depends on the number of
+                ;; runners, disabling it for now
+                ;; https://github.com/JuliaLang/julia/issues/34330
+                "tests =3D filter(e->!in(e,[\"backtrace\",\"exceptions\",\=
"client\",\"stacktraces\"]),testnames)"))
+             ;; When HOME is not set, julia calls uv_os_homedir, which in
+             ;; turns call getpwuid_r. Add the HOME env variable to the
+             ;; external julia call to fix this
+             (substitute* "test/cmdlineargs.jl"
+               (("\"JULIA_PROJECT\"") "\"HOME\"=3D>\"/tmp\", \"JULIA_PROJE=
CT\""))
+             ;; Marking the test as broken as it's a known bug:
+             ;; https://github.com/JuliaLang/julia/issues/32377
+             (substitute* "stdlib/REPL/test/replcompletions.jl"
+               (("@test count") "@test_broken count"))
 	     #t)))
        #:make-flags
        (list
@@ -345,26 +322,21 @@
            ;; platforms, e.g. when running "guix package --search=3D"
            (_ "MARCH=3DUNSUPPORTED"))
=20
-        "CONFIG_SHELL=3Dbash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=3D0"    ;not packaged for Guix and upstream has =
no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=3Dbash"             ;needed to build bundled librari=
es
+        ;; list of "USE_SYSTEM_*" is here:
+        ;; https://github.com/JuliaLang/julia/blob/v1.3.1/Make.inc
+        "USE_SYSTEM_DSFMT=3D1"
+        "USE_SYSTEM_P7ZIP=3D1"
         "USE_SYSTEM_LAPACK=3D1"
         "USE_SYSTEM_BLAS=3D1"
         "USE_BLAS64=3D0"          ;needed when USE_SYSTEM_BLAS=3D1
         "LIBBLAS=3D-lopenblas"
         "LIBBLASNAME=3Dlibopenblas"
=20
-        "USE_SYSTEM_FFTW=3D1"
-        "LIBFFTWNAME=3Dlibfftw3"
-        "LIBFFTWFNAME=3Dlibfftw3f"
-
-        ;; TODO: Suitesparse does not install shared libraries, so we cann=
ot
-        ;; use the suitesparse package.
-        ;; "USE_SYSTEM_SUITESPARSE=3D1"
-        ;; (string-append "SUITESPARSE_INC=3D-I "
-        ;;                (assoc-ref %build-inputs "suitesparse")
-        ;;                "/include")
-
+        "USE_SYSTEM_SUITESPARSE=3D1"
+        (string-append "SUITESPARSE_INC=3D-I "
+                       (assoc-ref %build-inputs "suitesparse")
+                       "/include")
         "USE_GPL_LIBS=3D1"        ;proudly
         "USE_SYSTEM_UTF8PROC=3D1"
         (string-append "UTF8PROC_INC=3D"
@@ -385,16 +357,19 @@
 	"USE_SYSTEM_PATCHELF=3D1"
 	"USE_SYSTEM_PCRE=3D1"
 	"USE_SYSTEM_OPENLIBM=3D1"
-
+        "USE_SYSTEM_LIBM=3D0"
+        "USE_SYSTEM_LIBSSH2=3D1"
+        "USE_SYSTEM_CURL=3D1"
 	"USE_SYSTEM_GMP=3D1"
 	"USE_SYSTEM_MPFR=3D1"
+	"USE_SYSTEM_MBEDTLS=3D1"
 	"USE_SYSTEM_ARPACK=3D1"
 	"USE_SYSTEM_LIBGIT2=3D1"
-	"USE_SYSTEM_ZLIB=3D1"
-	"USE_SYSTEM_OPENSPECFUN=3D1")))
+	"USE_SYSTEM_ZLIB=3D1")))
     (inputs
      `(("llvm" ,llvm-julia)
=20
+       ("p7zip" ,p7zip)
        ;; The bundled version is 3.3.0 so stick to that version.  With oth=
er
        ;; versions, we get test failures in 'linalg/arnoldi' as described =
in
        ;; <https://bugs.gnu.org/30282>.
@@ -403,12 +378,12 @@
        ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
        ("openblas" ,openblas) ;Julia does not build with Atlas
-       ("libunwind" ,libunwind)
+       ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
-       ("openspecfun" ,openspecfun)
+       ("mbedtls" ,mbedtls-apache)
+       ("curl" ,curl)
        ("libgit2" ,libgit2)
-       ("fftw" ,fftw)
-       ("fftwf" ,fftwf)
+       ("libssh2" ,libssh2)
        ("fortran" ,gfortran)
        ("libuv" ,libuv-julia)
        ("pcre2" ,pcre2)
@@ -418,31 +393,12 @@
        ("which" ,which)
        ("zlib" ,zlib)
        ("gmp" ,gmp)
-       ("virtualenv" ,python2-virtualenv)
+       ("suitesparse" ,suitesparse)
        ;; FIXME: The following inputs are downloaded from upstream to allo=
w us
        ;; to use the lightweight Julia release tarball.  Ideally, these in=
puts
        ;; would eventually be replaced with proper Guix packages.
-
-       ;; TODO: run "make -f contrib/repackage_system_suitesparse4.make" t=
o copy static lib
-       ;; Find dependency versions here:
-       ;; https://raw.githubusercontent.com/JuliaLang/julia/77a2c1e245c858=
12dc1c7687540beedecc52758f/deps/Versions.make
-       ("rmath"
-	,(origin
-	   (method git-fetch)
-	   (uri (git-reference
-                 (url "https://github.com/JuliaLang/Rmath-julia")
-                 (commit "v0.1")))
-           (file-name "rmath-julia-0.1-checkout")
-	   (sha256
-	    (base32
-	     "1zkpy0cg5zivq40zbhbdgj9128fqzs2j94wkwih8nc6xaj3gp9p6"))))
-       ("suitesparse"
-        ,(origin
-           (method url-fetch)
-           (uri "http://faculty.cse.tamu.edu/davis/SuiteSparse/SuiteSparse=
-4.4.5.tar.gz")
-           (sha256
-            (base32
-             "1jcbxb8jx5wlcixzf6n5dca2rcfx6mlcms1k2rl5gp67ay3bix43"))))
+       ;; Find dependencies versions here:
+       ;; https://raw.githubusercontent.com/JuliaLang/julia/v1.3.0/deps/Ve=
rsions.make
        ("objconv"
         ,(origin
            (method url-fetch)
@@ -467,15 +423,7 @@
 	     (sha256
 	      (base32
 	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
-       ("dsfmt"
-        ,(origin
-           (method url-fetch)
-           (uri (string-append
-                 "http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/"
-                 "SFMT/dSFMT-src-2.2.3.tar.gz"))
-           (sha256
-            (base32
-             "03kaqbjbi6viz0n33dk5jlf6ayxqlsq4804n7kwkndiga9s4hd42"))))))
+       ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
        ("perl" ,perl)
--=20
2.24.1




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:38 2020
Received: from localhost ([127.0.0.1]:40698 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoGH-000771-OE
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:38 -0500
Received: from mail-wr1-f50.google.com ([209.85.221.50]:35171)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoGG-00076U-4m
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:36 -0500
Received: by mail-wr1-f50.google.com with SMTP id g17so25206327wro.2
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:36 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=yqi6NU8znKG+TtYigo1FxEFwMUGT7B5Q2jmVrIMFp28=;
 b=aAZ50oPWc6XiOweo7rX3qw1RLaaK1Mt79rHhACvOVcoXCpCDFmGe7iujSlMWlyonmb
 bdvtzaINfkAt0I8f73I4pCLfUMC5VgqGwCGNt+kv+TNghUDEINsBaCz7LAynzSe6XwpJ
 cIDtj+WZ8n7xwkzsf92qssuG4U/XTYc4yRgZXrxLfR/Db/YCGBaqRlTuXE7UFni7dDzy
 80jb/FoIxUxaksbcU0hXqiPQUNnDLdbdSf+v/+KGchquTKotMan3S1jNX2wKVGxXSxxv
 x5F6oo58wl2vKsiglZTNVDqr0ZPRCAiK3No9j3MFqMQoTXSLnRMukstqEh1y1N57wfFZ
 p0wQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=yqi6NU8znKG+TtYigo1FxEFwMUGT7B5Q2jmVrIMFp28=;
 b=a2tv46YWSlb/cLKLxFZLowX3MDxFteraPKvM9AZVFnQvpIuBQQ5aUivmal3s9vP8wj
 NruYpRvoAzfBzhFjUCFrqZ6ZrOqx1I2+4bSE6Dy0Aj21p0sxIsu2DlbINgvVla6UXtGR
 V8BSOxwiifQ2755Sqp1Ek6xpjVe9uXq+L7OozyHyW8FnUmDOjwdvOQUoGcxiYPPPtWuk
 zgtkTfCp+wj00K/ZIkEOAs3dYQfgi9SpAXe9tRye101EcMTFcFN/+w9bJHIRqY5P1hYp
 321JxLPPj82i51YEGBPmP6jKaIWH9VugvCTonhWjayT7skisvdLqCTY2HAZZevgKsfTN
 9UVQ==
X-Gm-Message-State: APjAAAXT4UuuGBLQ7OM/sylRiIMkcAh/a5Lw/mf8ptpxei5V1LYVajuf
 Q19LWF4mMFz75vXfav/6d25r9QLu
X-Google-Smtp-Source: APXvYqwbUAo7sqofAS1cdzgzlzb0E2QTP3KjLMkC+xtaXc/K/ntpMTbFx9N5l+HCRXPCdLJsfwLxtQ==
X-Received: by 2002:a5d:548e:: with SMTP id h14mr7908454wrv.380.1579354530235; 
 Sat, 18 Jan 2020 05:35:30 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id t131sm15151276wmb.13.2020.01.18.05.35.29
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:29 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 11/11] gnu: Add julia-http.
Date: Sat, 18 Jan 2020 14:11:45 +0100
Message-ID: <87blr0vqe7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm (julia-http): New variable.
---
 gnu/packages/julia-xyz.scm | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 3e9f532697..ff1bb483f9 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -148,3 +148,27 @@ binaries required by julia packages.")
     (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
 cryptography C libary for Julia.")
     (license license:expat)))
+
+(define-public julia-http
+  (package
+    (name "julia-http")
+    (version "0.8.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaWeb/HTTP.jl")
+             (commit (string-append "v" version))))
+       (file-name "HTTP")
+       (sha256
+        (base32 "0928fvncfp07i5hvqxjyj8i27xmxxllas1m5idqq2i8h7jshzq3y"))))
+    (propagated-inputs
+     `(("julia-inifile" ,julia-inifile)
+       ("julia-mbedtls" ,julia-mbedtls)
+       ("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://juliaweb.github.io/HTTP.jl/")
+    (synopsis "HTTP support for Julia")
+    (description "@code{HTTP.jl} is a Julia library for HTTP Messages,
+implementing both a client and a server.")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:37 2020
Received: from localhost ([127.0.0.1]:40696 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoGH-00076z-EP
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:37 -0500
Received: from mail-wm1-f68.google.com ([209.85.128.68]:38773)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoGD-00076E-Iq
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:34 -0500
Received: by mail-wm1-f68.google.com with SMTP id u2so10285283wmc.3
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=dkWhEsJxIVsduip/IR1sjUmS0HukAVzwsS4Wb6iDTM0=;
 b=cPgGEts7KiyTXrYwstyu5NirA18OkaQoUWDvskFdh7Hv8Gy4Cm5hp8d0wfzXRBvSLk
 87fI253jfgie6mHfxNGdQs+6Ft5xApeh/xLn/SZzHLNomeiU/WRunWMWkcUJ5ktJj7Yb
 G7SEWPaU/wWtrMarEtSyquKANreSDtR6bx9gwkamKe7ttpSGtiVwrcoC2eS2fNxb3zzJ
 ZIJwIgNRplK36KT/a1M0m6yYuOiyhYQnqKhDAHON4j+cV+8uopqncU5WjfTvdfPjKdIB
 RG358AB3PzRmm5k6FORN3ybexDBdJMmC3N5PawM46ZvSUDOSaL/l2kSePmEJDdEnFW2l
 ezVA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=dkWhEsJxIVsduip/IR1sjUmS0HukAVzwsS4Wb6iDTM0=;
 b=aGMhh97QGJ55CUHMnRRdhPtUZw2ya7gRdIAgRggXtR3Ciey70/4P5mQ+ipZncOl2XJ
 uoptVD6VkmIlK4X6HxmRTsFVwVwtdO/NTalct5Y+YmGL5bqoIzmi8cjWr9uQbesoDSPm
 6zMlt2/cZN91BSMU6kw61gje4KOWFPltL3tmKTszH9m636mbcx897GyBkDCXqBXVyjT0
 tflNY3t3uNQDfpngiEKVVPLAhvjM/6hDY8l4WOK+zP9gpBTYPtf6cDEIIXcd5mUEY+wR
 JYc9Bq2QHp9/0pOXHSjHgfxUxNlzbfKJOj+bfblbkt7ZDTEuIEnioyJkQw0QgojJVlzP
 CTNg==
X-Gm-Message-State: APjAAAVp1DDSecGsqLL7u2T/45aEa5eKRODW41JdgFUwrE0dRnq0BJ7+
 Sn3McuIVrqBNyPyUNUmRDypA6AYF
X-Google-Smtp-Source: APXvYqxpXXMChw2JCC8N/yF8hmfop12/WB5dOEGuwY/9MN3QtCgf7/OzIgglDrN1Pc0idF261e3pYA==
X-Received: by 2002:a05:600c:2959:: with SMTP id
 n25mr6385404wmd.185.1579354527625; 
 Sat, 18 Jan 2020 05:35:27 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id k16sm39617833wru.0.2020.01.18.05.35.26
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:27 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 10/11] gnu: Add julia-mbedtls.
Date: Sat, 18 Jan 2020 14:11:14 +0100
Message-ID: <87d0bgvqe9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm (julia-mbedtls): New variable.
---
 gnu/packages/julia-xyz.scm | 49 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 48 insertions(+), 1 deletion(-)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 0f8e04b4d1..3e9f532697 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -2,7 +2,8 @@
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix packages)
   #:use-module (guix git-download)
-  #:use-module (guix build-system julia))
+  #:use-module (guix build-system julia)
+  #:use-module (gnu packages tls))
 
 (define-public julia-compat
   (package
@@ -101,3 +102,49 @@ function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
     (description "@code{BinaryProvider.jl} simplifies the installation of
 binaries required by julia packages.")
     (license license:expat)))
+
+(define-public julia-mbedtls
+  (package
+    (name "julia-mbedtls")
+    (version "0.7.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/MbedTLS.jl")
+             (commit (string-append "v" version))))
+       (file-name "MbedTLS")
+       (sha256
+        (base32 "1a8snw9gi21lm6r3kh6ly7ngi99s9k5shqkfiizj3g9li20q23h2"))))
+    (propagated-inputs
+     `(("julia-binaryprovider" ,julia-binaryprovider)
+       ("mbedtls-apache" ,mbedtls-apache)))
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-before 'precompile 'build-deps
+           (lambda* (#:key outputs source inputs #:allow-other-keys)
+             (let ((f (open-file
+                       (string-append
+                        (assoc-ref outputs "out")
+                        "/share/julia/packages/"
+                        (string-append
+                         (strip-store-file-name source) "/deps/deps.jl"))
+                       "w")))
+               (display (string-append "const libmbedcrypto = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedcrypto.so\"\n") f)
+               (display (string-append "const libmbedtls = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedtls.so\"\n") f)
+               (display (string-append "const libmbedx509 = \""
+                                       (assoc-ref inputs "mbedtls-apache")
+                                       "/lib/libmbedx509.so\"\n") f)
+               (close-port f))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/MbedTLS.jl")
+    (synopsis "Apache's mbed TLS library wrapper")
+    (description "@code{MbedTLS.jl} provides a wrapper around the mbed TLS and
+cryptography C libary for Julia.")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:34 2020
Received: from localhost ([127.0.0.1]:40693 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoGE-00076e-5r
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:34 -0500
Received: from mail-wm1-f67.google.com ([209.85.128.67]:37572)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoGB-000760-NI
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:33 -0500
Received: by mail-wm1-f67.google.com with SMTP id f129so10303928wmf.2
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=uO5YfTFrrMVSnmGfyWGOuKUKzCewIhmMgyopSlglAgM=;
 b=NE7LiOVqAJTYrOCWA9RQaMx92hRUfdvha8jXsm71QaJeogek1HsTxYzgjcuW52VVXc
 NaGBDkO52JZbtLD4ptJn2Hr6ULPTKlZLaBaQDUk4zcMthwnHo8n1jQiq1naY1XpDzm69
 NvSzBwHG8kSCjp8zBhbyZgrUAFTi5GNKOHLMhR/bdalGPKjaMhRcOWHFrk0w2XJgHJ00
 zj9dNpGMxqUHtlrQLpUWfy0TtmnPjBi5GdETwFdqmCEzz66o+CW7cSjqBwQcdzwqkYTp
 uw1r4FCC2wUATGkp9eb3r0p2Ti1sWXyJI9ScWupgLazP4zgX6obYmh1/r8BROMWr0SGu
 rJ1A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=uO5YfTFrrMVSnmGfyWGOuKUKzCewIhmMgyopSlglAgM=;
 b=bavd/W0rL9Lzs97O0E529bxM/NyX0m0vpSMVQ3SIKMci04c7Et9Hytvq3DCPcyJjmX
 0w7JUFX+VU5KLbGx19lk/W2695S1VptG0gZwxxbPYIytbhhYFo7yNE7lGH4RFT6MTyER
 hYyEEOEOf5BaL0cpaQW1lPXonP2cNgwf9zHGJnPYkIsb4J2FkAwi7un835tVvetyyM34
 ZRO4v6JLhcCr5wWq7chi56GVQ/nksyifuYdDqJ7yh/CrQT+Jujfb3RU2y1Cy2+g3bzGg
 NsxBtEWqIbheWfqDL5GmGQF7p+Fa6YLfcoNunrrkePyrpxAiqmqGLkJEy90uoXV+NMT6
 akhA==
X-Gm-Message-State: APjAAAVtCKhEJWd+vP6Q/IhqN6eW9mvjRBPs0SHjaGNIdSixkg0DQE78
 I/+SXnhXqZaJOyiwZgGDf+KcCLVc
X-Google-Smtp-Source: APXvYqwHR1FwH3mPEZIh/wZq5GQSM9O6aKsRz7Q2+XNuWjOrnOGEV0d9ID7g9nzWS+KLe5PBSIGnrA==
X-Received: by 2002:a1c:80d4:: with SMTP id b203mr9968211wmd.102.1579354525250; 
 Sat, 18 Jan 2020 05:35:25 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id y17sm235843wma.36.2020.01.18.05.35.24
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:24 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 09/11] gnu: Add julia-binaryprovider.
Date: Sat, 18 Jan 2020 14:07:36 +0100
Message-ID: <87eevwvqec.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm (julia-binaryprovider): New variable.
---
 gnu/packages/julia-xyz.scm | 33 +++++++++++++++++++++++++++++++++
 1 file changed, 33 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 92ffde58e7..0f8e04b4d1 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -68,3 +68,36 @@ allows to interface with @file{.ini} files")
 function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
 @code{IO} object.")
     (license license:expat)))
+
+(define-public julia-binaryprovider
+  (package
+    (name "julia-binaryprovider")
+    (version "0.5.8")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaPackaging/BinaryProvider.jl")
+             (commit (string-append "v" version))))
+       (file-name "BinaryProvider")
+       (sha256
+        (base32 "174jmg4w8ncgfhdvfnm0p4cnlayw31j4s9sksqlwz1sipywqvww7"))))
+    (propagated-inputs `(("julia-sha" ,julia-sha)))
+    ;; We don't really need BinaryProvider (as guix provides the binaries) but
+    ;; since it's a dependency of other packages we want to precompile it.
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'disable-engine-probe
+           (lambda _
+             (substitute* "src/BinaryProvider.jl"
+               ;; Precompilation tries to download things from the internet,
+               ;; disable the download part
+               (("probe_platform_engines") "# probe_platform_engines"))
+             #t)))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaPackaging/BinaryProvider.jl")
+    (synopsis "Reliable Binary provider for Julia")
+    (description "@code{BinaryProvider.jl} simplifies the installation of
+binaries required by julia packages.")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:30 2020
Received: from localhost ([127.0.0.1]:40689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoG9-00076M-UF
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:30 -0500
Received: from mail-wm1-f46.google.com ([209.85.128.46]:50609)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoG8-00075k-5W
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:29 -0500
Received: by mail-wm1-f46.google.com with SMTP id a5so10060791wmb.0
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:28 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=xvh5LIGoAp424JxkF0udeGC5Th13yeNJc2jMKkku9Z0=;
 b=ZB2wSYq/z31Cgubg6S3L40ttwHbjUTzyNAvW5BGOUyXiQB2+IkyEffXAgDc0/ggxxO
 wTUEy+dZyaqqvJnbfKWYDRutfe1ireg+xTupM6wcCRC9Ulm8bP8d7bNY2wpA12oECk7s
 n7aTUmyRMcxcUfSwrGY2DmKspA7RxRZYH+lSvciTcGPxgDIWiqC4J/OXIwtwRYdCEtaV
 n74tolD/jaN11pPaUTYTykB2tFM66NGBpuiAGHt9I74VaTCMjakp47k3cklsHaZInQ69
 nQ0Kgh1tMlht2jAVXJ+QIIqotpJaIBkjeal3bUV5gf4vK5r6JWrYYPY+TifcIkBQkwAW
 FzSw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=xvh5LIGoAp424JxkF0udeGC5Th13yeNJc2jMKkku9Z0=;
 b=julaVNgGCnZBRtQZqeSK7MwW6ao7YQ6lmgyHfXlkKMXhb5HEtEVMmitFe01Buvck0w
 jZhVX/aLfwnX8Lc/84CvjgX/NXtyROPCFDaHCa/bs4XC2RO3d0wlqO1U5WzoXgKkuql/
 byFg60/odqnGzgMxE9DywXTovOF2F/5p4EtBKzuT9LTzRXOT+yNdu7+T24X6T9dNKy7/
 eVTYzguWNQE6yXD+rSZNHvZPM13qgNvLNpp6UpnpoX/YPSzzKVifYjGzOJ3DjW5oUc//
 5oDVspvvYeEQ6JTsgDLyF7oTFfinCu9M1O8enIyc5OpG1r5mbiewQgRh7nBfqGNnbe0h
 5xYg==
X-Gm-Message-State: APjAAAVUsam1s51tHfLcGdSKpEpeUefu06wUm5aD6JjxfBBmNXmePhVR
 dhyXZN3UbCAjVh7Evn7sCkL3uAFV
X-Google-Smtp-Source: APXvYqz21Snt74pYAeq5eEX2nWYwaRjg0K2GWrTJ4l918BD9esJq9Kg+CmnpyF99XEeGzx4ZFU65SQ==
X-Received: by 2002:a05:600c:224d:: with SMTP id
 a13mr9376350wmm.57.1579354522205; 
 Sat, 18 Jan 2020 05:35:22 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id t125sm14780950wmf.17.2020.01.18.05.35.21
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:21 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 08/11] gnu: Add julia-sha.
Date: Sat, 18 Jan 2020 14:07:13 +0100
Message-ID: <87ftgcvqee.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm (julia-sha): New variable.
---
 gnu/packages/julia-xyz.scm | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 6b8053e5f8..92ffde58e7 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -45,3 +45,26 @@ way.")
     (description "This is a julia package that defines an IniFile type that
 allows to interface with @file{.ini} files")
     (license license:expat)))
+
+(define-public julia-sha
+  (package
+    (name "julia-sha")
+    (version "0.5.7")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/staticfloat/SHA.jl")
+             (commit (string-append "v" version))))
+       (file-name "SHA")
+       (sha256
+        (base32 "10a09kg9z0m8rvwmlgsna6p342kyvizx2axdqc6pzyhraddr8jrp"))))
+    (propagated-inputs `(("julia-compat" ,julia-compat)))
+    (build-system julia-build-system)
+    (home-page "https://github.com/staticfloat/SHA.jl")
+    (synopsis
+     "Performant, 100% native-julia SHA1, SHA2, and SHA3 implementation")
+    (description "Julia package implementing SHA algorithms.  Each exported
+function takes in either an @code{Array{UInt8}}, a @code{ByteString} or an
+@code{IO} object.")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:27 2020
Received: from localhost ([127.0.0.1]:40686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoG7-000767-LZ
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:27 -0500
Received: from mail-wr1-f51.google.com ([209.85.221.51]:37373)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoG3-00075D-CI
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:26 -0500
Received: by mail-wr1-f51.google.com with SMTP id w15so25286744wru.4
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:23 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=qLWFlL8nfW7ef0DZVdBxhDYxhLyDwtn5SnI0OuCkqjI=;
 b=iCajD5oPngS8T1r5LlakSgtfm13vcXWqlI1xCsehG3TjATeWFTg+f31At1d6jTze7C
 wejfRtKbAJuoMPbj4gDEeRkocjPO8VjN4OYa2pBF0wymcGVNdCMfazHDpdrzlO6VwibF
 k7I4OvvSvUE8rWsFoqSaVkF3eUyvB4GgPZY4y94JU+akyDYuLq71fNpe99iWUgFsanU3
 YhFuGcKUERFgp082dzPVIDUSj//rkA8RDzXZjTi7ND7927/MLLGnEO5IOAfepyuV1dAp
 7uw2WRJrlv15h6jn88/208kqAyc+wp2WTqjg4pNpbYgJw169DwrMk+qF9DraAuFuge8x
 RFjw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=qLWFlL8nfW7ef0DZVdBxhDYxhLyDwtn5SnI0OuCkqjI=;
 b=A57m5KH4NWD3WT+eyWB/YnsmH6x7DyVTUWB9Y2Q8k2/cqCr9VXPYeP6ntZfrq0cc6k
 n2aQEwuYipLTkRI7d1uof3fkwfU8ehMV4VfZDW4dKTQ+PogD+Hg2ioZbrIK0KluaAMmi
 MQG07jUu0oKTUWuAKGylbNOZdYx4bQUmL8wZTpXzcxfDtPPfdstOJ22VDbj2UhdBWhci
 oo25KEItKfXmnVVX5H/YMHEGcLHF6AeyZEaMX2SuX6xuEPo2io1iAIU7fgeZHlcyVFAM
 QVdxYNbe4CmysDDJiFLPTDtVVDUlYvMhiZVRE5YJZC3RY9gn87bVH7RIPiNHd8GIRbHu
 T/wg==
X-Gm-Message-State: APjAAAWIfO8gux0nNAwzKx7RLorJu6MNIYqfwaM5aUxEuJqPxi4AsuaS
 0rC9aIVisLivVdxeTtn5nEX6skDK
X-Google-Smtp-Source: APXvYqxbbta6Q6KBczFjlQipyNCE1d88H02ePs6li+lcPdo00JuuoF6Q1UXBwgUUDcNri3CNUd7Y4w==
X-Received: by 2002:adf:f605:: with SMTP id t5mr8199052wrp.282.1579354517402; 
 Sat, 18 Jan 2020 05:35:17 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id p18sm14372380wmb.8.2020.01.18.05.35.16
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:16 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 07/11] gnu: Add julia-inifile.
Date: Sat, 18 Jan 2020 14:06:11 +0100
Message-ID: <87h80svqej.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm (julia-inifile): New variable.
---
 gnu/packages/julia-xyz.scm | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
index 7d9faa63e9..6b8053e5f8 100644
--- a/gnu/packages/julia-xyz.scm
+++ b/gnu/packages/julia-xyz.scm
@@ -25,3 +25,23 @@ between older and newer versions of the Julia language.  The Compat package
 provides a macro that lets you use the latest syntax in a backwards-compatible
 way.")
     (license license:expat)))
+
+(define-public julia-inifile
+  (package
+    (name "julia-inifile")
+    (version "0.5.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaIO/IniFile.jl")
+             (commit "8ba59958495fa276d6489d2c3903e765d75e0bc0")))
+       (file-name "IniFile")
+       (sha256
+        (base32 "11h6f99jpbg729lplw841m68jprka7q3n8yw390bndlmcdsjabpd"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaIO/IniFile.jl")
+    (synopsis "Reading Windows-style INI files")
+    (description "This is a julia package that defines an IniFile type that
+allows to interface with @file{.ini} files")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:24 2020
Received: from localhost ([127.0.0.1]:40684 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoG4-00075p-Cv
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:24 -0500
Received: from mail-wm1-f51.google.com ([209.85.128.51]:35309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoG0-000754-7l
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:22 -0500
Received: by mail-wm1-f51.google.com with SMTP id p17so10332911wmb.0
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:20 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=GnIoBFrtNSeDRAfvbds5a8dE14FgGxkaDFQzX+fwTAk=;
 b=q2DMH44klEN8/mirMec00UCSDdE74Y9Hib6UeRYcqOfdSFk6GSX59UxFH8//sIHiZN
 7bmCPEReuMnWpjfjKzP+cZQHkyqwaKJ9vzTvhvzJLIg1lPoEZxuaO0ugQoRud0MHPgy2
 CqtiXicwKh3aGtp/u2AcX4/FbQz5qCm964a2r553lw6QUdkaZKztCaiMYiZ7ZT6Bexff
 tmXxEDv8uY4zCtgTH1qKpbSoSOcDKzf20fNjdh3TLC2iaXUG7WUuMXuMlnOwc1HkduhQ
 avLIk6/C+dO0lSYDtzbX5TqBNLmblEBzb2QzrHVzgsUnSyj+BLYYDJLdjJ6YUcuxa/Xt
 s2Ww==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=GnIoBFrtNSeDRAfvbds5a8dE14FgGxkaDFQzX+fwTAk=;
 b=q7ZiJ+RWfAJ59ex9ziHN/2GhYp7iGzCyPcL0dnhvNKoDKy53ZAMgz9xVogymi13d3Q
 /M1YWayxa9cpwil/YKj/W1FQQ3N82Itr2RsZmkEvEgHYD0IqYgc3cquL47thkcg2Fr0x
 vObNpFQE0QSL/qH1E07sZNapZlTMKmvNrRff4ffEkBjlaqGz6WgJvl/siqz0o7fF53DX
 xl2E1R2odIAWlINW7NT6VyeZsSjfAyEY2Oq2FnPcRXVF3Dm7WgYOTAxDYk/rE7FIMqqn
 FCtUvcTmRLiKNlei5gVjGnCFYo84NaylRuwGk/dywIBl5Ino8SULum7hXjftxVZLp8a6
 B2dA==
X-Gm-Message-State: APjAAAXTeYW7mmmK2ToTa6Z4N77iWDQUvkhUZN8q/pjSouUWFFaeqGtn
 w9XsRkS1Q/ApvBd/VAIHdP7kgRnG
X-Google-Smtp-Source: APXvYqxKJrAVFx8ZJ7wXa1l0KjqChODGWgUfrVpywnYpwK4k9pCreXEKqAiOD1g53BPVQUYzAWm3Jg==
X-Received: by 2002:a7b:c3d2:: with SMTP id t18mr10068112wmj.90.1579354514069; 
 Sat, 18 Jan 2020 05:35:14 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id q68sm15983642wme.14.2020.01.18.05.35.13
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:13 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 06/11] gnu: Add julia-compat.
Date: Sat, 18 Jan 2020 14:05:00 +0100
Message-ID: <87iml8vqen.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


* gnu/packages/julia-xyz.scm: New file
* gnu/packages/julia-xyz.scm (julia-compat): New variable
---
 gnu/local.mk               |  1 +
 gnu/packages/julia-xyz.scm | 27 +++++++++++++++++++++++++++
 2 files changed, 28 insertions(+)
 create mode 100644 gnu/packages/julia-xyz.scm

diff --git a/gnu/local.mk b/gnu/local.mk
index fe8634b44d..e07229ee20 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -277,6 +277,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/packages/jrnl.scm				\
   %D%/packages/jose.scm				\
   %D%/packages/julia.scm			\
+  %D%/packages/julia-xyz.scm			\
   %D%/packages/jupyter.scm			\
   %D%/packages/kawa.scm				\
   %D%/packages/kde.scm				\
diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
new file mode 100644
index 0000000000..7d9faa63e9
--- /dev/null
+++ b/gnu/packages/julia-xyz.scm
@@ -0,0 +1,27 @@
+(define-module (gnu packages julia-xyz)
+  #:use-module ((guix licenses) #:prefix license:)
+  #:use-module (guix packages)
+  #:use-module (guix git-download)
+  #:use-module (guix build-system julia))
+
+(define-public julia-compat
+  (package
+    (name "julia-compat")
+    (version "3.2.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/Compat.jl")
+             (commit (string-append "v" version))))
+       (file-name "Compat")
+       (sha256
+        (base32 "0d21h3l2ry2mmlhpg7b9cxifayzwcv7r13h5wydcbd5pjf6k4qd4"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/Compat.jl")
+    (synopsis "Compatibility across Julia versions")
+    (description "The Compat package is designed to ease interoperability
+between older and newer versions of the Julia language.  The Compat package
+provides a macro that lets you use the latest syntax in a backwards-compatible
+way.")
+    (license license:expat)))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:20 2020
Received: from localhost ([127.0.0.1]:40680 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoFz-00075P-W5
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:20 -0500
Received: from mail-wr1-f67.google.com ([209.85.221.67]:44794)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoFw-00074p-Kk
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:18 -0500
Received: by mail-wr1-f67.google.com with SMTP id q10so25226857wrm.11
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=3wHwIKzcx13DtpDUPgHgk/mc6iYE8CtmkxrF8EUOukw=;
 b=fG25p3DXwS1CdJn5djnqJFHijytlTCcTcQkwV1rLjbIHcRd9jG41E/2tlNvshj3xGZ
 cl2nFgQgDGb9KKyWYkw5hhC3wdFRPpfFxPm9y3MFWSObfaq97N3fkYIexR38D4/L4voz
 yYT46MbzgPIHu+OmnXrnwjzEaQa8jQGo9K3xziChb7YjKP13krAAgqBkCc2xDttUNnsQ
 tRdnT1/I9LR2yh/dTz6Ttxgr0W5CwXXve9d+8E/5KsUyR3V/VODrqQm8ZlEjSSNLHVbe
 dH+uF9FKRo7x095RuBPzJ3bJ5aI1cldbuattvRhdGaASbs6fv/I1eQqak16dzmrzM9pu
 FfZQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=3wHwIKzcx13DtpDUPgHgk/mc6iYE8CtmkxrF8EUOukw=;
 b=jHG8ECp+dmIWwvF7xqECfdniA/41gJABSN8VMOGhiFXxmXKn/u77JVDfJzlePQQHDF
 VEc7/35f/E0O4aUgFdiFAgTGrJe6c/d5j/CyVX11tLKJj6sGRFG2WuXggVcsz61Q5sEc
 y7IK5lbkVO9i1pFXgZeejuUwiRoOD/7Lln9XkM40IqwRq7rSDTMHvPALeLxFkFUBO9v5
 IzigcmGL9nKwDLMYvmjLa0m0TRTb+jZz5JX3wS9PGHDjXQ2QGypBRCpkM80lZ5+EfaEx
 lK9jSUCj2MTEqUrypLjxF+nQWX7zxaj8wn6Q1tQqb8OpSGrgrB3oKimbPpAmdesF1WK3
 /YBg==
X-Gm-Message-State: APjAAAW2F2wPjVmDsbHbxQ1urgC3gLNhZT4CLbo/1DJw/teJCcMOIxWF
 t0iOz4PXh5xWEEH2WC63DbuckWLU
X-Google-Smtp-Source: APXvYqzB5fFXuymWkcOKfhO2UqU0mucpCXl/dXbS2lDTZVY9oY0QGOiJH6kx6HQ+AVJxQI6vnDX/rA==
X-Received: by 2002:adf:fd07:: with SMTP id e7mr8381561wrr.21.1579354510576;
 Sat, 18 Jan 2020 05:35:10 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id f1sm38767911wru.6.2020.01.18.05.35.09
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:10 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 05/11] gnu: build: julia-build-system: fix package
Date: Fri, 17 Jan 2020 19:40:55 +0100
Message-ID: <87k15ovqeq.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.7 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  precompilation --- guix/build/julia-build-system.scm | 51
 +++++++++++++ 1 file changed, 22 insertions(+), 29 deletions(-) diff --git
 a/guix/build/julia-build-system.scm b/guix/build/julia-build-system.scm index
 ff6fcf5fe3..dbd4af623d 100644 --- a/guix/build/julia-build-system.scm +++
 b/guix/build/julia-build-system.scm @ [...] 
 Content analysis details:   (2.7 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: nixo.xyz]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.67 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.67 listed in wl.mailspike.net]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.8 DATE_IN_PAST_12_24     Date: is 12 to 24 hours before Received: date
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.7 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  precompilation --- guix/build/julia-build-system.scm | 51
    +++++++++++++ 1 file changed, 22 insertions(+), 29 deletions(-) diff --git
    a/guix/build/julia-build-system.scm b/guix/build/julia-build-system.scm index
    ff6fcf5fe3..dbd4af623d 100644 --- a/guix/build/julia-build-system.scm +++
    b/guix/build/julia-build-system.scm @ [...] 
 
 Content analysis details:   (1.7 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: nixo.xyz]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.221.67 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.221.67 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.8 DATE_IN_PAST_12_24     Date: is 12 to 24 hours before Received: date
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

 precompilation

---
 guix/build/julia-build-system.scm | 51 +++++++++++++------------------
 1 file changed, 22 insertions(+), 29 deletions(-)

diff --git a/guix/build/julia-build-system.scm b/guix/build/julia-build-sys=
tem.scm
index ff6fcf5fe3..dbd4af623d 100644
--- a/guix/build/julia-build-system.scm
+++ b/guix/build/julia-build-system.scm
@@ -1,5 +1,5 @@
 ;;; GNU Guix --- Functional package management for GNU
-;;; Copyright =C2=A9 2019 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
+;;; Copyright =C2=A9 2019, 2020 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,53 +37,46 @@
 ;; subpath where we store the package content
 (define %package-path "/share/julia/packages/")
=20
-(define (generate-load-path inputs outputs)
-  (string-append
-   (string-join (map (match-lambda
-                       ((_ . path)
-                        (string-append path %package-path)))
-                     ;; Restrict to inputs beginning with "julia-".
-                     (filter (match-lambda
-                               ((name . _)
-                                (string-prefix? "julia-" name)))
-                             inputs))
-                ":")
-   (string-append ":" (assoc-ref outputs "out") %package-path)
-   ;; stdlib is always required to find Julia's standard libraries.
-   ;; usually there are other two paths in this variable:
-   ;; "@" and "@v#.#"
-   ":@stdlib"))
-
 (define* (install #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package-dir (string-append out %package-path
-                                     (string-append
-                                      (strip-store-file-name source)))))
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+                                     (strip-store-file-name source))))
     (mkdir-p package-dir)
-    (copy-recursively source package-dir))
+    (copy-recursively (getcwd) package-dir))
   #t)
=20
-;; TODO: Precompilation is working, but I don't know how to tell
-;; julia to use use it. If (on rantime) we set HOME to
-;; store path, julia tries to write files there (failing)
 (define* (precompile #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (builddir (string-append out "/share/julia/"))
          (package (strip-store-file-name source)))
     (mkdir-p builddir)
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
-    ;; Actual precompilation
-    (invoke-julia (string-append "using " package)))
+    ;; add new package dir to the load path
+    (setenv "JULIA_LOAD_PATH"
+            (string-append builddir "packages/" ":"
+                           (or (getenv "JULIA_LOAD_PATH")
+                               "")))
+    ;; Actual precompilation.
+    (invoke-julia
+     ;; when using julia as a user, julia writes precompile cache to the f=
irst
+     ;; entry of the DEPOT_PATH list (by default, the home dir).  We want =
to
+     ;; write it to the store, so let's push the store path as the first
+     ;; element of DEPOT_PATH.  Once the cache file exists, this hack is n=
ot
+     ;; needed anymore (like in the check phase).  If the user install new
+     ;; pacakges, those will be installed and precompiled in the home dir
+     (string-append "pushfirst!(DEPOT_PATH, pop!(DEPOT_PATH)); using " pac=
kage)))
   #t)
=20
 (define* (check #:key source inputs outputs #:allow-other-keys)
   (let* ((out (assoc-ref outputs "out"))
          (package (strip-store-file-name source))
          (builddir (string-append out "/share/julia/")))
+    ;; With a patch, SOURCE_DATE_EPOCH is honored
+    (setenv "SOURCE_DATE_EPOCH" "1")
     (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+    (setenv "JULIA_LOAD_PATH" (string-append builddir "packages/"))
     (invoke-julia (string-append "using Pkg;Pkg.test(\"" package "\")")))
   #t)
=20
--=20
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:35:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:35:15 2020
Received: from localhost ([127.0.0.1]:40677 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoFu-000753-Mv
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:14 -0500
Received: from mail-wm1-f54.google.com ([209.85.128.54]:37907)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoFr-00074b-U4
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:35:13 -0500
Received: by mail-wm1-f54.google.com with SMTP id u2so10284656wmc.3
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:35:11 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=UsOPYVmbJHt8FK74CgycGw9Ov4jBseuNgiDMIBqtb2s=;
 b=av4+z1aRkRU1iTGjl0dWwGsIPAslta9iJ+9KZwvVemYYE+vjekaI8TiqBeKrxjxG/g
 omFUMxcvFm0ZL+b+NbcVYLmn/fWdViZkL3bstD2HOenzJ0HtDJoQdqYxax/hQTJvOu/b
 BEQ9r9Y0cn64b2fdGQ3T64bWFgxcu2kz46lFDbnhj9/l0zHLiqbUEVC3dQKBKhf/smMa
 HF/LBuckMQg7F3eh9qP+ZxUXNWtFfjvCOmP00sNaCsbuuEmqcJCS6PK2uyq2xuDGpbaI
 Yi5haay/FHasb56+9NFjc1c6mRQ6cHOAjhvbZFgqdjBd5gJ80g6uJA7UCZU7iPsIH20C
 cHew==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=UsOPYVmbJHt8FK74CgycGw9Ov4jBseuNgiDMIBqtb2s=;
 b=J6sKu6pKPw433r0mmy0PfW/Uq6bHj8Pgh39poUHVuUQIi6viV1rOEn9tGXugfkmENc
 sOtgFFkqbG+KFh7qYNEQqcB6NuP2Jm+SBwRFFM9HwH9IoNYivfGrlCHAQ/sloVckUi4Y
 T5/pugMdqKgOODIApuOv7MzN78IWy13QAs7bzsuvc4e17G6e0lbO/Pp49VsSS4g2qkc6
 KTuDqph3Asn45B38HaLzm/z3WQEssCyMyGToTHEcDK3zpVAYHeFC4lEJCu8+DtXSupJF
 DJpOb5kU/bbIcYJSDPJFR0V2jYZhNmOrVs1cpcwwGab81OLWeBUM2uSDzJYMpuEhBp6P
 oYEw==
X-Gm-Message-State: APjAAAW3WWpPp90GEUOuVvprDtZMoHapWaGx/i8+kZUZEKfN02aIskqg
 JuhH1KPgiwgBfFxeOu4Ezh9KqCLO
X-Google-Smtp-Source: APXvYqyFRTUgwjSWZwqgiuolxUKQX78mtpT7hwP2gcYGEgy2qfNLuHYz6Zt+e3TzGG+K3bWQxKucSw==
X-Received: by 2002:a05:600c:2c53:: with SMTP id
 r19mr9799893wmg.39.1579354505861; 
 Sat, 18 Jan 2020 05:35:05 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id y139sm5787986wmd.24.2020.01.18.05.35.04
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:35:05 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 04/11] use wrapper to set JULIA_LOAD_PATH and JULIA_DEPOT_PATH
Date: Sat, 18 Jan 2020 14:23:44 +0100
Message-ID: <87lfq4vqev.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


---
 gnu/packages/julia.scm | 25 +++++++++++++++++++++----
 1 file changed, 21 insertions(+), 4 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index e1c4685227..39c7d6d34f 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -297,7 +297,9 @@
                 ;; running order.  I think it depends on the number of
                 ;; runners, disabling it for now
                 ;; https://github.com/JuliaLang/julia/issues/34330
-                "tests = filter(e->!in(e,[\"backtrace\",\"exceptions\",\"client\",\"stacktraces\"]),testnames)"))
+                "tests = filter(e->!in(e,[\"backtrace\",\"exceptions\",\"client\",
+                                          \"stacktraces\",\"stress\",\"precompile\"]),
+                                testnames)"))
              ;; When HOME is not set, julia calls uv_os_homedir, which in
              ;; turns call getpwuid_r. Add the HOME env variable to the
              ;; external julia call to fix this
@@ -307,11 +309,23 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-             #t)))
+             #t))
+         (add-after 'install 'make-wrapper
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let* ((out (assoc-ref outputs "out"))
+                    (bin (string-append out "/bin"))
+                    (program "julia"))
+               (with-directory-excursion bin
+                 (wrap-program program
+                   `("JULIA_LOAD_PATH" ":" prefix
+                     ("" "$JULIA_LOAD_PATH")))
+                 (wrap-program program
+                   `("JULIA_DEPOT_PATH" ":" prefix
+                     ("" "$JULIA_DEPOT_PATH"))))
+               #t))))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
-        (string-append "PREFIX=" (assoc-ref %outputs "out"))
 
         ;; Passing the MARCH flag is necessary to build binary substitutes for
         ;; the supported architectures.
@@ -435,7 +449,10 @@
     (native-search-paths
      (list (search-path-specification
             (variable "JULIA_LOAD_PATH")
-            (files (list "share/julia/packages/")))))
+            (files (list "share/julia/packages/")))
+           (search-path-specification
+            (variable "JULIA_DEPOT_PATH")
+            (files (list "share/julia/")))))
     ;; Julia is not officially released for ARM and MIPS.
     ;; See https://github.com/JuliaLang/julia/issues/10639
     (supported-systems '("i686-linux" "x86_64-linux" "aarch64-linux"))
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:34:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:34:59 2020
Received: from localhost ([127.0.0.1]:40670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoFb-00073h-JK
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:34:59 -0500
Received: from mail-wr1-f67.google.com ([209.85.221.67]:45501)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoFa-00073V-2H
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:34:55 -0500
Received: by mail-wr1-f67.google.com with SMTP id j42so25184478wrj.12
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:34:53 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=GLDTNuXU121CZ94Kj4kIMlULUgf04wfx7vcVihPgWH4=;
 b=Ne83fLiY+yxKO9203OHc4l07drl9AGQn99criDWR/Cr/WGtYO/8NPIqTLAK7k+cPru
 YOYUQ/GoHwsEkIwVLqJ2qBP4B6TZD0XxDCPQnW5Jdq5evmNCvvNHYmLif4+glaZUvQyQ
 B8kDwKtkrrvhDgeFIEaZShkiuThYAxtpBcr4eQocBqThyEziqucOngC+yMgMTYRUb9fC
 QjAz8OnHbhbjJKffvtnd0wKXKuh0iAauWMre3pIBoGfBUX/R9RwfzmikuUaNJ6snQ6Bl
 JrK8EI7rzUPQLHdD2VCfgjm+9pAwoTS5Cfkn++HxE+r2VFoY/KQwzT+OrTirVrfJLcNJ
 pA/w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=GLDTNuXU121CZ94Kj4kIMlULUgf04wfx7vcVihPgWH4=;
 b=kLsOkPOYOtMCSH+Qfs+e6Xx96apDmDd/h1jYxrbh4b2x5cYOcxcSEPKL0urt7DkkDj
 Hh1J4RorhceTnEHvAb6oQ/Koc473aMg3qHcrt7uo3/KRBn+i65+JzPFdxAYxLJcM7ZNN
 dozOFq7eLS+71B6v5CWcmv19Sw3v0bmhHVLtGjU4k19xsF0KDOOADuP2UQkvaYQ76GSl
 M5ncT9/4AxNxEpk5XmzCYux/GfAGgYLBTAQY0blpU0DTNlHYC7GlhJpQ4iVkXAsdyMEd
 iAeUcgQF83HaX8ijvxVV74ccXz9qPihLEkVRE8NCf8K9kJ27AKK0nfYDP2dY4E9JoWLU
 0/+Q==
X-Gm-Message-State: APjAAAU4iGyBJ5tIQ/Q2909zHXR4o9Gcrp7sSvViuf7xHBAmYmTUXB9E
 jz2JpO5f5oHfh+tMuIf1NiDsIWJB
X-Google-Smtp-Source: APXvYqwQZchrwFxQF7W+MfkhL0Nurg9exjLp5vEhXXYjHu4WFLy4YewhR57yPzrRYKtYmmQhv/lyhA==
X-Received: by 2002:adf:e6c6:: with SMTP id y6mr8330584wrm.284.1579354487730; 
 Sat, 18 Jan 2020 05:34:47 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id s1sm14058484wmc.23.2020.01.18.05.34.46
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:34:47 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 03/11] gnu: julia: Adjust indentation.
Date: Fri, 10 Jan 2020 10:25:49 +0100
Message-ID: <87muakvqfd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  * gnu/packages/julia.scm (julia): Correct indentation,
 untabify
 --- gnu/packages/julia.scm | 216 ++++++++++++++++++++ 1 file changed, 108
 insertions(+),
 108 deletions(-) diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
 index a66309b611..e1c4685227 100644 --- a/gnu/packages/julia.scm +++
 b/gnu/packages/julia.scm @@ -51,14 +51,14 @@ 
 Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.67 listed in list.dnswl.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
 date
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.67 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/julia.scm (julia): Correct indentation, untabify
    --- gnu/packages/julia.scm | 216 ++++++++++++++++++++ 1 file changed, 108
    insertions(+), 108 deletions(-) diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
    index a66309b611..e1c4685227 100644 --- a/gnu/packages/julia.scm +++ b/gnu/packages/julia.scm
    @@ -51,14 +51,14 @@ 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: githubusercontent.com]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.221.67 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.221.67 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
                             date
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager


* gnu/packages/julia.scm (julia): Correct indentation, untabify
---
 gnu/packages/julia.scm | 216 ++++++++++++++++++++---------------------
 1 file changed, 108 insertions(+), 108 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index a66309b611..e1c4685227 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -51,14 +51,14 @@
 
 (define (julia-patch-url version name)
   (string-append "https://raw.githubusercontent.com/JuliaLang/julia/v" version
-		 "/deps/patches/" name ".patch"))
+                 "/deps/patches/" name ".patch"))
 
 (define (julia-patch name sha)
   (let ((version "1.3.1"))
     (origin (method url-fetch)
-	    (uri (julia-patch-url version name))
-	    (sha256 (base32 sha))
-	    (file-name name))))
+            (uri (julia-patch-url version name))
+            (sha256 (base32 sha))
+            (file-name name))))
 
 (define libuv-julia
   (let ((commit "35b1504507a7a4168caae3d78db54d1121b121e1"))
@@ -101,7 +101,7 @@
                 "1y0l08k6ak1mqbfj6accf9s5686kljwgsl4vcqpxzk5n74wpm6a3"))
               (patches
                (list
-	        (julia-patch "libunwind-prefer-extbl"
+                (julia-patch "libunwind-prefer-extbl"
                              "0lr4dafw8qyfh8sw8hhbwkql1dlhqv8px7k81y2l20hhxfgnh2m1")
                 (julia-patch "libunwind-static-arm"
                              "1jk3bmiw61ypcchqkk1fyg5wh8wpggk574wxyfyaic870zh3lhgq")))))
@@ -124,45 +124,45 @@
               ;; Discussion: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=919628
               (patches
                (list
-	        (julia-patch "llvm-6.0-D44650"
-			    "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
-	        (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
-			    "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
-	        (julia-patch "llvm-6.0-NVPTX-addrspaces"
-			    "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
-	        (julia-patch "llvm-6.0.0_D27296-libssp"
-			    "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
-	        (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
-			    "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
-	        (julia-patch "llvm-D34078-vectorize-fdiv"
-			    "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
-	        (julia-patch "llvm-D42262-jumpthreading-not-i1"
-			    "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
-	        (julia-patch "llvm-D44892-Perf-integration"
-			    "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
-	        (julia-patch "llvm-D46460"
-			    "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
-	        (julia-patch "llvm-D49832-SCEVPred"
-			    "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
-	        (julia-patch "llvm-D50010-VNCoercion-ni"
-			    "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
-	        (julia-patch "llvm-D50167-scev-umin"
-			    "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
-	        (julia-patch "llvm-OProfile-line-num"
-			    "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
-	        (julia-patch "llvm-PPC-addrspaces"
-			    "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
-	        (julia-patch "llvm-rL323946-LSRTy"
-			    "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
-	        (julia-patch "llvm-rL326967-aligned-load"
-			    "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
-	        (julia-patch "llvm-rL327898"
-			    "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
+                (julia-patch "llvm-6.0-D44650"
+                            "1336q4vqayr94wdcnlmcxh90mjdh34dzw9x2cbiqjnx9b1j8fxyb")
+                (julia-patch "llvm-6.0-DISABLE_ABI_CHECKS"
+                            "014fawd1ba7yckalypfld22zgic87x9nx3cim42zrwygywd36pyg")
+                (julia-patch "llvm-6.0-NVPTX-addrspaces"
+                            "1qdi2zmrjsrj0h84zv2vyly2hjcn4f67mfy0s1q353g4v4jkscqc")
+                (julia-patch "llvm-6.0.0_D27296-libssp"
+                            "0s5hi2r1j63i8m6ig1346crx2aiv9f7rgb3mg80kw1wx5y7pdpfh")
+                (julia-patch "llvm-D27629-AArch64-large_model_6.0.1"
+                            "1qrshmlqvnasdyc158vfn3hnbigqph3lsq7acb9w8lwkpnnm2j4z")
+                (julia-patch "llvm-D34078-vectorize-fdiv"
+                            "1696hg84a0jxcnggvqsc2cdp271hf9a44p4qsd078qm1mfawkaay")
+                (julia-patch "llvm-D42262-jumpthreading-not-i1"
+                            "1c8w210gwidbnkkw8anp17dk5pnxws2fl3mb2qxh7y9wzfpixgaq")
+                (julia-patch "llvm-D44892-Perf-integration"
+                            "0r37jd0ssh2k1pndkfd5blgpg9z90im4vlzprhb0n0wwz45g4b05")
+                (julia-patch "llvm-D46460"
+                            "1miqgswdc0qvbaf4571c2xkxyp9ais06b1bcpa83sq22vr4hbsfb")
+                (julia-patch "llvm-D49832-SCEVPred"
+                            "0v5c88hgqj6dymv3j86ca5mhpqab5fbnrvjiw1nvnrnya9l4dlbn")
+                (julia-patch "llvm-D50010-VNCoercion-ni"
+                            "0iblb3q1xixwrb12jpb89h3ywmqmzdp6aqp416j4ncwakyjhhfkp")
+                (julia-patch "llvm-D50167-scev-umin"
+                            "1f2rakcnnyhr7w10k7gqg0k0491pyvx5ijplivw557f714ys3q6v")
+                (julia-patch "llvm-OProfile-line-num"
+                            "1jvbbmwyags0xfwamb13qrf3rgcz9i1r03m9lava7swag8xb78c7")
+                (julia-patch "llvm-PPC-addrspaces"
+                            "1f23nhsxh2s3jskbgs7da9nwg3s1hrkbk5aahl08x41wi3mny01p")
+                (julia-patch "llvm-rL323946-LSRTy"
+                            "10cz3vy1yw0w643z7xx021wa4kymx9fcm3bjg61s6vzdqd6d9fns")
+                (julia-patch "llvm-rL326967-aligned-load"
+                            "04jxnv32yj5x17hqhi8g2p8rhgp38gmjzr871w7z8s44pq10v9v4")
+                (julia-patch "llvm-rL327898"
+                            "15ah49gbsll23z28kpyahi5vl0fh3fkxcgd1zmxxdcl96s3x8bnq")))))
     (arguments
      (substitute-keyword-arguments (package-arguments llvm-6)
        ((#:configure-flags flags)
         `(list ;; Taken from NixOS. Only way I could get libLLVM-6.0.so
-	  "-DCMAKE_BUILD_TYPE=Release"
+          "-DCMAKE_BUILD_TYPE=Release"
 
           ;; Build a native compiler and the NVPTX backend (NVIDIA) since
           ;; Julia insists on it, nothing more.  This reduces build times and
@@ -170,15 +170,15 @@
           ,(string-append "-DLLVM_TARGETS_TO_BUILD=" (system->llvm-target))
           "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=NVPTX"
 
-	  "-DLLVM_INSTALL_UTILS=ON"
-	  "-DLLVM_BUILD_TESTS=ON"
-	  "-DLLVM_ENABLE_FFI=ON"
-	  "-DLLVM_ENABLE_RTTI=ON"
+          "-DLLVM_INSTALL_UTILS=ON"
+          "-DLLVM_BUILD_TESTS=ON"
+          "-DLLVM_ENABLE_FFI=ON"
+          "-DLLVM_ENABLE_RTTI=ON"
           ;; "-DLLVM_HOST_TRIPLE=${stdenv.hostPlatform.config}"
           ;; "-DLLVM_DEFAULT_TARGET_TRIPLE=${stdenv.hostPlatform.config}"
-	  ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
-	  "-DLLVM_ENABLE_DUMP=ON"
-	  "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
+          ;; "-DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD=WebAssembly"
+          "-DLLVM_ENABLE_DUMP=ON"
+          "-DLLVM_LINK_LLVM_DYLIB=ON"))))))
 
 (define-public julia
   (package
@@ -222,9 +222,9 @@
                         (string-append "deps/srccache/libwhich-"
                                        "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"
                                        ".tar.gz"))
-	     ;; needed by libwhich
-	     (setenv "LD_LIBRARY_PATH"
-		     (string-join (map (lambda (pkg)
+             ;; needed by libwhich
+             (setenv "LD_LIBRARY_PATH"
+                     (string-join (map (lambda (pkg)
                                          (string-append (assoc-ref inputs pkg)
                                                         "/lib"))
                                        '("arpack-ng" "curl" "dsfmt"
@@ -234,7 +234,7 @@
                                          "openblas" "openlibm" "pcre2"
                                          "suitesparse"))
                                   ":"))
-	     #t))
+             #t))
          ;; FIXME: Building the documentation requires Julia packages that
          ;; would be downloaded from the Internet.  We should build them in a
          ;; separate build phase.
@@ -250,40 +250,40 @@
            ;; Some tests require a home directory to be set.
            (lambda _ (setenv "HOME" "/tmp") #t))
          (add-after 'unpack 'hardcode-soname-map
-          ;; ./src/runtime_ccall.cpp creates a map from library names to paths
-          ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
-          ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
-          (lambda* (#:key inputs #:allow-other-keys)
-            (substitute* "base/math.jl"
-              (("const libm = Base.libm_name")
-               (string-append "const libm = \""
-                              (assoc-ref inputs "openlibm")
-                              "/lib/libopenlibm.so"
-                              "\"")))))
+           ;; ./src/runtime_ccall.cpp creates a map from library names to paths
+           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
+           ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
+           (lambda* (#:key inputs #:allow-other-keys)
+             (substitute* "base/math.jl"
+               (("const libm = Base.libm_name")
+                (string-append "const libm = \""
+                               (assoc-ref inputs "openlibm")
+                               "/lib/libopenlibm.so"
+                               "\"")))))
          (add-before 'build 'fix-include-and-link-paths
-          (lambda* (#:key inputs #:allow-other-keys)
-            ;; LIBUTF8PROC is a linker flag, not a build target.  It is
-            ;; included in the LIBFILES_* variable which is used as a
-            ;; collection of build targets and a list of libraries to link
-            ;; against.
-            (substitute* "src/flisp/Makefile"
+           (lambda* (#:key inputs #:allow-other-keys)
+             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
+             ;; included in the LIBFILES_* variable which is used as a
+             ;; collection of build targets and a list of libraries to link
+             ;; against.
+             (substitute* "src/flisp/Makefile"
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)\\$\\(EXE\\): \\$\\(OBJS\\) \\$\\(LIBFILES_release\\)")
                 "$(BUILDDIR)/$(EXENAME)$(EXE): $(OBJS) $(LLT_release)")
                (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug$(EXE): \\$\\(DOBJS\\) \\$\\(LIBFILES_debug\\)")
                 "$(BUILDDIR)/$(EXENAME)-debug\\$\\(EXE\\): $(DOBJS) $(LLT_debug)"))
 
-            ;; The REPL must be linked with libuv.
-            (substitute* "ui/Makefile"
-              (("JLDFLAGS \\+= ")
-               (string-append "JLDFLAGS += "
-                              (assoc-ref %build-inputs "libuv")
-                              "/lib/libuv.so ")))
+             ;; The REPL must be linked with libuv.
+             (substitute* "ui/Makefile"
+               (("JLDFLAGS \\+= ")
+                (string-append "JLDFLAGS += "
+                               (assoc-ref %build-inputs "libuv")
+                               "/lib/libuv.so ")))
 
-            (substitute* "base/Makefile"
-              (("\\$\\(build_includedir\\)/uv/errno.h")
-               (string-append (assoc-ref inputs "libuv")
-                              "/include/uv/errno.h")))
-            #t))
+             (substitute* "base/Makefile"
+               (("\\$\\(build_includedir\\)/uv/errno.h")
+                (string-append (assoc-ref inputs "libuv")
+                               "/include/uv/errno.h")))
+             #t))
          (add-before 'build 'replace-default-shell
            (lambda _
              (substitute* "base/client.jl"
@@ -307,7 +307,7 @@
              ;; https://github.com/JuliaLang/julia/issues/32377
              (substitute* "stdlib/REPL/test/replcompletions.jl"
                (("@test count") "@test_broken count"))
-	     #t)))
+             #t)))
        #:make-flags
        (list
         (string-append "prefix=" (assoc-ref %outputs "out"))
@@ -331,7 +331,7 @@
         "USE_SYSTEM_P7ZIP=1"
         "USE_SYSTEM_LAPACK=1"
         "USE_SYSTEM_BLAS=1"
-        "USE_BLAS64=0"          ;needed when USE_SYSTEM_BLAS=1
+        "USE_BLAS64=0"                  ;needed when USE_SYSTEM_BLAS=1
         "LIBBLAS=-lopenblas"
         "LIBBLASNAME=libopenblas"
 
@@ -339,35 +339,35 @@
         (string-append "SUITESPARSE_INC=-I "
                        (assoc-ref %build-inputs "suitesparse")
                        "/include")
-        "USE_GPL_LIBS=1"        ;proudly
+        "USE_GPL_LIBS=1"                ;proudly
         "USE_SYSTEM_UTF8PROC=1"
         (string-append "UTF8PROC_INC="
                        (assoc-ref %build-inputs "utf8proc")
                        "/include")
         "USE_SYSTEM_LLVM=1"
-	"LLVM_VER=6.0.1"
+        "LLVM_VER=6.0.1"
 
-	"USE_LLVM_SHLIB=1"
-	"USE_SYSTEM_LIBUNWIND=1"
-	"USE_SYSTEM_LIBUV=1"
-	(string-append "LIBUV="
-		       (assoc-ref %build-inputs "libuv")
-		       "/lib/libuv.so")
-	(string-append "LIBUV_INC="
-		       (assoc-ref %build-inputs "libuv")
-		       "/include")
-	"USE_SYSTEM_PATCHELF=1"
-	"USE_SYSTEM_PCRE=1"
-	"USE_SYSTEM_OPENLIBM=1"
+        "USE_LLVM_SHLIB=1"
+        "USE_SYSTEM_LIBUNWIND=1"
+        "USE_SYSTEM_LIBUV=1"
+        (string-append "LIBUV="
+                       (assoc-ref %build-inputs "libuv")
+                       "/lib/libuv.so")
+        (string-append "LIBUV_INC="
+                       (assoc-ref %build-inputs "libuv")
+                       "/include")
+        "USE_SYSTEM_PATCHELF=1"
+        "USE_SYSTEM_PCRE=1"
+        "USE_SYSTEM_OPENLIBM=1"
         "USE_SYSTEM_LIBM=0"
         "USE_SYSTEM_LIBSSH2=1"
         "USE_SYSTEM_CURL=1"
-	"USE_SYSTEM_GMP=1"
-	"USE_SYSTEM_MPFR=1"
-	"USE_SYSTEM_MBEDTLS=1"
-	"USE_SYSTEM_ARPACK=1"
-	"USE_SYSTEM_LIBGIT2=1"
-	"USE_SYSTEM_ZLIB=1")))
+        "USE_SYSTEM_GMP=1"
+        "USE_SYSTEM_MPFR=1"
+        "USE_SYSTEM_MBEDTLS=1"
+        "USE_SYSTEM_ARPACK=1"
+        "USE_SYSTEM_LIBGIT2=1"
+        "USE_SYSTEM_ZLIB=1")))
     (inputs
      `(("llvm" ,llvm-julia)
 
@@ -377,9 +377,9 @@
        ;; <https://bugs.gnu.org/30282>.
        ("arpack-ng" ,arpack-ng-3.3.0)
 
-       ("coreutils" ,coreutils) ;for bindings to "mkdir" and the like
+       ("coreutils" ,coreutils)         ;for bindings to "mkdir" and the like
        ("lapack" ,lapack)
-       ("openblas" ,openblas) ;Julia does not build with Atlas
+       ("openblas" ,openblas)           ;Julia does not build with Atlas
        ("libunwind" ,libunwind-julia)
        ("openlibm" ,openlibm)
        ("mbedtls" ,mbedtls-apache)
@@ -411,20 +411,20 @@
             (base32
              "0wp6ld9vk11f4nnkn56627zmlv9k5vafi99qa3yyn1pgcd61zcfs"))))
        ("libwhich"
-	,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
+        ,(let ((commit "81e9723c0273d78493dc8c8ed570f68d9ce7e89e"))
            (origin
              ;; Note: We use a /tarball URL, but that's because Julia's build
              ;; system checks the hash of that tarball; thus we can't use
              ;; 'git-fetch'.
-	     (method url-fetch)
-	     (uri (string-append
+             (method url-fetch)
+             (uri (string-append
                    "https://api.github.com/repos/vtjnash/libwhich/tarball/"
                    commit))
              (file-name (string-append "libwhich-" (string-take commit 7)
                                        ".tar.gz"))
-	     (sha256
-	      (base32
-	       "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
+             (sha256
+              (base32
+               "1p7zg31kpmpbmh1znrk1xrbd074agx13b9q4dcw8n2zrwwdlbz3b")))))
        ("dsfmt" ,dsfmt)))
     (native-inputs
      `(("openssl" ,openssl)
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:34:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:34:39 2020
Received: from localhost ([127.0.0.1]:40667 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoFL-00073D-8u
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:34:39 -0500
Received: from mail-wr1-f46.google.com ([209.85.221.46]:37330)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoFG-00072x-Sg
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:34:38 -0500
Received: by mail-wr1-f46.google.com with SMTP id w15so25285597wru.4
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:34:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=VEzOjbQpmoo7l/vVk8Wiqaj3UFvoUUdKYHhv4hTiQcU=;
 b=vGMrEUiRpKRrNGLAfxdGftI2ZmcMhvVWONR7MPDWQ/M0gTBlvjL6kX2TtdhTNw4e3n
 UirPksZP493PUOxljV+Zuoc/oqdSNTianu5vz2RFVv9r586gpGh/l37jBmf8pe+l+L7X
 o6pNN9nUYZ/aTbT1xk10lAYZmpPvZx2Lnh74Iw8yVQ7kXfe+3j+iHsi0N0LevgLRFzy1
 603vrz5V8Uq/FYtDlXYWixL2OnnRv4lGygGB9dpOaI0KfU3PzTljvf6k8eACkEJzY2+y
 kBfLH3Fy+W1QlCpxzNX5Z6J4Uapg+ovnwXVNke3T9+Px3IkTL9fc1FnntwHsEovN16D3
 ksVA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=VEzOjbQpmoo7l/vVk8Wiqaj3UFvoUUdKYHhv4hTiQcU=;
 b=g0Pt8uvpI8Xoc6GTvENqrdCkdWTUM4fX9aFPr+9yTEL0eksFzmuOOrwXf4pc0QB+jb
 BjO9yyVLz7iSqGrhzvEC8zyy0boK3YQ50h2vaTEGqlgDSgmLNy69ErO3FjewOvBR+iZR
 kApn1UK+mGfA8q9eKywJ7tgAOZScTVqEMengqx0ucniuW7LGKAaYX7D8ibdY9CBndl0J
 eAcOpIHATykC3Cg7AsUP6OxzzWqX5jB+xSQnWQqDk6SAbJzhAErn8JV0uytBSZhh6JQo
 qrFuMDXkt//Ai57Kk6Q1PP2+wdCF4b90Bh/yVfyCm1KIPUyEmlA3/dwInHG4t9rRJpnL
 LzOg==
X-Gm-Message-State: APjAAAViQsfWvr2LHS7ouzV/KsX5WSqGxjhNVz6eYgk3ez/h9k7vRXT9
 gK7bHU3iSHTBPN5o/sWWFZPB1u0B
X-Google-Smtp-Source: APXvYqyRETvRCu36uEOlOPL1nCjVwEnAqPk16LHQx012Da/QfJBpkjjMOfOxKTbQOqYFDDSE3bCxxA==
X-Received: by 2002:a5d:6191:: with SMTP id j17mr8042118wru.427.1579354468801; 
 Sat, 18 Jan 2020 05:34:28 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id m10sm38785131wrx.19.2020.01.18.05.34.28
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:34:28 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: 38546 <at> debbugs.gnu.org
Subject: [PATCH 02/11] gnu: julia: use SOURCE_DATE_EPOCH for precompilation
 timestamp
Date: Sat, 18 Jan 2020 13:58:37 +0100
Message-ID: <87o8v0vqfw.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 1.9 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details. Content preview: *
 gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch:
 new file --- gnu/local.mk | 1 + gnu/packages/julia.scm | 4 ++-
 ...ia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
 | 29 ++++++++++++++++ [...] 
 Content analysis details:   (1.9 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 1.9 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: nixo.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: local.mk]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.46 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.46 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.9 (/)


* gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch: new file
---
 gnu/local.mk                                  |  1 +
 gnu/packages/julia.scm                        |  4 ++-
 ...ia-fake-mtime-with-SOURCE_DATE_EPOCH.patch | 29 +++++++++++++++++++
 3 files changed, 33 insertions(+), 1 deletion(-)
 create mode 100644 gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch

diff --git a/gnu/local.mk b/gnu/local.mk
index 00ff3b8d61..fe8634b44d 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1010,6 +1010,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/java-xerces-bootclasspath.patch	\
   %D%/packages/patches/java-xerces-build_dont_unzip.patch	\
   %D%/packages/patches/java-xerces-xjavac_taskdef.patch	\
+  %D%/packages/patches/julia-SOURCE_DATE_EPOCH-mtime.patch      \
   %D%/packages/patches/jbig2dec-ignore-testtest.patch		\
   %D%/packages/patches/kdbusaddons-kinit-file-name.patch	\
   %D%/packages/patches/libvirt-create-machine-cgroup.patch	\
diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index e4db39afbd..a66309b611 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -191,7 +191,9 @@
                     version "/julia-" version ".tar.gz"))
               (sha256
                (base32
-                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))))
+                "1nwkmr9j55g1zkxdchnid1h022s0is52vx23niksshgvh793g41x"))
+              (patches
+               (search-patches "julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch"))))
     (build-system gnu-build-system)
     (arguments
      `(#:test-target "test"
diff --git a/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
new file mode 100644
index 0000000000..467e6d68d1
--- /dev/null
+++ b/gnu/packages/patches/julia-fake-mtime-with-SOURCE_DATE_EPOCH.patch
@@ -0,0 +1,29 @@
+From e4dc28db1d70819505fd1a68fd9d2bfc4fb61a7d Mon Sep 17 00:00:00 2001
+From: nixo <nicolo@HIDDEN>
+Date: Fri, 17 Jan 2020 11:28:30 +0100
+Subject: [PATCH] base: loading: support fake mtime with SOURCE_DATE_EPCOCH
+
+Do this when loading libraries
+---
+ base/loading.jl | 5 ++++-
+ 1 file changed, 4 insertions(+), 1 deletion(-)
+
+diff --git a/base/loading.jl b/base/loading.jl
+index 7f11a2d4fc..1b4686d1dc 100644
+--- a/base/loading.jl
++++ b/base/loading.jl
+@@ -807,7 +807,10 @@ function _include_dependency(mod::Module, _path::AbstractString)
+         path = normpath(joinpath(dirname(prev), _path))
+     end
+     if _track_dependencies[]
+-        push!(_require_dependencies, (mod, path, mtime(path)))
++        push!(_require_dependencies,
++              (mod, path,
++               haskey(ENV, "SOURCE_DATE_EPOCH") ?
++               parse(Float64, ENV["SOURCE_DATE_EPOCH"]) : mtime(path)))
+     end
+     return path, prev
+ end
+-- 
+2.24.1
+
-- 
2.24.1





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 18 Jan 2020 13:32:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 08:32:47 2020
Received: from localhost ([127.0.0.1]:40663 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isoDW-00070K-Qq
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:32:47 -0500
Received: from mail-wr1-f52.google.com ([209.85.221.52]:47051)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1isoDU-000703-CE
 for 38546 <at> debbugs.gnu.org; Sat, 18 Jan 2020 08:32:45 -0500
Received: by mail-wr1-f52.google.com with SMTP id z7so25179792wrl.13
 for <38546 <at> debbugs.gnu.org>; Sat, 18 Jan 2020 05:32:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:references:date:message-id:mime-version
 :content-transfer-encoding;
 bh=bW1S8bDWJbJhqaIS9Jdn2qL5jp0mx9Yn5vHV92cDygE=;
 b=qXtP7yza7RcbY/Ay9ZNKPhosOSy8B37ITIPEDe9ufWqWuk6gGwiYc1RYLSwD+RZUGv
 z5x8LlH06IFkdogKRW79aMpJ9otxYXpPjj7WD6p5P8ZrGi8zDT8tU0lBdqePknyGV7dR
 l/I/YAZMbcGp5rPVTFQ82ykr34+1lzHsssfs7E1XsIMN+yHolqrnjRuiV+f4UCtPXg1u
 N6qAkswmhBhW2MnU95k9euiVEKS1pj1caMnVeRZhZmZoCLwkDMmh/II8S2ZcdRm2wBfN
 D0qbmJMBy0F5NwkJXpWmT3K7KHy7CsCGkTDxuX/E5hC7hdj6uKIi9gp+soF9/PwHT+MF
 U0AQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=bW1S8bDWJbJhqaIS9Jdn2qL5jp0mx9Yn5vHV92cDygE=;
 b=PpP6Mq5WRKSxoXrDTeJjj+MIJBp6RJnR+0TDUtAVjbBIHtRBlkHMDA3/tZLxFN9vZ7
 9v+71X6lj49nFUOqbkiTxuDPc3YqdnRSJ8+z5bUa9Rpxm4EE7d0up1ud2uguNrT/QjOq
 8+0YaLIRL/I7FHoPwWYWyR37Nc5vKTXriMlHgxvb2FBHHvrdNw6lS2VZCmjgipvIkC3p
 MplLESpXBvEgKwKVnWTFry0DntwU/j9ortuE4cDY0WftUXUBubQlD1eRkrLOmDqPgvxs
 /Xe4rZ3/uJt5f/1qTjjBVnLW+cqudxr5SzGRM2DCuXYD3DlLUS94mYzSlCEmILnE4705
 F4Og==
X-Gm-Message-State: APjAAAWnBWBM9PVY7KoewUjiMnXkZrtb13GZr5jGSXvK9XfxbSnmfxis
 A25dAAlBiDleS0MquAEiogPn2PR0
X-Google-Smtp-Source: APXvYqzYw9d27YPZBCo9mZpcR6HaJwjpphxR9ji+Bfb2AoqIRoJnsAiiyAGWPP9kPbM2ftghFJYEdA==
X-Received: by 2002:adf:eb0a:: with SMTP id s10mr8082681wrn.320.1579354358006; 
 Sat, 18 Jan 2020 05:32:38 -0800 (PST)
Received: from guixSD (host146-19-dynamic.50-79-r.retail.telecomitalia.it.
 [79.50.19.146])
 by smtp.gmail.com with ESMTPSA id b15sm3359777wmj.13.2020.01.18.05.32.37
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 18 Jan 2020 05:32:37 -0800 (PST)
From: anothersms@HIDDEN (=?utf-8?Q?Nicol=C3=B2?= Balzarotti)
To: 38546 <at> debbugs.gnu.org
Subject: =?utf-8?Q?=5BNicol=C3=B2?= Balzarotti] [PATCH 00/11] Update julia
 to 1.3.1, fix precompilation, add HTTP.jl
References: <87zhekvqpj.fsf@HIDDEN>
Date: Sat, 18 Jan 2020 14:32:36 +0100
Message-ID: <87sgkcvqiz.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Ok I had time to look at this again.

1. Package installation can be done both the julia way and the guix way
2. SOURCE_DATE_EPOCH is respected in package precompile timestamp. Other fi=
xes are needed to get reproducible builds, but for now that means that pack=
age cache is used.
3. This patch adds some first julia package (HTTP.jl and dependencies)=20
4. Updated julia to 1.3.1 (latest release). It's working great and the
build recipe is simplified a lot.  However, some test is failing.  The
"interesting" part is that when running tests alone, they are working.
It seems like the problem arise when tests are run on the _same core_
and not on different cores.  I opened a issue upstream for this
(https://github.com/JuliaLang/julia/issues/34330), I'll have to look
further on it, but for now if it's fine for me this is ready to be merged.

I'm sending the patch series here.

Thanks, Nicol=C3=B2

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi,
>
> (+Cc: bug report.)
>
> Nicol=C3=B2 Balzarotti <anothersms@HIDDEN> skribis:
>
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>>
>>> Hi!
>>>
>>> nixo <anothersms@HIDDEN> skribis:
>>>
>>>> This set of patches improve the state of julia-build-system.
>>>>
>>>> 1. set path JULIA_LOAD_PATH to enable installing packages, and
>>>>   JULIA_DEPOT_PATH to allow guix-precompiled cache to be recognized by=
 julia. To
>>>
>>> These two environment variables are supported upstream, right?
>>
>> Yes, those variables are documented here:
>> https://docs.julialang.org/en/v1/manual/environment-variables/index.html
>
> Great.
>
>> Should user be allowed to manually install packages in his own private
>> home folder manually? (I just tried with R: R recognize the store is RO
>> and ask for an alternative path). I'll try to allow "standard" package
>> installation and submit the patch again (also, I just read you other
>> comments, so I'll fix everything!)
>
> I think users should have the option to install packages in the normal
> Julia way, without Guix.
>
>>>>   do this, a small "hack" with libfaketime was required (julia decides=
 if the
>>>>   cache is valid by comparing source ".jl" mtime with cache ".ji" file=
, in which
>>>>   julia stores a timestamp. We need to force this timestamp to be equa=
l to the
>>>>   mtime of guix-store files).
>>>
>>> OK.  This hack shouldn=E2=80=99t break =E2=80=9Cnormal=E2=80=9D Julia u=
ses (outside of the
>>> store), right?
>> You are right, the issue is that julia finds its src (.jl) file to have
>> a different (although older) timestamp (because guix fixes the
>> mtime). This applies only to cache files placed in the store. Other
>> cache files (non-guix installed files) have the right timestamp, so are
>> not affected (I don't know if this explanation is clear. The TLDR is:
>> with this hack store works without double-precompilation, non-store
>> works normally, too).
>> However, I'll check if I can make it work with SOURCE_DATE_EPOCH. I
>> already read the code responsible for precompilation, so hopefully it
>> won't take too much time
>
> Awesome, thanks!
>
> Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 15 Dec 2019 21:47:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 16:47:06 2019
Received: from localhost ([127.0.0.1]:37333 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igbjG-0001Tb-LJ
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:47:06 -0500
Received: from eggs.gnu.org ([209.51.188.92]:49542)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1igbjF-0001T1-5X
 for 38546 <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:47:05 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49548)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1igbj9-0006BV-Vm; Sun, 15 Dec 2019 16:47:00 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=44734 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1igbj9-00012q-DO; Sun, 15 Dec 2019 16:46:59 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
Subject: Re: [bug#38546] [PATCH 3/3] gnu: julia-xyz: Add julia-compat.
References: <87v9qpvbyr.fsf@HIDDEN>
 <87r21dvbrc.fsf@HIDDEN>
Date: Sun, 15 Dec 2019 22:46:56 +0100
In-Reply-To: <87r21dvbrc.fsf@HIDDEN>
 (=?utf-8?Q?=22Nicol=C3=B2?= Balzarotti"'s message of "Thu, 10 Oct 2019
 17:49:15 +0200")
Message-ID: <8736dls1m7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38546
Cc: Guix Patches <38546 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Nicol=C3=B2 Balzarotti <anothersms@HIDDEN> skribis:

> * gnu/packages/julia-xyz.scm: New file.
> * gnu/packages/julia-xyz.scm (julia-compat): New variable.

The second line is unnecessary.

However, please make sure to add the file to =E2=80=98gnu/local.mk=E2=80=99.

Otherwise LGTM.

Thanks!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 15 Dec 2019 21:46:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 16:46:02 2019
Received: from localhost ([127.0.0.1]:37329 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igbiE-0001Rm-AH
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:46:02 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48580)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1igbiD-0001RG-2i
 for 38546 <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:46:01 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49542)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1igbi7-0004M9-Sr; Sun, 15 Dec 2019 16:45:55 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=44732 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1igbi7-0000za-9U; Sun, 15 Dec 2019 16:45:55 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
Subject: Re: [bug#38546] [PATCH 2/3] gnu: julia-build-system: Enable tests.
References: <87v9qpvbyr.fsf@HIDDEN>
 <87sgltvbs1.fsf@HIDDEN>
Date: Sun, 15 Dec 2019 22:45:53 +0100
In-Reply-To: <87sgltvbs1.fsf@HIDDEN>
 (=?utf-8?Q?=22Nicol=C3=B2?= Balzarotti"'s message of "Thu, 10 Oct 2019
 17:49:15 +0200")
Message-ID: <877e2xs1ny.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38546
Cc: Guix Patches <38546 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Nicol=C3=B2 Balzarotti <anothersms@HIDDEN> skribis:

> ---
>  guix/build-system/julia.scm       |  4 +++-
>  guix/build/julia-build-system.scm | 28 +++++++++++++++++++---------
>  2 files changed, 22 insertions(+), 10 deletions(-)

With a commit log, please.  :-)

> --- a/guix/build/julia-build-system.scm
> +++ b/guix/build/julia-build-system.scm
> @@ -32,7 +32,13 @@
>  ;; Code:
>=20=20
>  (define (invoke-julia code)
> -  (invoke "julia" "-e" code))
> +  ;; Julia stores the result of the time() call
> +  ;; inside the precompiled file. When trying to load it, its precompila=
tion
> +  ;; it fails at comparing the file mtime with the precompilation time,
> +  ;; always triggering a recompile. This fixes the stored value.
> +  ;; Also, libc.jl rand() uses time() as its seed. This might introduce =
indeterminism while building
> +  ;; Default guix mtime is 1, so I'm setting the same here (if they diff=
er, precompilation is invalid)
> +  (invoke "faketime" "-f" "1970-01-01 00:00:01" "julia" "-e" code))

Do you think it would be feasible to modify Julia to emit this fixed
timestamp, or to honor SOURCE_DATE_EPOCH, instead of using =E2=80=98faketim=
e=E2=80=99?

The reason I=E2=80=99m asking is that (1) =E2=80=98faketime=E2=80=99 relies=
 on LD_PRELOAD and so
it could introduce its own set of issues, and (2) I wouldn=E2=80=99t be
surprised to find ready-to-use SOURCE_DATE_EPOCH patches from fellow
Reproducible Builders floating around.  :-)

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 15 Dec 2019 21:43:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 16:43:25 2019
Received: from localhost ([127.0.0.1]:37325 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igbfg-0001NN-Tk
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:43:25 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46567)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1igbff-0001NA-Ih
 for 38546 <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:43:23 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49536)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1igbfa-0001yK-DG; Sun, 15 Dec 2019 16:43:18 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=44730 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1igbfa-0000mt-0m; Sun, 15 Dec 2019 16:43:18 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: =?utf-8?Q?Nicol=C3=B2?= Balzarotti <anothersms@HIDDEN>
Subject: Re: [bug#38546] [PATCH 1/3] gnu: julia: Set to JULIA_LOAD_PATH and
 JULIA_DEPOT_PATH variables.
References: <87v9qpvbyr.fsf@HIDDEN>
 <87tv69vbt6.fsf@HIDDEN>
Date: Sun, 15 Dec 2019 22:43:16 +0100
In-Reply-To: <87tv69vbt6.fsf@HIDDEN>
 (=?utf-8?Q?=22Nicol=C3=B2?= Balzarotti"'s message of "Thu, 10 Oct 2019
 17:49:15 +0200")
Message-ID: <87bls9s1sb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38546
Cc: Guix Patches <38546 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Nicol=C3=B2 Balzarotti <anothersms@HIDDEN> skribis:

>  gnu/packages/julia.scm | 146 +++++++++++++++++++++--------------------
>  1 file changed, 75 insertions(+), 71 deletions(-)

Please make sure to add a commit log listing all the entities changed.

Apparently there was some reindentation that makes this patch looks big
and makes the actual changes harder to spot.  Could you resubmit it
without the reindentation?

>      (native-search-paths
>       (list (search-path-specification
>              (variable "JULIA_LOAD_PATH")
> -            (files (list "share/julia/packages/")))))
> +            (files (list "share/julia/packages/"
> +                         "share/julia/stdlib/v1.1/")))

Why is this extra entry needed?  Doesn=E2=80=99t Julia find its own standard
library by default, even if JULIA_LOAD_PATH is unset?

> +           (search-path-specification
> +            (variable "JULIA_DEPOT_PATH")
> +            (files (list "share/julia/")))))

What=E2=80=99s JULIA_DEPOT_PATH supposed to point to again?  =E2=80=98share=
/julia=E2=80=99 seems
to be very much a catch-all thing.  :-)

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 15 Dec 2019 21:40:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 16:40:10 2019
Received: from localhost ([127.0.0.1]:37321 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igbcY-0001Ij-Ez
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:40:10 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42644)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1igbcW-0001IR-5K
 for 38546 <at> debbugs.gnu.org; Sun, 15 Dec 2019 16:40:08 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49522)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1igbcQ-0000QT-VA; Sun, 15 Dec 2019 16:40:03 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=44724 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1igbcQ-0000ay-EV; Sun, 15 Dec 2019 16:40:02 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: nixo <anothersms@HIDDEN>
Subject: Re: [bug#38546] [PATCH 0/3] Julia: fix package build and add julia-xyz
References: <87v9qpvbyr.fsf@HIDDEN>
Date: Sun, 15 Dec 2019 22:40:00 +0100
In-Reply-To: <87v9qpvbyr.fsf@HIDDEN>
 (nixo's message of "Mon, 9 Dec 2019 14:36:25 +0100")
Message-ID: <87fthls1xr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38546
Cc: 38546 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi!

nixo <anothersms@HIDDEN> skribis:

> This set of patches improve the state of julia-build-system.
>
> 1. set path JULIA_LOAD_PATH to enable installing packages, and
>   JULIA_DEPOT_PATH to allow guix-precompiled cache to be recognized by ju=
lia. To

These two environment variables are supported upstream, right?

>   do this, a small "hack" with libfaketime was required (julia decides if=
 the
>   cache is valid by comparing source ".jl" mtime with cache ".ji" file, i=
n which
>   julia stores a timestamp. We need to force this timestamp to be equal t=
o the
>   mtime of guix-store files).

OK.  This hack shouldn=E2=80=99t break =E2=80=9Cnormal=E2=80=9D Julia uses =
(outside of the
store), right?

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 9 Dec 2019 14:01:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 09:01:39 2019
Received: from localhost ([127.0.0.1]:52808 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieJbX-000304-Fd
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:01:39 -0500
Received: from mail-wr1-f41.google.com ([209.85.221.41]:41360)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ieJbU-0002zp-4a
 for 38546 <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:01:37 -0500
Received: by mail-wr1-f41.google.com with SMTP id c9so16322984wrw.8
 for <38546 <at> debbugs.gnu.org>; Mon, 09 Dec 2019 06:01:36 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=jKZqmGi9UblsXcAB5zboN+7molI8KReX/LEostBrgbA=;
 b=BtVYTnP8C7ylK9MBSc/6M+PPU6wunJpu8FJtGRzU9vsnH0LE5xedKBhwYqVGPUF4yA
 uHbVM7afFL1lpzpJMolw7iDNdq1MfY8iwYxXyDHQ99Ue2ZScm4RBjBYulv7QBnFcV4B8
 olk+FjQDiWLJi/Z2JKdhl5TROhv33FuuIV4o5PoK8JrikSdG1k5+goujXN0Wnwvdq5AR
 iapZQgHRZw9c6+7HMvfjknzFgci2tvzQtmRkYfU+gZNYoxffby8SoVSnT6PYVUVGFJRD
 Zz7cyLRGz6I4SLxzmZp75OBvzWQxc0QGuKaeDXo8b6iiCP0S0Nl4i0NWU0jKEcW9UojO
 CqDA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=jKZqmGi9UblsXcAB5zboN+7molI8KReX/LEostBrgbA=;
 b=gACFCkQgE5MbZXgxX/HWGPHzVmWEjYarG6L7rXc2Vleba3Mx8tgs/isFaVcwLRuwNz
 hOXHWGNUulQafz/1DUmJmvtsV+cuEHZRM7Jq3j8hN8HIGAE9LBp/G9e/XS6zZHaydOAb
 n4sNJuoa/RIBEVtTsf6UCa86MZk4Aemzj3h55AxW9sH/tFPcHkdbv+E8x04SqskbqN8h
 Abxl0tx9AXGw3XafOMY349Y15OV4NQOz/wOe1ZMxUa4svtPI+wrwIVJxW3x2LdyJBzRq
 T811JSrmQaOLpbPxSj8FgvB61NpYNaMDBErtwQYDdcsZqOYb/MSg/rj2bM0RBrKIPs4n
 1vxw==
X-Gm-Message-State: APjAAAWHbyrp/ts3TpnsJkV1LFiWwj8YhfIVnJsejBzz3g0XZrrMFgjv
 pgK0XQTxRlhhixTDtRDn3WnxhOI9kww=
X-Google-Smtp-Source: APXvYqz8FIfwRKDShXG1Maeuhi6rk0WzVjDh+ai6tYpj+kfIwiTvp++vAwqGUt36Qcgi8TlsPX40HA==
X-Received: by 2002:adf:c145:: with SMTP id w5mr2307647wre.205.1575900089902; 
 Mon, 09 Dec 2019 06:01:29 -0800 (PST)
Received: from guixSD (host1-200-dynamic.5-87-r.retail.telecomitalia.it.
 [87.5.200.1])
 by smtp.gmail.com with ESMTPSA id f9sm5012616wmb.4.2019.12.09.06.01.28
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 09 Dec 2019 06:01:29 -0800 (PST)
From: =?UTF-8?q?Nicol=C3=B2=20Balzarotti?= <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: Guix Patches <38546 <at> debbugs.gnu.org>
Subject: [PATCH 3/3] gnu: julia-xyz: Add julia-compat.
Date: Thu, 10 Oct 2019 17:49:15 +0200
Message-ID: <87r21dvbrc.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: * gnu/packages/julia-xyz.scm: New file. *
 gnu/packages/julia-xyz.scm
 (julia-compat): New variable. --- gnu/packages/julia-xyz.scm | 62
 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 62 inserti [...] 
 Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
 date
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.41 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.41 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  * gnu/packages/julia-xyz.scm: New file. * gnu/packages/julia-xyz.scm
    (julia-compat): New variable. --- gnu/packages/julia-xyz.scm | 62 ++++++++++++++++++++++++++++++++++++++
    1 file changed, 62 inserti [...] 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: nixo.xyz]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.221.41 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.221.41 listed in wl.mailspike.net]
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
                             date
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

* gnu/packages/julia-xyz.scm: New file.
* gnu/packages/julia-xyz.scm (julia-compat): New variable.
---
 gnu/packages/julia-xyz.scm | 62 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 62 insertions(+)
 create mode 100644 gnu/packages/julia-xyz.scm

diff --git a/gnu/packages/julia-xyz.scm b/gnu/packages/julia-xyz.scm
new file mode 100644
index 0000000000..85d4d696d9
--- /dev/null
+++ b/gnu/packages/julia-xyz.scm
@@ -0,0 +1,62 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2019 Nicol=C3=B2 Balzarotti <nicolo@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu packages julia-xyz)
+  #:use-module (guix build-system julia)
+  #:use-module (guix git-download)
+  #:use-module ((guix licenses) #:prefix license:)
+  #:use-module (guix packages)
+  #:use-module (gnu packages algebra)
+  #:use-module (gnu packages base)      ; binutils (packagecompiler)
+  #:use-module (gnu packages commencement)
+  #:use-module (gnu packages compression)
+  #:use-module (gnu packages fontutils)
+  #:use-module (gnu packages fonts)
+  #:use-module (gnu packages graphics)
+  #:use-module (gnu packages glib)
+  #:use-module (gnu packages gtk)
+  #:use-module (gnu packages image)
+  #:use-module (gnu packages imagemagick)
+  #:use-module (gnu packages maths)
+  #:use-module (gnu packages statistics)
+  #:use-module (gnu packages video)
+  #:use-module (gnu packages web)
+  #:use-module (gnu packages xml)
+  #:use-module (gnu packages tls))
+
+(define-public julia-compat
+  (package
+    (name "julia-compat")
+    (version "3.0.0")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/JuliaLang/Compat.jl")
+             (commit (string-append "v" version))))
+       (file-name "Compat")
+       (sha256
+        (base32 "0n4gqk0b5fcf0d12gizjs7hsgakh7w7xgx2srbvzc5pkm5z469l4"))))
+    (build-system julia-build-system)
+    (home-page "https://github.com/JuliaLang/Compat.jl")
+    (synopsis "Compatibility across Julia versions")
+    (description "The Compat package is designed to ease interoperability
+between older and newer versions of the Julia language.  The Compat package
+provides a macro that lets you use the latest syntax in a backwards-compat=
ible
+way.")
+    (license license:expat)))
--=20
2.24.0





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 9 Dec 2019 14:01:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 09:01:12 2019
Received: from localhost ([127.0.0.1]:52805 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieJb6-0002zF-4Q
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:01:12 -0500
Received: from mail-wm1-f53.google.com ([209.85.128.53]:51965)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ieJb5-0002z2-GT
 for 38546 <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:01:11 -0500
Received: by mail-wm1-f53.google.com with SMTP id g206so15615370wme.1
 for <38546 <at> debbugs.gnu.org>; Mon, 09 Dec 2019 06:01:11 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=R1pOjVjfkYP0/RizHzBsVDjA1ihpjc8d/A/lxx+upj4=;
 b=BPp3TzqJLT8yrcFLcKy9xxpP/1UO9YoIFWRj0vEGRLOVfzUEegxschJtgqqoJfcK5g
 y4OXjPq2In2isRxzJGtw4Dk7gTbmx5kIKYbf2ufLMl6xHQY3vGf+GyC5SOEAQHIIsLxb
 wEp9FxgTJTBpCda2SLl5SZcPPZ7LcpCrQy49I9MrkO8H/WYm+bsw2X6KvqV1o57FY56a
 Roj1coS3bSbvmBGdCzyCRQcT6XLoUMdsj5f2uN4bvHFiyjxjI/55QGpFJXNwxvZm0G2N
 RnpEU7sQSmCHx81DVNIRSvs0lPH1QID1cABlSKKUaoxcybaCcyWJMxaYn1T50bj/0JuR
 abXA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=R1pOjVjfkYP0/RizHzBsVDjA1ihpjc8d/A/lxx+upj4=;
 b=mBb7+7lm5/vgt5MMswvMkBaoT9ict6zA6US01jqennpuFdNY9M0OeYbnU3fLgwexlS
 ZKP6AYtNfPYRxaV49wlnpfIRH2uZnC4MPJLIaSKxS/bzlDxrL4nHs8jXrbKbSYfRzEAs
 SLlroXiN2CHFTrQIUULNmwTDhfLSMutVahG8YGD9hoadhR05Kh/EaFnCVdD4PyB6jpIj
 Cgodicu57Ru+LJdDCWQWFo9OGxtQqpr3V8qGaK7xtEox7AzaD5WKvnGBktaGCv6CGm9o
 ctKNb1SDLzhBcWtbb8j3+btTyrekIhasAFkAF4FOKYYc6qXtzcOhY1dyAppkKfNxPrgE
 pLTw==
X-Gm-Message-State: APjAAAUdUU46ReqJhNefxuUn4xIyEo2kUnlBdx7VmCaHeN1n6ZJ3Cqp9
 8402IVnTd4U6owec2NnPyB/19OBfNb4=
X-Google-Smtp-Source: APXvYqzixuLdpDo6FFqpwBYQ2Of34hBBeKGEHPLPuCBKlcLfRlzrzaWgLL6meFNzv3SLsPgTdwz8VA==
X-Received: by 2002:a05:600c:cd:: with SMTP id
 u13mr25130362wmm.24.1575900065069; 
 Mon, 09 Dec 2019 06:01:05 -0800 (PST)
Received: from guixSD (host1-200-dynamic.5-87-r.retail.telecomitalia.it.
 [87.5.200.1])
 by smtp.gmail.com with ESMTPSA id w13sm28688595wru.38.2019.12.09.06.01.04
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 09 Dec 2019 06:01:04 -0800 (PST)
From: =?UTF-8?q?Nicol=C3=B2=20Balzarotti?= <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: Guix Patches <38546 <at> debbugs.gnu.org>
Subject: [PATCH 2/3] gnu: julia-build-system: Enable tests.
Date: Thu, 10 Oct 2019 17:49:15 +0200
Message-ID: <87sgltvbs1.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: --- guix/build-system/julia.scm | 4 +++-
 guix/build/julia-build-system.scm
 | 28 +++++++++++++++++++--------- 2 files changed, 22 insertions(+),
 10 deletions(-)
 diff --git a/guix/build-system/julia.scm b/guix/build-system/julia.scm index
 488fe9bb1d..0c07484f12 100644 --- a/guix/build-system/julia.scm +++
 b/guix/build-system/julia.scm @@ -26,6 +26,7 @@ #:use-m [...] 
 Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
 date
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.128.53 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.128.53 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  --- guix/build-system/julia.scm | 4 +++- guix/build/julia-build-system.scm
    | 28 +++++++++++++++++++--------- 2 files changed, 22 insertions(+), 10 deletions(-)
    diff --git a/guix/build-system/julia.scm b/guix/build-system/julia.scm index
    488fe9bb1d..0c07484f12 100644 --- a/guix/build-system/julia.scm +++ b/guix/build-system/julia.scm
    @@ -26,6 +26,7 @@ #:use-m [...] 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.128.53 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.128.53 listed in wl.mailspike.net]
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
                             date
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

---
 guix/build-system/julia.scm       |  4 +++-
 guix/build/julia-build-system.scm | 28 +++++++++++++++++++---------
 2 files changed, 22 insertions(+), 10 deletions(-)

diff --git a/guix/build-system/julia.scm b/guix/build-system/julia.scm
index 488fe9bb1d..0c07484f12 100644
--- a/guix/build-system/julia.scm
+++ b/guix/build-system/julia.scm
@@ -26,6 +26,7 @@
   #:use-module (guix build-system gnu)
   #:use-module (ice-9 match)
   #:use-module (srfi srfi-26)
+  #:use-module (gnu packages check) ;; libfaketime
   #:export (%julia-build-system-modules
             julia-build
             julia-build-system))
@@ -68,6 +69,7 @@
                         ;; Keep the standard inputs of 'gnu-build-system'.
                         ,@(standard-packages)))
          (build-inputs `(("julia" ,julia)
+                         ("libfaketime" ,libfaketime)
                          ,@native-inputs))
          (outputs outputs)
          (build julia-build)
@@ -75,7 +77,7 @@
 
 (define* (julia-build store name inputs
                       #:key source
-                      (tests? #f)
+                      (tests? #t)
                       (phases '(@ (guix build julia-build-system)
                                   %standard-phases))
                       (outputs '("out"))
diff --git a/guix/build/julia-build-system.scm b/guix/build/julia-build-system.scm
index ff6fcf5fe3..bd4c64fa11 100644
--- a/guix/build/julia-build-system.scm
+++ b/guix/build/julia-build-system.scm
@@ -32,7 +32,13 @@
 ;; Code:
 
 (define (invoke-julia code)
-  (invoke "julia" "-e" code))
+  ;; Julia stores the result of the time() call
+  ;; inside the precompiled file. When trying to load it, its precompilation
+  ;; it fails at comparing the file mtime with the precompilation time,
+  ;; always triggering a recompile. This fixes the stored value.
+  ;; Also, libc.jl rand() uses time() as its seed. This might introduce indeterminism while building
+  ;; Default guix mtime is 1, so I'm setting the same here (if they differ, precompilation is invalid)
+  (invoke "faketime" "-f" "1970-01-01 00:00:01" "julia" "-e" code))
 
 ;; subpath where we store the package content
 (define %package-path "/share/julia/packages/")
@@ -78,13 +84,17 @@
     (invoke-julia (string-append "using " package)))
   #t)
 
-(define* (check #:key source inputs outputs #:allow-other-keys)
-  (let* ((out (assoc-ref outputs "out"))
-         (package (strip-store-file-name source))
-         (builddir (string-append out "/share/julia/")))
-    (setenv "JULIA_DEPOT_PATH" builddir)
-    (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
-    (invoke-julia (string-append "using Pkg;Pkg.test(\"" package "\")")))
+(define* (check #:key tests? source inputs outputs #:allow-other-keys)
+  (when tests?
+      (let* ((out (assoc-ref outputs "out"))
+             (package (strip-store-file-name source))
+             (builddir (string-append out "/share/julia/")))
+        (setenv "JULIA_DEPOT_PATH" builddir)
+        (setenv "JULIA_LOAD_PATH" (generate-load-path inputs outputs))
+        (display builddir)
+        (invoke "julia" (string-append builddir
+                                       "packages/"
+                                       package "/test/runtests.jl"))))
   #t)
 
 (define (julia-create-package-toml outputs source
@@ -119,7 +129,7 @@ version = \"" version "\"
     (delete 'check) ; tests must be run after installation
     (replace 'install install)
     (add-after 'install 'precompile precompile)
-    ;; (add-after 'install 'check check)
+    (add-after 'install 'check check)
     ;; TODO: In the future we could add a "system-image-generation" phase
     ;; where we use PackageCompiler.jl to speed up package loading times
     (delete 'configure)
-- 
2.24.0





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at 38546 <at> debbugs.gnu.org:


Received: (at 38546) by debbugs.gnu.org; 9 Dec 2019 14:00:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 09:00:43 2019
Received: from localhost ([127.0.0.1]:52797 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieJaR-0002we-OE
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:00:43 -0500
Received: from mail-wr1-f68.google.com ([209.85.221.68]:43562)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ieJaP-0002w9-Et
 for 38546 <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:00:30 -0500
Received: by mail-wr1-f68.google.com with SMTP id d16so16275824wre.10
 for <38546 <at> debbugs.gnu.org>; Mon, 09 Dec 2019 06:00:29 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=H7wc+w6tZQZL6th+Fvp0bJLzljuhSaRMH8S5/FfyG0M=;
 b=oDjZf64TAyn5e0+ZkBB6c+YApTKDKw0MYo4f0kmkZdb9kvTsz7NopJKEKPFFl5YVbh
 Q4bbItX6PPTsiYikARpuR+TXhR+gJNHO+IUjX6aULvBSlh/vMou6889FrnsLwo71NLel
 fovs7r/fyNG5J1QyCm1FeRWDliZVUIlnlYvvNLNQKHNPKTdFV0abfLfO7iW+t/lCukYh
 LupHFmDBU4E8FGjdqVp5dbY/gK8IBAVD7JnPdrboacWSthdp0B+dYcM1p3Q73dEJx4Px
 C1Ig36UQ7jgazMWjDs3K6+LuK8nqjn2f1K2E6yb74J/+q9QFpsS0rSOSU0TegNWxcmyu
 hlUA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=H7wc+w6tZQZL6th+Fvp0bJLzljuhSaRMH8S5/FfyG0M=;
 b=C2rT9/3G7T/vghqcwkPjU2AG+38e9BWqHlfd/vgNih90viYlLRU2ChUjG+LW7hcrtB
 Cq00J6r6Uh6ge8nHu9dmkin601I83Vitg8snOy26kTcoYDKrdowNMQHcBBqcHLdGD8wS
 NPw69lS79ddSYHZtDq8hs9BSrNl+4SEx6pcunG3W7snpxQwLMasxOpxGRNZhkD3L59Gt
 Vq/M0wFsKcwwPsgpu4txdER40rOhR+wS40QiiW0PUMTV6TwP9zoQzPj8ahzZo8LB7aY6
 UCGwrEK20/+lZ0sG+jDUO2MiZPgxmocouMOyAssFSSOzX8in/bwYMXytWew0Sq4AGO8R
 livQ==
X-Gm-Message-State: APjAAAXf3WLYoyIED7RfjHVVffKT+baoGqTcd+xiK2Hq5nmz1JoKwLhG
 M3DHGY54tErfDMyiJLihWBLFO+lnFws=
X-Google-Smtp-Source: APXvYqyG49gHGEmBDKk2oEcHRuaqK/I2Uej620LSzDoyUY2piDYiLb78jyJZi5YtmrAGo8rJ/WsLvg==
X-Received: by 2002:a5d:61cf:: with SMTP id q15mr2351346wrv.231.1575900022922; 
 Mon, 09 Dec 2019 06:00:22 -0800 (PST)
Received: from guixSD (host1-200-dynamic.5-87-r.retail.telecomitalia.it.
 [87.5.200.1])
 by smtp.gmail.com with ESMTPSA id s25sm13304054wmh.4.2019.12.09.06.00.22
 for <38546 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 09 Dec 2019 06:00:22 -0800 (PST)
From: =?UTF-8?q?Nicol=C3=B2=20Balzarotti?= <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: Guix Patches <38546 <at> debbugs.gnu.org>
Subject: [PATCH 1/3] gnu: julia: Set to JULIA_LOAD_PATH and JULIA_DEPOT_PATH
 variables.
Date: Thu, 10 Oct 2019 17:49:15 +0200
Message-ID: <87tv69vbt6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.1 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  gnu/packages/julia.scm | 146 +++++++++++++++++++++ 1 file
 changed, 75 insertions(+), 71 deletions(-) diff --git a/gnu/packages/julia.scm
 b/gnu/packages/julia.scm index 65a5e42beb..2516e7fa82 100644 ---
 a/gnu/packages/julia.scm
 +++ b/gnu/packages/julia.scm @@ -158,7 +158,7 @@ (define-public julia (pac
 [...] Content analysis details:   (2.1 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: libopenspecfun.so]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (anothersms[at]gmail.com)
 2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
 date
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.221.68 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.221.68 listed in wl.mailspike.net]
X-Debbugs-Envelope-To: 38546
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.1 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  gnu/packages/julia.scm | 146 +++++++++++++++++++++ 1 file
    changed, 75 insertions(+), 71 deletions(-) diff --git a/gnu/packages/julia.scm
    b/gnu/packages/julia.scm index 65a5e42beb..2516e7fa82 100644 --- a/gnu/packages/julia.scm
    +++ b/gnu/packages/julia.scm @@ -158,7 +158,7 @@ (define-public julia (pac
    [...] 
 
 Content analysis details:   (1.1 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: libopenblas.so]
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (anothersms[at]gmail.com)
  2.1 DATE_IN_PAST_96_XX     Date: is 96 hours or more before Received:
                             date
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

 gnu/packages/julia.scm | 146 +++++++++++++++++++++--------------------
 1 file changed, 75 insertions(+), 71 deletions(-)

diff --git a/gnu/packages/julia.scm b/gnu/packages/julia.scm
index 65a5e42beb..2516e7fa82 100644
--- a/gnu/packages/julia.scm
+++ b/gnu/packages/julia.scm
@@ -158,7 +158,7 @@
 (define-public julia
   (package
     (name "julia")
-    (version "1.1.1")
+    (version "1.1.1") ;; Update also JULIA_LOAD_PATH with it
     (source (origin
               (method url-fetch)
               (uri (string-append
@@ -229,77 +229,77 @@
            ;; Some tests require a home directory to be set.
            (lambda _ (setenv "HOME" "/tmp") #t))
          (add-after 'unpack 'hardcode-soname-map
-          ;; ./src/runtime_ccall.cpp creates a map from library names to paths
-          ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
-          ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
-          (lambda* (#:key inputs #:allow-other-keys)
-            (use-modules (ice-9 match))
-            (substitute* "src/runtime_ccall.cpp"
-              ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
-              ;; error messages about missing '/sbin/ldconfig' on Guix System.
-              (("popen\\(.*ldconfig.*\\);")
-               "NULL;\n")
+           ;; ./src/runtime_ccall.cpp creates a map from library names to paths
+           ;; using the output of "/sbin/ldconfig -p".  Since ldconfig is not
+           ;; used in Guix, we patch runtime_ccall.cpp to contain a static map.
+           (lambda* (#:key inputs #:allow-other-keys)
+             (use-modules (ice-9 match))
+             (substitute* "src/runtime_ccall.cpp"
+               ;; Patch out invocations of '/sbin/ldconfig' to avoid getting
+               ;; error messages about missing '/sbin/ldconfig' on Guix System.
+               (("popen\\(.*ldconfig.*\\);")
+                "NULL;\n")
 
-              ;; Populate 'sonameMap'.
-              (("jl_read_sonames.*;")
-               (string-join
-                (map (match-lambda
-                       ((input libname soname)
-                        (string-append
-                         "sonameMap[\"" libname "\"] = "
-                         "\"" (assoc-ref inputs input) "/lib/" soname "\";")))
-                     '(("libc"        "libc"           "libc.so.6")
-                       ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
-                       ("mpfr"        "libmpfr"        "libmpfr.so")
-                       ("openblas"    "libblas"        "libopenblas.so")
-                       ("arpack-ng"   "libarpack"      "libarpack.so")
-                       ("lapack"      "liblapack"      "liblapack.so")
-                       ("libgit2"     "libgit2"        "libgit2.so")
-                       ("gmp"         "libgmp"         "libgmp.so")
-                       ("openspecfun" "libopenspecfun" "libopenspecfun.so")
-                       ("fftw"        "libfftw3"       "libfftw3_threads.so")
-                       ("fftwf"       "libfftw3f"      "libfftw3f_threads.so"))))))
-            (substitute* "base/math.jl"
-              (("const libm = Base.libm_name")
-               (string-append "const libm = \""
-                              (assoc-ref inputs "openlibm")
-                              "/lib/libopenlibm.so"
-                              "\""))
-              (("const openspecfun = \"libopenspecfun\"")
-               (string-append "const openspecfun = \""
-                              (assoc-ref inputs "openspecfun")
-                              "/lib/libopenspecfun.so"
-                              "\"")))
-            #t))
+               ;; Populate 'sonameMap'.
+               (("jl_read_sonames.*;")
+                (string-join
+                 (map (match-lambda
+                        ((input libname soname)
+                         (string-append
+                          "sonameMap[\"" libname "\"] = "
+                          "\"" (assoc-ref inputs input) "/lib/" soname "\";")))
+                      '(("libc"        "libc"           "libc.so.6")
+                        ("pcre2"       "libpcre2-8"     "libpcre2-8.so")
+                        ("mpfr"        "libmpfr"        "libmpfr.so")
+                        ("openblas"    "libblas"        "libopenblas.so")
+                        ("arpack-ng"   "libarpack"      "libarpack.so")
+                        ("lapack"      "liblapack"      "liblapack.so")
+                        ("libgit2"     "libgit2"        "libgit2.so")
+                        ("gmp"         "libgmp"         "libgmp.so")
+                        ("openspecfun" "libopenspecfun" "libopenspecfun.so")
+                        ("fftw"        "libfftw3"       "libfftw3_threads.so")
+                        ("fftwf"       "libfftw3f"      "libfftw3f_threads.so"))))))
+             (substitute* "base/math.jl"
+               (("const libm = Base.libm_name")
+                (string-append "const libm = \""
+                               (assoc-ref inputs "openlibm")
+                               "/lib/libopenlibm.so"
+                               "\""))
+               (("const openspecfun = \"libopenspecfun\"")
+                (string-append "const openspecfun = \""
+                               (assoc-ref inputs "openspecfun")
+                               "/lib/libopenspecfun.so"
+                               "\"")))
+             #t))
          (add-before 'build 'fix-include-and-link-paths
-          (lambda* (#:key inputs #:allow-other-keys)
-            ;; LIBUTF8PROC is a linker flag, not a build target.  It is
-            ;; included in the LIBFILES_* variable which is used as a
-            ;; collection of build targets and a list of libraries to link
-            ;; against.
-            (substitute* "src/flisp/Makefile"
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(LIBFILES_release\\)")
-               "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
-              (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) \\$\\(LIBFILES_debug\\)")
-               "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
+           (lambda* (#:key inputs #:allow-other-keys)
+             ;; LIBUTF8PROC is a linker flag, not a build target.  It is
+             ;; included in the LIBFILES_* variable which is used as a
+             ;; collection of build targets and a list of libraries to link
+             ;; against.
+             (substitute* "src/flisp/Makefile"
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\): \\$\\(OBJS\\) \\$\\(LIBFILES_release\\)")
+                "$(BUILDDIR)/$(EXENAME): $(OBJS) $(LLT_release)")
+               (("\\$\\(BUILDDIR\\)/\\$\\(EXENAME\\)-debug: \\$\\(DOBJS\\) \\$\\(LIBFILES_debug\\)")
+                "$(BUILDDIR)/$(EXENAME)-debug: $(DOBJS) $(LLT_debug)"))
 
-            ;; The REPL must be linked with libuv.
-            (substitute* "ui/Makefile"
-              (("JLDFLAGS \\+= ")
-               (string-append "JLDFLAGS += "
-                              (assoc-ref %build-inputs "libuv")
-                              "/lib/libuv.so ")))
+             ;; The REPL must be linked with libuv.
+             (substitute* "ui/Makefile"
+               (("JLDFLAGS \\+= ")
+                (string-append "JLDFLAGS += "
+                               (assoc-ref %build-inputs "libuv")
+                               "/lib/libuv.so ")))
 
-            (substitute* "base/Makefile"
-              (("\\$\\(build_includedir\\)/uv/errno.h")
-               (string-append (assoc-ref inputs "libuv")
-                              "/include/uv/errno.h")))
-            #t))
+             (substitute* "base/Makefile"
+               (("\\$\\(build_includedir\\)/uv/errno.h")
+                (string-append (assoc-ref inputs "libuv")
+                               "/include/uv/errno.h")))
+             #t))
          (add-before 'build 'replace-default-shell
-          (lambda _
-            (substitute* "base/client.jl"
-              (("/bin/sh") (which "sh")))
-            #t))
+           (lambda _
+             (substitute* "base/client.jl"
+               (("/bin/sh") (which "sh")))
+             #t))
          (add-after 'unpack 'hardcode-paths
            (lambda _
              (substitute* "stdlib/InteractiveUtils/src/InteractiveUtils.jl"
@@ -345,9 +345,9 @@
            ;; platforms, e.g. when running "guix package --search="
            (_ "MARCH=UNSUPPORTED"))
 
-        "CONFIG_SHELL=bash"     ;needed to build bundled libraries
-        "USE_SYSTEM_DSFMT=0"    ;not packaged for Guix and upstream has no
-                                ;build system for a shared library.
+        "CONFIG_SHELL=bash"         ;needed to build bundled libraries
+        "USE_SYSTEM_DSFMT=0"        ;not packaged for Guix and upstream has no
+                                        ;build system for a shared library.
         "USE_SYSTEM_LAPACK=1"
         "USE_SYSTEM_BLAS=1"
         "USE_BLAS64=0"          ;needed when USE_SYSTEM_BLAS=1
@@ -485,7 +485,11 @@
     (native-search-paths
      (list (search-path-specification
             (variable "JULIA_LOAD_PATH")
-            (files (list "share/julia/packages/")))))
+            (files (list "share/julia/packages/"
+                         "share/julia/stdlib/v1.1/")))
+           (search-path-specification
+            (variable "JULIA_DEPOT_PATH")
+            (files (list "share/julia/")))))
     ;; Julia is not officially released for ARM and MIPS.
     ;; See https://github.com/JuliaLang/julia/issues/10639
     (supported-systems '("i686-linux" "x86_64-linux" "aarch64-linux"))
-- 
2.24.0





Information forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 9 Dec 2019 13:57:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 08:57:15 2019
Received: from localhost ([127.0.0.1]:52792 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieJXH-0002on-9V
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 08:57:15 -0500
Received: from lists.gnu.org ([209.51.188.17]:34535)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <anothersms@HIDDEN>) id 1ieJXF-0002of-9k
 for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 08:57:13 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:58340)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <anothersms@HIDDEN>) id 1ieJXD-00053I-MX
 for guix-patches@HIDDEN; Mon, 09 Dec 2019 08:57:13 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <anothersms@HIDDEN>) id 1ieJX7-0004aH-PZ
 for guix-patches@HIDDEN; Mon, 09 Dec 2019 08:57:11 -0500
Received: from mail-wm1-x32f.google.com ([2a00:1450:4864:20::32f]:36129)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <anothersms@HIDDEN>)
 id 1ieJX7-0004YP-GV
 for guix-patches@HIDDEN; Mon, 09 Dec 2019 08:57:05 -0500
Received: by mail-wm1-x32f.google.com with SMTP id p17so15036368wma.1
 for <guix-patches@HIDDEN>; Mon, 09 Dec 2019 05:57:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=lGHrLUtDMEjV0hsZdOmjjkn/NtRgJtMiKhpXKMoxN50=;
 b=AV7R9aaMKANFDfmR4zxeaDcH2ySVs8l7q/O8HcLTOM2InGaRJl1wd3vw226dw2VC0H
 4t6ROX1McNt0eUxiTpiyMxFGYxwL7MhWNwNPAg7SNmqG9Tx3Z1BEfdGUtdDfEOtdfqRu
 uyywx2zp2kGK54xsEYMNfhGdvNti59AZGk7XC904gqrIOd6N0blGd7fOlCkSunZQYGRD
 44k2zv1DTp4XpvQ826plSyE6nVKf3xRq1bw+Ilr4jmrYBPiJ1SQ67GhQaS+BAWQrqcgJ
 UuD9t38G35JN3G2tMGD9zdohLVPPJJNNfDYaouKr4AbMbEZsTIvd1FakHIwgDZJai5qJ
 ASPQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=lGHrLUtDMEjV0hsZdOmjjkn/NtRgJtMiKhpXKMoxN50=;
 b=UAPBE7G8A2UW+QIrDU6DaKsw+6tAWqBYb1wzEDHWr/GX2cKvLcCZMmMUiRiTlWBP9U
 7SQpmZQPAtfyyXjZ8w/8cSusMGFlswFnRRQ1db72LYUdjMOa8TYR7xMQBcfTmX0qdQ3d
 4TRxYwFEY5STUqUGWyIAa8jNgPNY6gJYQL1lL5/ug/dEb81qKP6MTCmXD2oxUbbfFjLe
 bbXbf3D4R59knGfBXfrWcEI1aMJP568ZlRZCFEsu1L4kW76fkyAmXEwV50r7crqRjAM5
 /lVaBL6VDs74qoZhnAvvgP93fxh40YzWiYZ6C/efXFI5sskD9RDqmHf9l7ts115esr8G
 ZrPA==
X-Gm-Message-State: APjAAAWAJvl0+DtLAJn8WLWvKRFRuFKQ4IY1AzQKzG/qI9RRsTtikwid
 vOA96v8ZBG5DhSZrGIp2cGyCUA8GAxc=
X-Google-Smtp-Source: APXvYqx90QIX2MzQpEJbwR2cJ51LNPsbHtLkvxUPjlM8ZcoHrO4NwopzIq5BP+0ADdaRUPbZ4gSkbg==
X-Received: by 2002:a05:600c:2c08:: with SMTP id
 q8mr8124791wmg.45.1575899822257; 
 Mon, 09 Dec 2019 05:57:02 -0800 (PST)
Received: from guixSD (host1-200-dynamic.5-87-r.retail.telecomitalia.it.
 [87.5.200.1])
 by smtp.gmail.com with ESMTPSA id e6sm26212882wru.44.2019.12.09.05.57.01
 for <guix-patches@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 09 Dec 2019 05:57:01 -0800 (PST)
From: nixo <anothersms@HIDDEN>
X-Google-Original-From: nixo <nicolo@HIDDEN>
To: Guix Patches <guix-patches@HIDDEN>
Subject: [PATCH 0/3] Julia: fix package build and add julia-xyz
Date: Mon, 9 Dec 2019 14:36:25 +0100
Message-ID: <87v9qpvbyr.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::32f
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


Hello Guix!

Changes:

This set of patches improve the state of julia-build-system.

1. set path JULIA_LOAD_PATH to enable installing packages, and
  JULIA_DEPOT_PATH to allow guix-precompiled cache to be recognized by julia. To
  do this, a small "hack" with libfaketime was required (julia decides if the
  cache is valid by comparing source ".jl" mtime with cache ".ji" file, in which
  julia stores a timestamp. We need to force this timestamp to be equal to the
  mtime of guix-store files).
2. Enable package tests
3. Add a first package (julia-compat) definition. If this is fine, I'll start
   pushing many many more (I have them ready, but I need to update many of them)



 Thanks! :)

One note: with this PATH changes, julia will not be able to find packages
installed by Julia Pkg3.jl anymore. This is expected (it should happen for R,
python, emacs... too) but since we still need to merge the packages, this
patch renders julia pretty unusable. The workaround is for users to add to
JULIA_LOAD_PATH and JULIA_LOAD_PATH local user-writable folders, activate a
profile, and then install packages manually:

#+begin_src bash
   JULIA_LOAD_PATH=/tmp/julia:$JULIA_LOAD_PATH JULIA_DEPOT_PATH=/tmp/julia:$JULIA_DEPOT_PATH julia
#+end_src

nixo (3):
 gnu: julia: Set to JULIA_LOAD_PATH and JULIA_DEPOT_PATH variables.
 gnu: julia-build-system: Enable tests.
 gnu: julia-xyz: Add julia-compat.

#+begin_src julia
   using Pkg
   Pkg.activate("/tmp/julia")
   Pkg.add("PACKAGE_NAME")
#+end_src

-- 
2.24.0

gnu/packages/julia-xyz.scm        |  62 +++++++++++++
gnu/packages/julia.scm            | 146 +++++++++++++++---------------
guix/build-system/julia.scm       |   4 +-
guix/build/julia-build-system.scm |  28 ++++--
4 files changed, 159 insertions(+), 81 deletions(-)
create mode 100644 gnu/packages/julia-xyz.scm





Acknowledgement sent to nixo <anothersms@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#38546; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 11 Feb 2020 17:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.